#include  <stdio.h>

#define	error(f)	fprintf(stderr, f)
#define	error1(f,a1)	fprintf(stderr, f, a1)
#define	RD	0
#define	WR	1
#define TIMEOUT	0x3FFF

main()
{
	register int	pid, rval, fd, pass;
	int		p[2], gc, i;
	char		c, buff[512];

	if (pipe(p) < 0) {
		error("pipetst:  pipe failed; ");
		perror("");
	}

	pid = fork();
	if (pid < 0) {
		error("pipetst:  fork failed; ");
		perror("");
		exit(1);
	}

	if (pid == 0) {		/* We're the child */
		close(p[RD]);		/* We WRITE to the pipe Mom made */
		fd = p[WR];

		for (i = 0; i < sizeof(buff); ++i)
			buff[i] = 'x';

		error("child:  Start...\n");
		for (i = 1; i <= 20; ++i) {
			if (write(fd, buff, sizeof(buff)) < 0) {
				error("child:  write failed; ");
				perror("");
				close(fd);
				exit(1);
			}
		}

		close(fd);
		error("child:  Done.\n");
		exit(0);
	}

	close(p[WR]);			/* We READ data from the child */
	fd = p[RD];
	i = pass = 0;

	for ( ; ; ) {
		rval = rdchk(fd);
		if (rval > 0) {
			i = 1;
			pass = 0;
			rval = read(fd, buff, sizeof(buff));
			if (rval == sizeof(buff))
				continue;
			else if (rval < 0) {
				error("pipetst:  read failed; ");
				perror("");
				close(fd);
				exit(1);
			}
			else if (rval == 0) {
				error("pipetst:  EOF encountered.");
				error("  End of test.\n");
				close(fd);
				exit(0);
			}
			else {
				error1("pipetst:  insane read %d\n", rval);
				continue;
			}
		}
		if (rval < 0) {
			error("pipetst:  rdchk failed; ");
			perror("");
			close(fd);
			exit(1);
		}

		/* Well, rval must == 0  and so there's nothing to read */
		if (i && ++pass > TIMEOUT) {
			error("pipetst:  TIMEOUT waiting for child\n");
			close(fd);
			exit(1);
		}
	}
}
