/*
 *	%Z% %M% %I% %D% %Q%
 *
 *	Copyright (C) Microsoft Corporation, 1983
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 */
/***	dmesg -- suck up system messages
 *
 *	MODIFICATION HISTORY
 *	M000	27 Oct 83	andyp
 *	- Added some error checks.
 */

#include <stdio.h>
#include <sys/param.h>
#include <sys/z80msgbuf.h>
#include <a.out.h>

int	sflg = 0, rflg = 0;
int	of = -1;

struct zm_iopb	msgs;
struct zm_iopb	omsgs = { 0, 0, 0 };
struct zm_dkbuf dkmsgs;


struct nlist nl[] = {
	{ "_z80msgb" },
	{ "" }
};

char	Pnkernel[]	= "/xenix";
char	Pnmem[]		= "/dev/mem";
char	Pnmsg[]		= "/usr/adm/msgbuf";
char	Pnrecover[]	= "/dev/hdbt0";

main(argc, argv)
char **argv;
{
	register char	*mp, *omp, *mstart;
	register struct zm_iopb	*zmp, *ozmp;
	int		mem, samef, magic;
	char		*mfront;

	if (argc > 1 && argv[1][0] == '-') {
		++sflg;
		if (argv[1][1] == 'r')
			++rflg;
		argc--;
		argv++;
	}

	if (sflg) {
		if ((of = open(Pnmsg, 2)) == -1)
			done("dmesg: No msgbuf\n");

		read(of, (char *)&omsgs, sizeof (omsgs));
		lseek(of, 0L, 0);
	}

	if (!rflg) {
		nlist(argc>2? argv[2]:Pnkernel, nl);
		if (nl[0].n_type==0)
			done("dmesg: No namelist\n");
		if ((mem = open((argc>1? argv[1]: Pnmem), 0)) < 0)
			done("dmesg: No mem\n");

		lseek(mem, (long)nl[0].n_value, 0);
		read(mem, (char *)&msgs, sizeof (msgs));
	}
	else {
		if ((mem = open(Pnrecover, 2)) == -1)
			done("dmesg: No recover\n");

		lseek(mem, (long)(16 * BSIZE), 0);
		read(mem, (char *)&dkmsgs, sizeof (dkmsgs));
		magic = dkmsgs.magic;
		if (magic == ZMMAGIC) {
			zmp = &msgs;
			zmp->zm_front = 0;
			zmp->zm_back = 0;
			zmp->zm_6front = dkmsgs.msgbufi;
			bcopy(dkmsgs.mbuf, zmp->zm_68k, sizeof (zmp->zm_68k));
		}

		dkmsgs.magic = 0;		/* Mark invalid */
		lseek(mem, (long)16 * BSIZE, 0);
		write(mem, (char *)&dkmsgs, sizeof (dkmsgs));

		close(mem);

		if (magic != ZMMAGIC)
			exit(0);
	}
	sflg = 0;

	zmp = &msgs;
	ozmp = &omsgs;

	if (zmp->zm_6front >= MSGBUFS || zmp->zm_6front < 0
	    || zmp->zm_back > ZMQSIZE || zmp->zm_front > ZMQSIZE)
	{
		done("dmesg: Namelist mismatch\n");
	}

	mfront = mp = &zmp->zm_68k[zmp->zm_6front];
	omp = &ozmp->zm_68k[zmp->zm_6front];
	mstart = &zmp->zm_68k[ozmp->zm_6front];
	samef = 1;
	do {
		if (*mp++ != *omp++) {
			mstart = mfront;
			samef = 0;
			pdate();
			printf("...\n");
			break;
		}
		if (mp == &zmp->zm_68k[MSGBUFS])
			mp = zmp->zm_68k;
		if (omp == &ozmp->zm_68k[MSGBUFS])
			omp = ozmp->zm_68k;
	} while (mp != mstart);
	if (samef && mstart == mfront)
		exit(0);

	mp = mstart;
	do {
		pdate();
		if (*mp && *mp != '\r')
			putchar(*mp);
		mp++;
		if (mp == &zmp->zm_68k[MSGBUFS])
			mp = zmp->zm_68k;
	} while (mp != mfront);
	done((char *)NULL);
}

done(s)
char *s;
{
	register char *p, *q;

	if (s && sflg==0) {
		pdate();
		printf(s);
	}
	write(of, (char *)&msgs, sizeof (msgs));
	exit(s!=NULL);
}

pdate()
{
	extern char *ctime();
	static firstime;
	time_t tbuf;

	if (firstime==0) {
		firstime++;
		time(&tbuf);
		printf("\n%.12s\n", ctime(&tbuf)+4);
	}
}

bcopy(from, to, size)
  register char	*from, *to;
  register int	size;
{
	while (size--)
		*to++ = *from++;
}
