/*
 *  "gload.c"  -  Load a graphics image
 *
 *	John Elliott IV		08/25/1986
 */

#include  <sys/ioctl.h>
#include  <sys/graphics.h>

extern int	errno;


char	screen[] = "/dev/graphics";
char	cantopen[] = "Can't open ";


char	buff[80][240];
char	*myname;


main(argc, argv)
  int	argc;
  char	**argv;
{
	register int	ifd, ofd, rval;
	int		mask;

	myname = *argv++; --argc;

	ifd = open(*argv, 0);
	if (ifd < 0) {
		write(2, cantopen, sizeof(cantopen));
		perror(*argv);
		exit(1);
	}
	rval = read(ifd, buff, sizeof (buff));
	if (rval != sizeof (buff)) {
		printf("%s: Can't load image, wanted %d got %d; ", 
					myname,
					sizeof (buff),
					rval);
		perror("");
	}
	close(ifd);

	ofd = open(screen, 2);
	if (ofd < 0) {
		write(2, cantopen, sizeof(cantopen));
		perror(screen);
		exit(1);
	}

	mask = (GR_ENABLE|GR_WAITS);
	if (ioctl(ofd, GIOCCBIC, &mask) < 0) {
		perror("Can't alter control word");
		exit(1);
	}

	errno = 0;
	rval = write(ofd, buff, sizeof (buff));
	if (rval != sizeof (buff)) {
		printf("%s: Can't write image, wanted %d got %d; ", 
					myname,
					sizeof (buff),
					rval);
		perror("");
	}

	if (ioctl(ofd, GIOCCBIS, &mask) < 0) {
		perror("Can't alter control word");
		exit(1);
	}

	if (close(ofd) != 0) {
		perror("Close failed");
		exit(1);
	}

	exit(0);
}
