/*
 *  "gtest.c"  -  Write a test pattern to the graphics board
 *
 *	John Elliott IV		08/25/1986
 */

#include  <sys/ioctl.h>
#include  <sys/graphics.h>

extern int	errno;


char	screen[] = "/dev/graphics";
char	cantopen[] = "Can't open ";


char	buff0[80], buff1[80];
char	*myname;


main(argc, argv)
  int	argc;
  char	**argv;
{
	register int	fd, i;
	register char	*cp;
	int		arg;

	myname = *argv;

	fd = open(screen, 2);
	if (fd < 0) {
		write(2, cantopen, sizeof(cantopen));
		perror(screen);
		exit(1);
	}

	for (cp = buff0; cp < &buff0[80]; ++cp)
		*cp = (char)0xF0;

	for (cp = buff1; cp < &buff1[80]; ++cp)
		*cp = (char)0x0F;

	arg = GR_W_ASYNC;
	if (ioctl(fd, GIOCCBIS, &arg) < 0)
		perror("Can't set GR_W_ASYNC");

	for (i = 0; i < 120; ++i) {
		gwrite(fd, buff0, 80);
		gwrite(fd, buff1, 80);
	}

	close(fd);
}

gwrite(fd, buff, size)
  int	fd;
  char	*buff;
  int	size;
{
	register int	rval;

	rval = write(fd, buff, size);
	if (rval != size) {
		printf("%s write error: wanted %d, got %d; ", 
					myname,
					sizeof (buff),
					rval);
		perror("");
	}
}
