/*
 *  "stars.c"  -  YAGTP (Yet Another Graphics Test Program)
 *
 *	John Elliott IV		09/25/1986
 */

#include  <stdio.h>
#include  <signal.h>
#include  <sys/ioctl.h>
#include  <sys/graphics.h>

#define	RND(int)	((rand() >> 4) % int)

int	quit();

char	screen[] = "/dev/graphics";
char	cantopen[] = "Can't open ";

char	sbuff[240][80];
char	*myname;
int	screen_fd;

main(argc, argv)
  char	**argv;
{
	register int	x, y, c;
	int		async = 0;
	int		ctlwrd;		/* Can't be register */

	myname = *argv++; --argc;
	if (argc > 1)
		++async;

	screen_fd = open(screen, 1);
	if (screen_fd < 0) {
		write(2, cantopen, sizeof(cantopen));
		perror(screen);
		exit(1);
	}

	/* Clear the screen */
	ctlwrd = (GR_ENABLE|GR_WAITS);
	if (ioctl(screen_fd, GIOCCBIC, &ctlwrd) < 0) {
		perror("Can't clear control bits");
		exit(1);
	}
	gwrite(screen_fd, sbuff, sizeof (sbuff));	/* Clear it */

	/* Set some crunchy options */
	ctlwrd = (GR_ENABLE|GR_WAITS);
	if (async)
		ctlwrd |= GR_W_ASYNC;
	if (ioctl(screen_fd, GIOCCBIS, &ctlwrd) < 0) {
		perror("Can't set control bits");
		exit(1);
	}
	if (ioctl(screen_fd, TIOCNXCL, 0) < 0) {
		perror("Can't set NXCL");
		exit(1);
	}

	signal(SIGINT, quit);
	signal(SIGTERM, quit);

	/* Get going... */
	fprintf(stderr, "Rc");	/* Clear text & turn cursor OFF */
	srand((unsigned)time((long *)0));
	for ( ; ; ) {
		x = RND(640);
		y = RND(240);
		c = RND(100)? 0 : 1;
		write_pixel(x, y, c);
	}
	/*NOTREACHED*/
}

quit()
{
	int	ctlwrd;

	ctlwrd = GR_ENABLE;			/* Turn graphics off */
	if (ioctl(screen_fd, GIOCCBIC, &ctlwrd) < 0)
		perror("Can't clear control bit");

	close(screen_fd);
	fprintf(stderr, "RC");		/* Turn cursor ON */
	exit(0);
}

write_pixel(x, y, c)
  int	x, y, c;
{
	register char	mask;
	register long	seek;

	mask = 1 << (7 - (x&7));
	if (c)
		sbuff[y][x/8] |= mask;
	else
		sbuff[y][x/8] &= ~mask;

	seek = (y * 80) + (x / 8);
	lseek(screen_fd, seek, 0);
	/* Can't check return value in ASYNC mode */
	write(screen_fd, &sbuff[y][x], 1);
}

gwrite(fd, buff, n)
  int	fd;
  char	*buff;
  int	n;
{
	int	rval;

	rval = write(fd, buff, n);
	if (rval != n) {
		fprintf(stderr, "%s write error: wanted %d, got %d; ", 
						myname,
						n,
						rval);
		perror("");
	}
}
