/*
 * @(#) ke/syscalls/shdata.c 1.1 83/10/01 Copyright Microsoft Corporation, 1983
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 */


/*
 * shdata -- test shared data.  Late addition.
 */

#include <stdio.h>
#include <sys/sd.h>

#define NCELLS 100
#define eprintf	printf


struct seg {
	int flag;
	int ar[NCELLS];
};


char *sdget();


main()
{
	int pid;

	if ((pid = fork()) == 0)
		exit(shdrdr());

	shdwtr();
	while(wait((int *)0) != pid)
		;
	
	printf("main:  test completed.\n");
}




shdrdr()
{
	register char *addr;
	register struct seg *sp;
	register int v, i, ver;

	for (i = 0; i < 10; i++) {
		addr = sdget("/tmp/sd", SD_WRITE);
		if (addr != (char *) -1) {
			break;
		}
		sleep(5);
	}
	if (addr == (char *) -1) {
		perror("shdata_reader");
		printf("shdrdr:  reader can't sdget\n");
		return;
	}

	printf("shdrdr:  sd address is 0x%lx\n", addr);
	sp = (struct seg *) addr;
	for (v = 0; v < 255; v++) {
		ver = sdgetv(addr);
		printf("\nshdrdr:  Pass %d; version is %d\n", v, ver);

		while (sp->flag == 0) {
			ver = sdwaitv(addr, ver);
			printf("shdrdr:  Awakened, sp->flag is %d\n", sp->flag);
		}

		sdenter(addr, SD_RDONLY);
		for (i = 0; i < NCELLS; i++) {
			if (sp->ar[i] != v) {
				printf("shdrdr:  wrong shared value @ %d\n", i);
			}
		}
		sdleave(addr);

		sdenter(addr, SD_WRITE);
		sp->flag = 0;
		sdleave(addr);
	}
}




shdwtr()
{
	register char *addr;
	register struct seg *sp;
	register int v, i, ver;

	addr = sdget("/tmp/sd", SD_CREAT|SD_WRITE, sizeof(struct seg), 0666);
	if (addr == (char *) -1) {
		perror("shdata_writer");
		printf("shdrdr:  reader can't sdget\n");
		return;
	}

	printf("shdwtr:  sd address is 0x%lx\n", addr);
	sp = (struct seg *) addr;
	for( v = 0; v < 255; v++) {
		sdenter(addr, SD_WRITE);
		for (i = 0; i < NCELLS; i++) {
			sp->ar[i] = v;
		}
		sp->flag = 1;
		sdleave(addr);

		ver = sdgetv(addr);
		printf("\nshdwtr:  Pass %d; version is %d\n", v, ver);
		while (sp->flag == 1) {
			ver = sdwaitv(addr, ver);
			printf("shdwtr:  Awakened, sp->flag is %d\n", sp->flag);
		}
	}
}
