   1                             |***	Startup for XENIX
   2                             |***	
   3                             |***	Create the environment for a call to main and upon return start
   4                             |***	the initial user process.
   5                             |***
   6                             |***	Originally written by Jerry J. Dunietz, Microsoft Corp.; January 1983
   7                             |***	Maintained locally by John A. Elliott IV
   8                             |***	Copyright (c) Tandy Corporation, 1986, 1987
   9                             |***
  10                             |***	Assembly Language Assist Routines
  11                             |***   
  12                             |***	===========================================================
  13                             |***   
  14                             |***	Tandy Radio Shack Model 16
  15                             |***   
  16                             |***	The hardware provides no relocation in supervisor mode (!!).
  17                             |***	For initial development, we reserve an area in which the currently
  18                             |***	active U and stack manipulated.  Whenever a save is done, we copy
  19                             |***	the currently active U and stack back to where they belong; whenever
  20                             |***	a resume is done, the newly selected U and stack are copied into 
  21                             |***	the active area.
  22                             |***
  23                             |***	The memory management in user mode supports two segments;
  24                             |***	one starts at location 0, the other at hex 800000.
  25                             |***	Segments can be any multiple of 4Kbytes in size.  They are
  26                             |***	defined by set of offset registers and a set of limit registers.
  27                             |***
  28                             |***	All I/O is done thru the auxiliary Z80 processor.  The 68000
  29                             |***	informs the Z80 of the start of their communications buffers
  30                             |***	by loading this address into location 4.  The Z80 initializes 
  31                             |***	them and resets the contents of location 4 back to its original 
  32                             |***	value.  This informs the 68000 to proceed.
  33                             |***
  34                             |*** ========================================================================
  35                             |***  Modification record:
  36                             |***
  37                             |***   $Log:	mch.S,v $
  38                             |***   Revision 6.2  88/08/17  15:25:18  root
  39                             |***   	- Changed all DEBUG putchar() calls to _putcha()
  40                             |***   	  [so it won't get put in the output buffer]
  41                             |***   
  42                             |***   Revision 6.1  88/04/05  11:16:38  iv
  43                             |***   	- Added MC68010 conditional support
  44                             |***   	- Added DEBUG code for startup under conditional DEBUGS
  45                             |***   	- Changed kernel-debugger conditional to KDEBUG
  46                             |***   
  47                             |***   Revision 6.0  87/10/12  17:00:10  iv
  48                             |***   	- Checkin to lock down 3.2
  49                             |***   
  50                             |***   Revision 5.6  86/10/16  15:17:28  iv
  51                             |***   	- Replaced `movb's with `moveq's in _spl? calls
  52                             |***   	- Renamed bufinit() to cfginit()  [now handles more than buffers]
  53                             |***   
  54                             |***   Revision 5.5  86/10/01  16:59:37  iv
  55                             |***   	- Re-arranged startup code to support auto-configurable buffers
  56                             |***   	  (and maybe other things later!)
  57                             |***   
  58                             |***   Revision 5.4  86/08/28  17:22:14  iv
  59                             |***   	- Changed mmu-related code to support extra 3 bits of resolution
  60                             |***   	  (see mmu.h and mmu.c comments and change log)
  61                             |***   
  62                             |***   Revision 5.3  86/07/10  15:24:07  iv
  63                             |***   	- Cleaned up some of the RCS revsion comments
  64                             |***   	- Prettied up some of the code comments
  65                             |***   	- Changed copyright message to Tandy, 1986 [we've changed AT LEAST 10%]
  66                             |***   	- Added new 1 conditional, compiles in fast-system-call handling
  67                             |***   	  code.  Trimmed ~2 seconds off of our system call benchmark!
  68                             |***   	- Moved z80 mailboxes into mch.S, especially for Mr. Bob Snapp
  69                             |***   	  who likes patching our code to death
  70                             |***   	- Rewrote spl code & saved 4 clocks there & shortened local calls to it
  71                             |***   
  72                             |***   Revision 5.2  86/06/12  11:39:30  iv
  73                             |***   	- Added support code for auto-boot
  74                             |***   
  75                             |***   Revision 5.1  86/05/21  21:12:55  iv
  76                             |***   	- Converted the awful, awful, ea syntax that mch.s was written in
  77                             |***   	  to the one everyone else in the world uses.  Much more readable.
  78                             |***   
  79                             |***   Revision 5.0  85/08/23  10:00:48  iv
  80                             |***   	- Checkin to lock down XENIX 3.1 release
  81                             |***   
  82                             |***   Revision 5.0  85/08/23  09:56:21  iv
  83                             |***   	- Checkin to lock down XENIX 3.1 release
  84                             |***   
  85                             |***   Revision 4.2  85/08/22  16:06:14  iv
  86                             |***   	- Changed memory size code to lie and say 1 Meg if the actual
  87                             |***   	  main memory is really > 1 Meg, because the MMU can't handle
  88                             |***   	  addresses that are > 1 Meg.  *sigh*
  89                             |***   
  90                             |***   Revision 4.1  85/03/29  09:57:47  iv
  91                             |***    - Removed the Z80 interrupt ID array; it is not used
  92                             |***   
  93                             |***   Revision 4.0  85/03/13  14:38:03  iv
  94                             |***   	- Checkin to lock down XENIX 3.0(28) release
  95                             |***   
  96                             |***   Revision 3.0  85/01/17  15:37:59  iv
  97                             |***   	- Checkin to save XENIX v3.0(23)
  98                             |***   
  99                             |***   Revision 2.0  85/01/10  14:05:14  iv
 100                             |***   	- Checkin to save XENIX 3.0(22)
 101                             |***   
 102                             |***   Revision 1.5  84/12/21  15:58:10  iv
 103                             |***   	- Changed call to "clock()" to call to "rclock()", which gives
 104                             |***   	  clock() the arguments it expects
 105                             |***   	- Corrected misc typos (in comments and such)
 106                             |***   	- Added "_tasktime" as an alias for "_spl0"
 107                             |***   	- Added "_bcopy" entry for "copybuf"
 108                             |***   
 109                             |***   Revision 1.4  84/04/18  10:20:11  iv
 110                             |***   	- Fixed up some RCS comment leader errors, I forgot to set
 111                             |***   	  the comment header with 'rcs -c' before I checked in.
 112                             |***   
 113                             |***   Revision 1.3  84/04/18  10:12:52  iv
 114                             |***	- Changed "idleflg" to "Idlef", per sys/clock.c
 115                             |***
 116                             |*** ------------------------------------------------------------------------
 117                             |***	M000	07 Jul 1983	jeIV  (Tandy)
 118                             |***		- Added z80 interrupt routine and request fifo initialization
 119                             |***
 120                             |***	M001	19 Sep 1983	jeIV  (Tandy)
 121                             |***		- Added C interface to "umap" routine so drivers can hand
 122                             |***		  PHYSICAL user addresses to z80 for "DMA" z80 style
 123                             |***		- Added initialization of z80 interrupt ID mask
 124                             |***
 125                             |***	M002	01 Feb 1984	jeIV  (Tandy)
 126                             |***		- Added support for z80 notification of system shutdown
 127                             |***		  [done at haltcpu].  Added code to initalize shutdown enable
 128                             |***		  byte "z80halt" to a safe value.
 129                             |***
 130                             |*** ========================================================================
 131                             
 132                             	.data
 133  0f44  436f 7079 7269 6768  	.asciz	"Copyright 1987 Tandy Corporation\n"
            7420 3139 3837 2054 616e 6479 2043 6f72 706f 7261 7469 6f6e 0a00
 134  0f66                       	.even
 135                             	.text
 136                             
 137                             USRSTART= /000000	| User Virtual Addr of First Execable Code
 138                             
 139                             USIZE		=	/1000	| size of U structure
 140                             UMASK		=	/fff
 141                             PAGESIZE	=	/1000	| size of 1 page
 142                             PAGESHIFT	=	12	| shift required
 143                             SHIFT1		=	8	| fragments of PAGESHIFT
 144                             SHIFT2		=	4	|	for use in shift instructions
 145                             
 146                             INTDATA		= 0x7800d0	| interrupt controller data register
 147                             INTCOMMAND	= 0x7800d1	| interrupt controller command register
 148                             
 149                             CLRINT		= /60		| clear interrupt command
 150                             MASKWRITE	= /b0		| next data write is new mask register
 151                             MASKREAD	= /a4		| condition for reading mask register
 152                             INTPROGRAM	= /ffffffe0	| command to program first int with 1 byte
 153                             INTARM		= /a5		| arm the chip (and set for reading of mask)
 154                             INTRESET	= /00		| reset the interrupt controller
 155                             ISRREAD		= /a0		| condition reading interrupt service register
 156                             
 157                             MMU_BASE	= 0x7800d2	| base of MMU registers
 158                             MMU_HILIM	= 0x7800d2	| 	limit register, hi segment
 159                             MMU_HIOFF	= 0x7800d3	|	offset register, hi segment
 160                             MMU_LOLIM	= 0x7800d4	|	limit register, lo segment
 161                             MMU_LOOFF	= 0x7800d5	|	offset register, lo segment
 162                             
 163                             Z80IADDR	= /7800d6	| M000  z80 interrupt latch
 164                             
 165                             
 166                             |***
 167                             |***	We must set up software copies of the MMU registers...
 168                             |***
 169                             |***	     WARNING:	mmu.c *depends* on and uses the fact that
 170                             |***			_mmuHiOff follows _mmuHiLim and that
 171                             |***			_mmuLoOff follows _mmuLoLim.
 172                             |***
 173                             |***		[See the code and comments for mmusub() in mmu.c]
 174                             |***
 175                             	.data
 176                             	.globl	_mmuHiLim, _mmuHiOff, _mmuLoLim, _mmuLoOff
 177                             mmuhi:
 178                             _mmuHiLim:
 179  0f66  0000                 	.word	0
 180                             _mmuHiOff:
 181  0f68  0000                 	.word	0
 182                             
 183                             mmulo:
 184                             _mmuLoLim:
 185  0f6a  0000                 	.word	0
 186                             _mmuLoOff:
 187  0f6c  0000                 	.word	0
 188                             
 189                             	.text
 190                             
 191                             |***
 192                             |***	Because a TIMERRI (bus timeout while 68000 is bus master) or ADERR
 193                             |***	ADERR (user MMU fault) interrupt would also generate a bus error,
 194                             |***	these are always masked off.
 195                             |***	Under no circumstances should the kernel ever get a TIMERRE (bus
 196                             |***	timeout while 68000 is *not* bus master) interrupt; therefore this
 197                             |***	mask bit is used to differentiate between MASK1 and MASK0.
 198                             |***
 199                             |***	MASK7-4 use negative numbers so that we can use a `moveq' in _spl
 200                             |***
 201                             MASK7	= -1	|/ff		| no ints enabled
 202                             MASK6	= -1	|/ff		| level six must disable clock; same as MASK7
 203                             MASK5	= -2	|/fe		| allow highest pri int only (clock)
 204                             MASK4   = -4	|/fc		| allow clock and disk
 205                             MASK1	= 	/38		| lowest pri which does not enable all ints
 206                             MASK0	= 	/18		| all ints enabled
 207                             
 208                             |SPL7	= /2700		| status reg value disable all interupts, super mode
 209                             |SPL6	= /2600		| level 6
 210                             |SPL5	= /2500		| level 5
 211                             |SPL4	= /2400		| level 4
 212                             |SPL3	= /2300		| level 3
 213                             |SPL2	= /2200		| level 2
 214                             |SPL1	= /2100		| level 1
 215                             |SPL0	= /2000		| level 0
 216                             
 217                             SSTATE	= /2000		| supervisor state bit
 218                             SBIT	= 13		| supervisor state bit of status register
 219                             TBIT	= 15		| trace bit of status register
 220                             NOINTR	= /2700		| no interrupts
 221                             TRACE	= /8000		| trace mode bit
 222                             
 223                             |***
 224                             |***	Location 0	Interrupt and Trap Vectors
 225                             |***
 226                             zero:
 227  0000  0000 0100            	.long	_end+0x100	| Initial SSP (FIX ME BUG)
 228  0004  0000 0830            	.long	start		| Initial PC
 229                             
 230  0008  0000 0a98            	.long	_buserr		| vector   2	BUS ERROR
 231  000c  0000 0aca            	.long	_adrerr		| vector   3	ADDRESS ERROR
 232  0010  0000 06e0            	.long	encode+16	| vector   4
 233  0014  0000 06e4            	.long	encode+20	| vector   5
 234  0018  0000 06e8            	.long	encode+24	| vector   6
 235  001c  0000 06ec            	.long	encode+28	| vector   7
 236  0020  0000 06f0            	.long	encode+32	| vector   8
 237  0024  0000 06f4            	.long	encode+36	| vector   9
 238  0028  0000 06f8            	.long	encode+40	| vector  10
 239  002c  0000 06fc            	.long	encode+44	| vector  11
 240  0030  0000 0700            	.long	encode+48	| vector  12
 241  0034  0000 0704            	.long	encode+52	| vector  13
 242  0038  0000 0708            	.long	encode+56	| vector  14
 243  003c  0000 070c            	.long	encode+60	| vector  15
 244  0040  0000 0710            	.long	encode+64	| vector  16
 245  0044  0000 0714            	.long	encode+68	| vector  17
 246  0048  0000 0718            	.long	encode+72	| vector  18
 247  004c  0000 071c            	.long	encode+76	| vector  19
 248  0050  0000 0720            	.long	encode+80	| vector  20
 249  0054  0000 0724            	.long	encode+84	| vector  21
 250  0058  0000 0728            	.long	encode+88	| vector  22
 251  005c  0000 072c            	.long	encode+92	| vector  23
 252  0060  0000 0730            	.long	encode+96	| vector  24
 253  0064  0000 0734            	.long	encode+100	| vector  25
 254  0068  0000 0738            	.long	encode+104	| vector  26
 255  006c  0000 073c            	.long	encode+108	| vector  27
 256  0070  0000 0740            	.long	encode+112	| vector  28
 257  0074  0000 0744            	.long	encode+116	| vector  29
 258  0078  0000 0748            	.long	encode+120	| vector  30
 259                             
 260  007c  0000 0a8a            	.long	nmi		| vector  31
 261                             
 262  0080  0000 09d2            	.long	do_scall	| vector  32	trap #0 -- System call
 263                             
 264                             
 265  0084  0000 0754            	.long	encode+132	| vector  33
 266  0088  0000 0758            	.long	encode+136	| vector  34
 267  008c  0000 075c            	.long	encode+140	| vector  35
 268  0090  0000 0760            	.long	encode+144	| vector  36
 269  0094  0000 0764            	.long	encode+148	| vector  37
 270  0098  0000 0768            	.long	encode+152	| vector  38
 271  009c  0000 076c            	.long	encode+156	| vector  39
 272  00a0  0000 0770            	.long	encode+160	| vector  40
 273  00a4  0000 0774            	.long	encode+164	| vector  41
 274  00a8  0000 0778            	.long	encode+168	| vector  42
 275  00ac  0000 077c            	.long	encode+172	| vector  43
 276  00b0  0000 0780            	.long	encode+176	| vector  44
 277  00b4  0000 0784            	.long	encode+180	| vector  45
 278  00b8  0000 0788            	.long	encode+184	| vector  46
 279  00bc  0000 078c            	.long	encode+188	| vector  47
 280  00c0  0000 0790            	.long	encode+192	| vector  48
 281  00c4  0000 0794            	.long	encode+196	| vector  49
 282  00c8  0000 0798            	.long	encode+200	| vector  50
 283  00cc  0000 079c            	.long	encode+204	| vector  51
 284  00d0  0000 07a0            	.long	encode+208	| vector  52
 285  00d4  0000 07a4            	.long	encode+212	| vector  53
 286  00d8  0000 07a8            	.long	encode+216	| vector  54
 287  00dc  0000 07ac            	.long	encode+220	| vector  55
 288  00e0  0000 07b0            	.long	encode+224	| vector  56
 289  00e4  0000 07b4            	.long	encode+228	| vector  57
 290  00e8  0000 07b8            	.long	encode+232	| vector  58
 291  00ec  0000 07bc            	.long	encode+236	| vector  59
 292  00f0  0000 07c0            	.long	encode+240	| vector  60
 293  00f4  0000 07c4            	.long	encode+244	| vector  61
 294  00f8  0000 07c8            	.long	encode+248	| vector  62
 295  00fc  0000 07cc            	.long	encode+252	| vector  63
 296                             
 297                             
 298                             |***	We use the first user vectors for the interrupt
 299                             |***	contoller chip.  It must be programmed to generate
 300                             |**	vectors 64-71.
 301                             
 302                             INTVEC	=	64
 303                             
 304  0100  0000 07d0            cont4:	.long	cont4encode	| initiated by z80
 305  0104  0000 07dc            cont5:	.long	cont5encode	| initiated by z80
 306  0108  0000 07e8            cont6:	.long	cont6encode	| initiated by z80
 307                             |***
 308                             |***	The following three interrupts cannot be generated without also
 309                             |***	generating a bus error.  We keep the first two masked off permanently.
 310                             |***	The third should absolutely never be generated while running XENIX;
 311                             |***	the mask bit for this interrupt is used for special purposes by
 312                             |***	XENIX.
 313                             |***
 314  010c  0000 07f4            aderr:	.long	spu1encode	| MMU address error
 315                             timerri:
 316  0110  0000 0800            	.long	spu2encode	| timeout error, 68000 is bus master
 317                             timerre:
 318  0114  0000 080c            	.long	spu3encode	| timeout error, 68000 is not bus master
 319  0118  0000 0818            iper:	.long	ipencode	| parity error, 68000 is bus master
 320  011c  0000 0824            eper:	.long	epencode	| parity error, 68000 is not bus master
 321                             
 322                             
 323                             |***
 324                             |***	Just for fun, and to be totally evil to Mr. Snapp, we decided
 325                             |***	to put the mailboxes here instead of letting `ld' place them.
 326                             |***	[You hear maniacal laughter in the distance...]
 327                             |***
 328                             
 329                             |	c68  - enhanced compiler  - Version 3(24)  29-Mar-88
 330                             	.text
 331                             	.globl	z80base
 332  0120                       	.even
 333                             z80base:
 334                             
 335                             	.globl	_z80clk
 336  0120  0000                 _z80clk:	.blkb	2
 337  0122                       	.even
 338                             
 339                             	.globl	_z80halt
 340  0122  00                   _z80halt:	.blkb	1
 341  0123  00                   	.even
 342                             
 343                             	.globl	_z80disk
 344  0124  0000 0000 0000 0000  _z80disk:	.blkb	84
            0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000
 345  0178                       	.even
 346                             
 347                             	.globl	_z80msgb
 348  0178  0000 0000 0000 0000  _z80msgb:	.blkb	636
            0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 00
 349  03f4                       	.even
 350                             
 351                             	.globl	_z80grap
 352  03f4  0000 0000 0000 0000  _z80grap:	.blkb	18
            0000 0000 0000 0000 0000
 353  0406                       	.even
 354                             
 355                             	.globl	_z80ser
 356  0406  0000 0000 0000 0000  _z80ser:	.blkb	130
            0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 00
 357  0488                       	.even
 358                             
 359                             	.globl	_z80rcv
 360  0488  0000 0000            _z80rcv:	.blkb	4
 361  048c                       	.even
 362                             
 363                             	.globl	_z80fifo
 364  048c  0000 0000 0000 0000  _z80fifo:	.blkb	512
            0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 00
 365  068c                       	.even
 366                             
 367                             	.globl	_z80req_
 368  068c  0000 0000 0000 0000  _z80req_:	.blkb	66
            0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000
 369  06ce                       	.even
 370                             
 371                             	.globl	_z80boot
 372  06ce  0000                 _z80boot:	.blkb	2
 373  06d0                       	.even
 374                             
 375                             
 376                             
 377                             |***
 378                             |***	Finally, the vector and interrupt number encoders which
 379                             |***	transfer control to common routines.  Vector calculates
 380                             |***	the the trap number based on the return address of its
 381                             |***	caller, and calls trap; intr decides whom to call
 382                             |***	by looking in its caller's return address.
 383                             |***
 384                             
 385                             encode:
 386  06d0  6100 035a            	bsr     _vector         | start up xenix
 387                             |***
 388                             |***	Vector 1 is never really generated by the M68000 (it 
 389                             |***	doesn't exist, since reset uses 4 words).
 390                             |***	However, the interrupt handling routine fakes a trap 1
 391                             |***	to force _trap to reschedule: trap number 1 is the
 392                             |***	rescheduling trap.
 393                             |***
 394  06d4  6100 0356            	bsr     _vector         | vector   1
 395                             bencode:
 396  06d8  6100 0352            	bsr     _vector         | vector   2
 397                             
 398                             	.globl	_firstvec,_firstve	| first possible vector from user mode
 399                             _firstvec:
 400                             _firstve:
 401                             aencode:
 402  06dc  6100 034e            	bsr     _vector         | vector   3
 403  06e0  6100 034a            	bsr     _vector         | vector   4
 404  06e4  6100 0346            	bsr     _vector         | vector   5
 405  06e8  6100 0342            	bsr     _vector         | vector   6
 406  06ec  6100 033e            	bsr     _vector         | vector   7
 407  06f0  6100 033a            	bsr     _vector         | vector   8
 408  06f4  6100 0336            	bsr     _vector         | vector   9
 409  06f8  6100 0332            	bsr     _vector         | vector  10
 410  06fc  6100 032e            	bsr     _vector         | vector  11
 411  0700  6100 032a            	bsr     _vector         | vector  12
 412  0704  6100 0326            	bsr     _vector         | vector  13
 413  0708  6100 0322            	bsr     _vector         | vector  14
 414  070c  6100 031e            	bsr     _vector         | vector  15
 415  0710  6100 031a            	bsr     _vector         | vector  16
 416  0714  6100 0316            	bsr     _vector         | vector  17
 417  0718  6100 0312            	bsr     _vector         | vector  18
 418  071c  6100 030e            	bsr     _vector         | vector  19
 419  0720  6100 030a            	bsr     _vector         | vector  20
 420  0724  6100 0306            	bsr     _vector         | vector  21
 421  0728  6100 0302            	bsr     _vector         | vector  22
 422  072c  6100 02fe            	bsr     _vector         | vector  23
 423  0730  6100 02fa            	bsr     _vector         | vector  24
 424  0734  6100 02f6            	bsr     _vector         | vector  25
 425  0738  6100 02f2            	bsr     _vector         | vector  26
 426  073c  6100 02ee            	bsr     _vector         | vector  27
 427  0740  6100 02ea            	bsr     _vector         | vector  28
 428  0744  6100 02e6            	bsr     _vector         | vector  29
 429  0748  6100 02e2            	bsr     _vector         | vector  30
 430                             nencode:
 431  074c  6100 02de            	bsr     _vector         | vector  31
 432                             
 433                             	| This really isn't ever used when FASTSC is defined...
 434                             	| It's just here to hold the slot so I don't have to redo
 435                             	| all the `.long encode+FOO's after vector 32 (above)
 436  0750  6100 0280            	bsr     do_scall        | vector  32   trap #0 -- system call
 437                             
 438  0754  6100 02d6            	bsr     _vector         | vector  33
 439  0758  6100 02d2            	bsr     _vector         | vector  34
 440  075c  6100 02ce            	bsr     _vector         | vector  35
 441  0760  6100 02ca            	bsr     _vector         | vector  36
 442  0764  6100 02c6            	bsr     _vector         | vector  37
 443  0768  6100 02c2            	bsr     _vector         | vector  38
 444  076c  6100 02be            	bsr     _vector         | vector  39
 445  0770  6100 02ba            	bsr     _vector         | vector  40
 446  0774  6100 02b6            	bsr     _vector         | vector  41
 447  0778  6100 02b2            	bsr     _vector         | vector  42
 448  077c  6100 02ae            	bsr     _vector         | vector  43
 449  0780  6100 02aa            	bsr     _vector         | vector  44
 450  0784  6100 02a6            	bsr     _vector         | vector  45
 451  0788  6100 02a2            	bsr     _vector         | vector  46
 452  078c  6100 029e            	bsr     _vector         | vector  47
 453  0790  6100 029a            	bsr     _vector         | vector  48
 454  0794  6100 0296            	bsr     _vector         | vector  49
 455  0798  6100 0292            	bsr     _vector         | vector  50
 456  079c  6100 028e            	bsr     _vector         | vector  51
 457  07a0  6100 028a            	bsr     _vector         | vector  52
 458  07a4  6100 0286            	bsr     _vector         | vector  53
 459  07a8  6100 0282            	bsr     _vector         | vector  54
 460  07ac  6100 027e            	bsr     _vector         | vector  55
 461  07b0  6100 027a            	bsr     _vector         | vector  56
 462  07b4  6100 0276            	bsr     _vector         | vector  57
 463  07b8  6100 0272            	bsr     _vector         | vector  58
 464  07bc  6100 026e            	bsr     _vector         | vector  59
 465  07c0  6100 026a            	bsr     _vector         | vector  60
 466  07c4  6100 0266            	bsr     _vector         | vector  61
 467  07c8  6100 0262            	bsr     _vector         | vector  62
 468  07cc  6100 025e            	bsr     _vector         | vector  63
 469                             
 470                             
 471                             cont4encode:
 472                             	.globl	_rclock
 473  07d0  6100 016c            	jbsr	intr		| cont4
 474  07d4  0000 0000            	.long	0
 475  07d8  0000 0000            	.long	_rclock
 476                             cont5encode:
 477                             	.globl	_cont5
 478  07dc  6100 0160            	jbsr	intr		| cont5
 479  07e0  0000 0001            	.long	1
 480  07e4  0000 0000            	.long	_cont5
 481                             cont6encode:
 482                             	.globl	_cont6
 483  07e8  6100 0154            	jbsr	intr		| cont6
 484  07ec  0000 0002            	.long	2
 485  07f0  0000 0000            	.long	_cont6
 486                             spu1encode:
 487                             	.globl	_novec
 488  07f4  6100 0148            	jbsr	intr		| unexpected interrupt
 489  07f8  0000 0003            	.long	3
 490  07fc  0000 0000            	.long	_novec
 491                             spu2encode:
 492                             	.globl	_novec
 493  0800  6100 013c            	jbsr	intr		| unexpected interrupt
 494  0804  0000 0004            	.long	4
 495  0808  0000 0000            	.long	_novec
 496                             spu3encode:
 497                             	.globl	_novec
 498  080c  6100 0130            	jbsr	intr		| unexpected interrupt
 499  0810  0000 0005            	.long	5
 500  0814  0000 0000            	.long	_novec
 501                             ipencode:
 502                             	.globl	_parity
 503  0818  6100 0124            	jbsr	intr
 504  081c  0000 0006            	.long	6
 505  0820  0000 0000            	.long	_parity
 506                             epencode:
 507                             	.globl	_parity
 508  0824  6100 0118            	jbsr	intr
 509  0828  0000 0007            	.long	7
 510  082c  0000 0000            	.long	_parity
 511                             
 512                             	.globl	_endvec		| end of vectors
 513                             _endvec:
 514                             
 515                             |***   
 516                             |***	START	- The very first XENIX code
 517                             |***
 518                             |***	Create a C environment and call main, when main returns start the
 519                             |***	first user task.
 520                             |***
 521                             
 522                             |***
 523                             |***	Clear BSS, and initialize global variables as to size of system,
 524                             |***	base of working upage, address of first user memory, etc.
 525                             |***
 526                             	.text
 527                             	.globl	start,_end,_edata,_main,_cfginit
 528                             |***
 529                             |***	Size memory by trying to write a value and testing by reading it.
 530                             |***	Also check for memory wrap by looking at loc 0
 531                             |***
 532                             start:
 533                             
 534  0830  203c 0000 0000       	movl	#_end,d0	| point to start of user memory (more-or-less)
 535  0836  0680 0000 0fff       	addl	#USIZE-1,d0	| Round up one page
 536                             |<1>	andl	#~UMASK,d0	| to page boundry
 537  083c  0240 f000            	andw	#~UMASK,d0	|<1> to page boundry - upper bits stay on
 538  0840  2040                 	movl	d0,a0
 539  0842  93c9                 	subl	a1,a1		| point to loc zero
 540                             
 541  0844  23fc 0000 086a 0000  	movl	#3$,nofault	| make memory faults go here
            0f8c
 542                             2$:
 543  084e  30bc 1234            	movw	#/1234,(a0)	| try to store 1234
 544  0852  317c 0000 0002       	movw	#0,2(a0)	| put another value on the bus
 545  0858  0c50 1234            	cmpw	#/1234,(a0)	| did it store ?
 546  085c  660c                 	jne	3$		| no, so this is top of memory
 547  085e  0c51 1234            	cmpw	#/1234,(a1)	| did it set loc 0 ?
 548  0862  6706                 	jeq	3$		| yes, we have finished with all of memory
 549  0864  d0fc 1000            	addw	#PAGESIZE,a0	| next page boundary
 550  0868  60e4                 	jra	2$		| loop for more memory
 551                             
 552  086a  23c8 0000 0f76       3$:	movl	a0,_maxaddr	| This is top of memory for XENIX
 553                             
 554  0870  42b9 0000 0f8c       	clrl	nofault
 555                             
 556                             
 557                             
 558  0876  4eb9 0000 0000       	jsr	_cfginit	| Allocate configurable stuff as apropriate
 559                             				|  [cfginit() returns new _end in d0]
 560                             
 561                             
 562  087c  0680 0000 0fff       	addl	#USIZE-1,d0	| Round up one page
 563                             |<1>	andl	#~UMASK,d0	|   to page boundry
 564  0882  0240 f000            	andw	#~UMASK,d0	|<1>   to page boundry - upper stay bits on
 565  0886  23c0 0000 0f6e       	movl	d0,_exenix	| addr of end of xenix
 566  088c  23c0 0000 0f90       	movl	d0,uaddr	| initialize address of current process U
 567  0892  0680 0000 1000       	addl	#USIZE,d0	| next page
 568  0898  23c0 0000 0f72       	movl	d0,_umem	| first free page
 569  089e  207c 0000 0000       	movl	#_edata,a0	| start clearing from here
 570                             
 571                             |*** Clear BSS, first upage.  Because we may have parity equipped
 572                             |*** memory, we don't use a clr intruction on memory, which generates
 573                             |*** a read access before write access.
 574  08a4  7200                 	moveq	#0,d1
 575  08a6  20c1                 1$:	movl	d1,(a0)+	| clear a long word and increment a0
 576  08a8  b088                 	cmpl	a0,d0		| are we done
 577  08aa  6efa                 	jgt	1$		| loop while less than or equal
 578                             
 579                             
 580                             
 581                             
 582                             
 583                             
 584                             
 585                             
 586                             
 587                             
 588                             
 589                             
 590                             
 591                             |***	Initialize all of physical memory, in case it is parity equipped.
 592  08ac  2079 0000 0f76       	movl	_maxaddr,a0
 593  08b2  2008                 	movl	a0,d0		| top of physical memory
 594  08b4  90b9 0000 0f72       	subl	_umem,d0	| number of bytes of user memory
 595  08ba  223c 4afc 4afc       	movl	#/4afc4afc,d1	| initialize memory with illegal instructions
 596                             
 597  08c0  2101                 4$:	movl	d1,-(a0)	| Initialize a word
 598  08c2  5980                 	subql	#4,d0		| We did 4 bytes
 599  08c4  66fa                 	bnes	4$		| Loop for all words (we can't use dbra
 600                             				|   here because it might be > 16 bits)
 601                             
 602                             
 603                             |***	The initial system stack will grow from the end of the system U
 604                             |***	page down
 605                             
 606  08c6  207c 0000 0000       	movl	#_u,a0		| physical address of system U
 607  08cc  23f9 0000 0f6e 0000  	movl	_exenix,uaddr	| where we keep the proc 0 upage when running
            0f90
 608                             				|   other processes
 609  08d6  d0fc 0ffe            	addw	#USIZE-2,a0
 610  08da  2e48                 	movl	a0,sp
 611                             
 612                             |***
 613                             |***	Initialize the Z80 interface and interrupt controller.
 614                             |***
 615  08dc  46fc 2700            	movw	#NOINTR,sr	| hi processor priority
 616                             
 617                             	.globl	_z80init
 618  08e0  4eb9 0000 0000       	jsr	_z80init	| Initialize z80 structures
 619                             
 620  08e6  21fc 0000 0120 0004  	movl	#z80base,4:w	| inform z80 of base address
 621  08ee  0cb8 0000 0120 0004  8$:	cmpl	#z80base,4:w	| wait for z80 to intialize buffer space
 622  08f6  67f6                 	jeq	8$
 623                             
 624                             
 625                             	| We need to wait until this point to check the reboot-byte
 626                             	|   because the Z80 didn't know where the iopb's were until
 627                             	|   just now (we just told it).
 628                             	.globl	_z80rebo	| [In real life: z80reboot()]
 629  08f8  4eb9 0000 0000       	jsr	_z80rebo	| Check for reboot or normal boot
 630                             
 631                             
 632                             
 633                             
 634                             
 635  08fe  41f9 0078 00d1       	lea	INTCOMMAND,a0	| pointer to interrupt command reg
 636  0904  2248                 	movl	a0,a1		| pointer to
 637  0906  5389                 	subql	#1,a1		|	interrupt data reg
 638  0908  10bc 0000            	movb	#INTRESET,(a0)	| reset controller
 639                             
 640  090c  70e0                 	moveq	#INTPROGRAM,d0	| command to program first int level
 641  090e  7240                 	moveq	#INTVEC,d1	| interrupt vector to be programmed
 642  0910  7407                 	moveq	#7,d2		| number of vectors minus one
 643                             
 644  0912  1080                 9$:	movb	d0,(a0)		| specify which register to program
 645  0914  1281                 	movb	d1,(a1)		| provide vector number
 646  0916  5280                 	addql	#1,d0		| next register
 647  0918  5281                 	addql	#1,d1		| next vector number
 648  091a  51ca fff6            	dbra	d2,9$		| loop
 649                             
 650                             
 651                             
 652  091e  10bc 00a5            	movb	#INTARM,(a0)	| arm the chip
 653                             
 654                             
 655                             
 656                             	| make a stack so first proc can have a u.u_ar0
 657  0922  48e7 ffff            	moveml	#/ffff,-(sp)	| save all regs
 658  0926  48e7 f800            	moveml	#/f800,-(sp)	| save 5 more
 659  092a  46fc 2000            	movw	#SSTATE,sr	| lo processor priority
 660                             
 661                             
 662                             
 663  092e  4eb9 0000 0000       	jsr	_main		| call main
 664                             
 665                             |***	return from main is "in" init process
 666                             
 667                             
 668  0934  2f3c 0000 0000       	movl	#USRSTART,-(sp)	| starting addr for user process
 669  093a  4267                 	clrw	-(sp)		| return to user mode
 670  093c  4e73                 	rte
 671                             
 672                             	.data
 673                             	.globl	_exenix,_umem,_maxaddr
 674                             
 675  0f6e  0000 0000            _exenix: .long	0	| The first page after xenix (also the first U page)
 676  0f72  0000 0000            _umem:	 .long	0	| The first free page
 677  0f76  0000 0000            _maxaddr:.long	0	| The last page of memory
 678                             
 679  0f7a  00                   nmiflag:.byte	0
 680                             
 681                             |***	Because we seem to be unable to read the mask register
 682                             |***	of the interrupt controller, we maintain copy in software.
 683                             
 684                             	.globl	intmask		| so it will come out in the symbol table
 685  0f7b  ff                   intmask:.byte	/ff		| software copy of interrupt mask register
 686  0f7c                       	.even
 687                             
 688                             
 689                             |***   
 690                             |***	Trap and Interrupt Handlers
 691                             |***
 692                             |***	Your basic stack is:
 693                             |***				pchi,pclo	long
 694                             |***				sr		word
 695                             |***				pchi,pclo	long from bsr
 696                             |***
 697                             |***	For traps, the "long from bsr" points to the trap number.
 698                             |***	For interrupts, the "long from bsr" points to the interrupt
 699                             |***		number, followed by a jmp instruction to the handler.
 700                             |***
 701                             |***	Your stack handed to _trap becomes:
 702                             |***				pchi,pclo	long
 703                             |***				sr		long
 704                             |***				intmask		long	(formerly unused "mmu")
 705                             |***				regs		16 longs
 706                             |***				trap no		long
 707                             |***
 708                             |***	Your stack handed to interrupt handlers is:
 709                             |***				pchi,pclo	long
 710                             |***				sr		long
 711                             |***				intmask		long
 712                             |***				saved a1	long
 713                             |***				saved a0	long
 714                             |***				saved d1	long
 715                             |***				saved d0	long
 716                             |***				intno		long
 717                             |***
 718                             |*** trap(no,d0,d1,d2,d3,d4,d5,d6,d7,a0,a1,a2,a3,a4,a5,a6,usp,mmu,sr,tpc)
 719                             |*** long no,d0,d1,d2,d3,d4,d5,d6,d7,a0,a1,a2,a3,a4,a5,a6,usp,mmu,sr,tpc;
 720                             |***
 721                             |*** devintr(no,d0,d1,a0,a1,intmask,sr,tpc)
 722                             |*** long no,d0,d1,a0,a1,sr,tpc;
 723                             |***
 724                             
 725                             |***
 726                             |***	INTR -- handle vectored interrupts from interrupt controller
 727                             |***
 728                             	.text
 729                             intr:				| vectored interrupt handler
 730  093e  4267                 	clrw	-(sp)		| get to long alignment
 731  0940  48e7 c0c0            	moveml	<a0,a1,d0,d1>,-(sp)
 732                             
 733  0944  206f 0012            	movl	18(sp),a0	| where bsr put address of itself plus 4
 734                             
 735  0948  7000                 	moveq	#0,d0		|<1>(4)
 736  094a  2f40 0012            	movl	d0,18(sp)	|<1>(16)make args nice
 737                             |<1>	clrl	18(sp)		|(24) make args nice
 738                             
 739  094e  2018                 	movl	(a0)+,d0	| fetch vector number
 740  0950  2f00                 	movl	d0,-(sp)	| push vector number as arg
 741                             
 742                             	| Compute the appropriate bits to set in the mask register
 743  0952  72ff                 	moveq	#-1,d1
 744  0954  e1a1                 	asll	d0,d1
 745                             
 746                             	| d1 now holds bits to set in mask register
 747  0956  1039 0000 0f7b       	movb	intmask,d0	| get old mask value
 748  095c  1f40 0017            	movb	d0,23(sp)	| save as stack arg
 749  0960  8001                 	orb	d1,d0		| compute new mask
 750                             
 751                             	| d0 now holds the new mask
 752  0962  43f9 0078 00d1       	lea	INTCOMMAND,a1	| points after data register
 753  0968  12bc 00b0            	movb	#MASKWRITE,(a1)	| prepare to write new mask value
 754                             |<1>	movb	d0,-(a1)	|(8) new mask into hardware
 755  096c  1340 ffff            	movb	d0,-1(a1)	|<1>(12) new mask into hardware
 756  0970  13c0 0000 0f7b       	movb	d0,intmask	| new mask into software copy
 757                             |<1>	addql	#1,a1		|(8) points to command register again
 758  0976  12bc 0060            	movb	#CLRINT,(a1)	| clear the interrupt -- trust the mask
 759                             
 760                             	| we use d1 to figure what the new SR will be
 761  097a  322f 001a            	movw	26(sp),d1	| old sr
 762                             |<1>	bset	#SBIT,d1	|(12) set supervisor bit
 763  097e  0041 2000            	orw	#/2000,d1	|<1>(8) set supervisor bit
 764                             |<1>	bclr	#TBIT,d1	|(14) clear trace bit
 765  0982  0241 7fff            	andw	#/7fff,d1	|<1>(8) clear trace bit
 766  0986  46c1                 	movw	d1,sr		| new processor pri -- enable higher pri ints
 767                             
 768  0988  2050                 	movl	(a0),a0		| Grab handler's address
 769  098a  4e90                 	jsr	(a0)		| call handler(no,d0,d1,a0,a1,intmask,sr,tpc)
 770                             
 771  098c  588f                 	addql	#4,sp		| pop int number
 772  098e  082f 000d 0016       	btst	#SBIT,22(sp)	| came from supervisor mode?
 773  0994  6608                 	jne	1$		| yes: do not reschedule
 774  0996  4a39 0000 0000       	tstb	_runrun		| need to reschedule?
 775  099c  6628                 	jne	reschedule	| yes: branch
 776                             1$:
 777  099e  4279 0000 0f94       	clrw	_Idlef		| don't loop in idle
 778  09a4  102f 0013            	movb	19(sp),d0	| saved mask register
 779  09a8  41f9 0078 00d1       	lea	INTCOMMAND,a0	| pointer to hardware register
 780  09ae  46fc 2700            	movw	#NOINTR,sr	| hi priority for mask fiddling
 781  09b2  13c0 0000 0f7b       	movb	d0,intmask	| software copy
 782  09b8  10bc 00b0            	movb	#MASKWRITE,(a0)	|
 783  09bc  1100                 	movb	d0,-(a0)	| hardware copy
 784  09be  4cdf 0303            	moveml	(sp)+,<a0,a1,d0,d1>	| restore registers
 785  09c2  5c8f                 	addql	#6,sp		| pop old intmask, hi sr
 786  09c4  4e73                 	rte
 787                             
 788                             	.data
 789                             	.comm	_runrun,1
 790                             	.text
 791                             
 792                             
 793                             |***
 794                             |***	RESCHEDULE -- branched to from INTR to fake a rescheduling trap
 795                             |***	RESCHED1 -- branched to from DO_SCALL to fake a rescheduling trap
 796                             |***
 797                             	.text
 798                             reschedule:
 799  09c6  4cdf 0303            	moveml	(sp)+,<a0,a1,d0,d1>	| restore registers, leaving intmask
 800                             resched1:
 801  09ca  48e7 ffff            	moveml	#/ffff,-(sp)	| save ALL registers
 802  09ce  7001                 	moveq	#1,d0		| fake trap 1
 803  09d0  6078                 	jra	calltrap
 804                             
 805                             
 806                             
 807                             |***
 808                             |***	DO_SCALL -- handle system call traps quickly
 809                             |***
 810                             
 811                             do_scall:
 812  09d2  4267                 	clrw	-(sp)		| Make sr a long
 813  09d4  42a7                 	clrl	-(sp)		| put old `mmu' arg on stack
 814  09d6  48e7 ffff            	moveml	#/ffff,-(sp)	| save all regs
 815  09da  1f79 0000 0f7b 0043  	movb	intmask,67(sp)	| save interrupt info on stack in old "mmu" slot
 816                             
 817  09e2  082f 000d 0046       	btst	#SBIT,70(sp)	| Did we come from supervisor mode?
 818  09e8  6706                 	jeq	1$		|   No:  proceed with system call
 819                             
 820  09ea  7020                 	moveq	#32,d0		| Yes:  Oh, oh; we executed a "trap #0" from
 821  09ec  6000 005c            	bra	calltrap	|   SUPERVISOR mode...  (prepare to panic:)
 822                             
 823  09f0  4e68                 1$:	movl	usp,a0
 824  09f2  2f48 003c            	movl	a0,60(sp)	| Replace saved a7 with user stack pointer
 825                             
 826  09f6  4eb9 0000 0000       	jbsr	_systrap	| Run the system call
 827                             
 828  09fc  206f 003c            	movl	60(sp),a0	| Possibly altered user stack pointer
 829  0a00  4e60                 	movl	a0,usp		| Restore user stack pointer
 830                             
 831                             |***  Program interrupt controller chip
 832  0a02  102f 0043            	movb	67(sp),d0	| saved mask register
 833  0a06  41f9 0078 00d1       	lea	INTCOMMAND,a0	| pointer to hardware register
 834  0a0c  46fc 2700            	movw	#NOINTR,sr	| hi priority for mask fiddling
 835  0a10  13c0 0000 0f7b       	movb	d0,intmask	| Save software a copy
 836  0a16  10bc 00b0            	movb	#MASKWRITE,(a0)	|
 837  0a1a  1100                 	movb	d0,-(a0)	| Give hardware its copy
 838                             
 839  0a1c  4cdf 7fff            	moveml	(sp)+,#/7fff	| restore all registers except sp
 840  0a20  defc 000a            	addw	#10,sp		| Pop saved usp, intmask, and high word of sr
 841  0a24  4239 0000 0f7a       	clrb	nmiflag		| allow processing of NMI
 842  0a2a  4e73                 	rte			| Back to the User
 843                             
 844                             
 845                             
 846                             |***
 847                             |***	VECTOR -- handle processor traps
 848                             |***
 849                             	.globl	_vector,_trap
 850                             
 851                             _vector:
 852                             
 853                             
 854  0a2c  4267                 	clrw	-(sp)		| get to long alignment
 855  0a2e  48e7 ffff            	moveml	#/ffff,-(sp)	| save ALL regs
 856  0a32  202f 0042            	movl	66(sp),d0	| where bsr put the address of itself+4
 857  0a36  0480 0000 06d4       	subl	#encode+4,d0	| change to offset
 858  0a3c  e480                 	asrl	#2,d0		| divide by 4 to get vector number
 859  0a3e  42af 0042            	clrl	66(sp)		| put zero in jsrpc (make sr and mmu args nice)
 860                             
 861                             
 862                             illtrap:
 863  0a42  1f79 0000 0f7b 0043  	movb	intmask,67(sp)	| save interrupt info on stack in "mmu" arg
 864                             
 865                             calltrap:
 866  0a4a  2f00                 	movl	d0,-(sp)	| push trap number on stack
 867  0a4c  4e68                 	movl	usp,a0		| get user stack pointer
 868  0a4e  2f48 0040            	movl	a0,64(sp)	| replace saved a7 with user stack pointer
 869                             
 870  0a52  4eb9 0000 0000       	jbsr	_trap		| call trap(number, regs)
 871                             
 872  0a58  588f                 	addql	#4,sp		| pop off vector number
 873  0a5a  206f 003c            	movl	60(sp),a0	| saved user stack pointer
 874  0a5e  4e60                 	movl	a0,usp		| restore user stack pointer
 875                             
 876  0a60  102f 0043            	movb	67(sp),d0	| saved mask register
 877  0a64  41f9 0078 00d1       	lea	INTCOMMAND,a0	| pointer to hardware register
 878  0a6a  46fc 2700            	movw	#NOINTR,sr	| hi priority for mask fiddling
 879  0a6e  13c0 0000 0f7b       	movb	d0,intmask	| software copy
 880  0a74  10bc 00b0            	movb	#MASKWRITE,(a0)	|
 881  0a78  1100                 	movb	d0,-(a0)	| hardware copy
 882                             
 883  0a7a  4cdf 7fff            	moveml	(sp)+,#/7fff	| restore all registers (not sp)
 884  0a7e  defc 000a            	addw	#10,sp		| saved usp, intmask, and hi of sr
 885  0a82  4239 0000 0f7a       	clrb	nmiflag		| allow processing of NMI
 886  0a88  4e73                 	rte			| back to somewhere
 887                             
 888                             |*** Debounce NMI
 889                             nmi:
 890  0a8a  08f9 0000 0000 0f7a  	bset	#0,nmiflag    | Figure out if we're already handling NMI
 891                             			      | uses kludge because some MMU's can't handle TAS
 892                             
 893  0a92  6700 fcb8            	jeq	nencode		| no -- call vector
 894                             
 895  0a96  4e73                 	rte			| yes -- ignore this one
 896                             
 897                             |***
 898                             |***	Bus error and Address error traps push 4 extra words on the stack.
 899                             |***	On a 68010, they push 22 extra words on the stack.
 900                             |***
 901                             |***	These routines take the words off the stack so that all traps look
 902                             |***	the same.
 903                             |***
 904                             	.data
 905                             	.globl	berrinfo,aerrinfo,_fltinfo,nofault
 906                             _fltinfo:
 907  0f7c  0000 0000 0000 0000  berrinfo:.word	0,0,0,0		| save error info in global
 908  0f84  0000 0000 0000 0000  aerrinfo:.word	0,0,0,0		| save error info in global
 909  0f8c  0000 0000            nofault:.long	0		| address to go to on memory faults
 910                             
 911                             
 912                             	.text
 913                             
 914                             
 915                             	.globl	_buserr,_adrerr
 916                             _buserr:
 917  0a98  48e7 000e            	moveml	<a4,a5,a6>,-(sp)| save regs
 918  0a9c  4cef 6000 000c       	moveml	12.(sp),<a5,a6>	| get the 4 extra words into a6 and a5
 919  0aa2  287c 0000 0f7c       	movl	#berrinfo,a4	| point to global save area
 920  0aa8  48d4 6000            	moveml	<a5,a6>,(a4)	| put in berrinfo
 921  0aac  4ab9 0000 0f8c       	tstl	nofault		| nofault set ?
 922  0ab2  6648                 	jne	fixfault	| yes so return there
 923  0ab4  4cd7 7000            	moveml	(sp),<a4,a5,a6>	| restore regs
 924  0ab8  defc 0014            	addw	#20.,sp		| back to where we moved it
 925                                 | Do an rte to avoid processor halt
 926  0abc  2f3c 0000 0ac6       	movl	#bus1,-(sp)	| push pc
 927  0ac2  40e7                 	movw	sr,-(sp)	| push status word
 928  0ac4  4e73                 	rte
 929                             bus1:
 930  0ac6  6000 fc10            	jra	bencode		| just like any other trap
 931                             
 932                             _adrerr:
 933  0aca  48e7 000e            	moveml	<a4,a5,a6>,-(sp)| save regs
 934  0ace  4cef 6000 000c       	moveml	12.(sp),<a5,a6>	| get the 4 extra words into a6 and a5
 935  0ad4  287c 0000 0f84       	movl	#aerrinfo,a4	| point to global save area
 936  0ada  48d4 6000            	moveml	<a5,a6>,(a4)	| put in berrinfo
 937  0ade  4ab9 0000 0f8c       	tstl	nofault		| nofault set ?
 938  0ae4  6616                 	jne	fixfault	| yes so return there
 939  0ae6  4cd7 7000            	moveml	(sp),<a4,a5,a6>	| restore regs
 940  0aea  defc 0014            	addw	#20.,sp		| back to where we moved it
 941                                 | Do an rte to avoid processor halt
 942  0aee  2f3c 0000 0af8       	movl	#adr1,-(sp)	| push pc
 943  0af4  40e7                 	movw	sr,-(sp)	| push status word
 944  0af6  4e73                 	rte
 945                             adr1:
 946  0af8  6000 fbe2            	jra	aencode		| just like any other trap
 947                             
 948                             fixfault:
 949  0afc  2879 0000 0f8c       	movl	nofault,a4	| where to go
 950  0b02  2f4c 0016            	movl	a4,22.(sp)	| change pc
 951  0b06  4cd7 7000            	moveml	(sp),<a4,a5,a6>	| restore regs
 952  0b0a  defc 0014            	addw	#20.,sp		| back to where we moved it
 953  0b0e  4e73                 	rte			| back to where nofault said to go
 954                             
 955                             
 956                             |***
 957                             |***	SAVE(regs)
 958                             |***	struct label_t *regs;
 959                             |***
 960                             |***		Save register contents in U area pointed to by
 961                             |***		addr, in prepartion for context switch.
 962                             |***
 963                             |***		On TRS-16, must copy struct U and stack contents
 964                             |***		from working Upage to process's Upage.
 965                             |***
 966                             |***		  Note:	The M68010SR code does NOT work.  
 967                             |***			Do not define M68010SR.  23 Oct 87  jeIV
 968                             |***
 969                             	.data
 970                             
 971                             	.globl	_dustack	| number of bytes from &u to &u.stack
 972                             				| initialized in C code
 973                             	.globl	_u
 974                             	.comm	_u,USIZE
 975                             
 976                             	.globl	uaddr
 977  0f90  0000 0000            uaddr:	.long	0		| address of U area for current process
 978                             				| set by last resume, initialized with
 979                             				| same value as _exenix
 980                             	.text
 981                             	.globl	_save
 982                             
 983                             _save:				| save(regs)
 984  0b10  225f                 	movl	(sp)+,a1	| return address off of stack
 985  0b12  2057                 	movl	(sp),a0		| ptr to a label_t (place to save regs)
 986  0b14  48d0 fcfc            	moveml	#/fcfc,(a0)	| save d2-d7 and a2-a7
 987  0b18  2149 0030            	movl	a1,48(a0)	| save return address
 988  0b1c  2f09                 	movl	a1,-(sp)	| and back onto stack for safe keeping
 989                             |***
 990                             |***	Copy the stack and U-struct from the working area to the
 991                             |***	process's allocated U and stack
 992                             |***
 993                             
 994                             
 995                                 |*** First, copy the stack [from sp to (_u + USIZE - 1)]
 996  0b1e  200f                 	movl	sp,d0		| copy current stack pointer
 997  0b20  207c 0000 1000       	movl	#_u+USIZE,a0	| end of U
 998  0b26  91cf                 	subl	sp,a0		| number of bytes of stack
 999  0b28  2f08                 	movl	a0,-(sp)	| nbytes arg to copybuf
1000                             
1001  0b2a  2200                 	movl	d0,d1		| stack pointer copy
1002  0b2c  0481 0000 0000       	subl	#_u,d1		| calculate offset within U+stack page
1003  0b32  d2b9 0000 0f90       	addl	uaddr,d1	| address within process's real U
1004  0b38  2f01                 	movl	d1,-(sp)	| toaddr arg to copybuf
1005  0b3a  2f00                 	movl	d0,-(sp)	| copy of sp -- fromaddr arg to copybuf
1006  0b3c  6100 00f6            	jbsr	_copybuf	| copy bytes
1007  0b40  defc 000c            	addw	#12,sp		| pop args to copybuf
1008                             
1009                                 |*** Then, copy the U struct proper  [from &u to &u.u_stack (end of the U)]
1010  0b44  2f39 0000 0000       	movl	_dustack,-(sp)	| nbytes = (char *) u.u_stack - (char *) &u
1011  0b4a  2f39 0000 0f90       	movl	uaddr,-(sp)	| toaddr
1012  0b50  2f3c 0000 0000       	movl	#_u,-(sp)	| fromaddr
1013  0b56  6100 00dc            	jbsr	_copybuf	| copy bytes
1014  0b5a  defc 000c            	addw	#12,sp		| pop args to copybuf
1015                             
1016                             
1017  0b5e  7000                 	moveq	#0,d0		| return value is 0 in saver
1018  0b60  4e75                 	rts			| return
1019                             
1020                             |***
1021                             |***	RESUME(upage,regs)
1022                             |***	struct label_t *regs;
1023                             |***
1024                             |***		Switch contexts to kernel process whose U and stack
1025                             |***		are in physical page upage, and whose registers are
1026                             |***		saved in its U at the location corresponding to
1027                             |***		address regs.
1028                             |***
1029                             |***		On TRS-16, must copy new process's U-struct and stack
1030                             |***		into the working area, and must set variable (uaddr)
1031                             |***		to hold address of current process's allocated U-page.
1032                             |***
1033                             |***		  Note:	The M68010SR code does NOT work.  
1034                             |***			Do not define M68010SR.  23 Oct 87  jeIV
1035                             |***
1036                             	.globl	_resume
1037                             _resume:			| resume(upage,regs)
1038  0b62  242f 0004            	movl	4(sp),d2	| address of user structure
1039  0b66  246f 0008            	movl	8(sp),a2	| ptr to label_t (place where regs were saved)
1040                             
1041                             |<1>	asll	#SHIFT1,d2	|(8+16) convert upage number
1042                             |<1>	asll	#SHIFT2,d2	|(8+8)	to physical address
1043                             |<1>	Believe it or not, the following is equivalent.  Here is what happens:
1044                             |<1>	31 30 29 28 ... 18 17 16 | 15 14 13 ... 5  4  3  2  1  0
1045                             |<1>	3  2  1  0  31 30 29 ...  21 20 | 19 18 17 16  ... 6  5  4
1046                             |<1>	19 18 17 16 ... 6  5  4 | 3  2  1  0 31 30 29 ... 22 21 20
1047                             |<1>    19 18 17 16 ... 6  5  4 | 3  2  1  0 - - - - - - - - - - - - 
1048                             |<1>	Cute, eh?  saves 12 clocks - fdiv
1049                             
1050  0b6a  e89a                 	rorl	#4,d2		|<1>(16)Rotate right four bits
1051  0b6c  4842                 	swap	d2		|<1>(4)
1052  0b6e  0242 f000            	andw	#/f000,d2	|<1>(8)Zero lower 12 bits
1053                             
1054  0b72  23c2 0000 0f90       	movl	d2,uaddr	| stow address of new U in global
1055                             
1056                             
1057  0b78  2f39 0000 0000       	movl	_dustack,-(sp)	| nbytes
1058  0b7e  2f3c 0000 0000       	movl	#_u,-(sp)	| toaddr
1059  0b84  2f02                 	movl	d2,-(sp)	| from addr
1060  0b86  6100 00ac            	jbsr	_copybuf	| copy bytes
1061  0b8a  defc 000c            	addw	#12,sp		| pop args
1062                             
1063                             
1064  0b8e  2e6a 002c            	movl	44(a2),sp	| stack pointer to be restored
1065                             				| note that current stack contents are now
1066                             				| 	invalid
1067                             
1068  0b92  260f                 	movl	sp,d3		| copy of new stack pointer
1069  0b94  267c 0000 1000       	movl	#_u+USIZE,a3	| end of working Upage
1070  0b9a  97cf                 	subl	sp,a3		| calculate size of saved stack
1071  0b9c  2f0b                 	movl	a3,-(sp)	| nbytes
1072                             
1073  0b9e  2f03                 	movl	d3,-(sp)	| toaddress
1074  0ba0  0483 0000 0000       	subl	#_u,d3		| convert sp copy to offset in page
1075  0ba6  d682                 	addl	d2,d3		| compute address within process's copy
1076  0ba8  2f03                 	movl	d3,-(sp)	| fromaddress
1077  0baa  6100 0088            	jbsr	_copybuf	| copy bytes
1078  0bae  defc 000c            	addw	#12,sp		| pop args
1079                             
1080                             
1081  0bb2  613a                 	jbsr	_spl0		| we return in an interruptible condition
1082  0bb4  204a                 	movl	a2,a0		| reg pointer into a volatile register
1083  0bb6  4cd8 fcfc            	moveml	(a0)+,#/fcfc	| restore d2-d7 & a2-a7
1084  0bba  2050                 	movl	(a0),a0		| return address
1085  0bbc  7001                 	moveq	#1,d0		| return 1
1086  0bbe  4ed0                 	jmp	(a0)		| return in new context
1087                             
1088                             |***
1089                             |***	SETJMP(regs)
1090                             |***	LONGJMP(regs)
1091                             |***
1092                             |***		Similar to save and resume, but do not involve
1093                             |***		context switches, and therefore, don't require
1094                             |***		copying of any U information.
1095                             |***
1096                             	.globl	_setjmp,_longjmp
1097                             _setjmp:
1098  0bc0  225f                 	movl	(sp)+,a1	| return address
1099  0bc2  2057                 	movl	(sp),a0		| ptr to a label_t (place to save regs)
1100  0bc4  48d0 fcfc            	moveml	#/fcfc,(a0)	| save d2-d7 and a2-a7
1101  0bc8  2149 0030            	movl	a1,48(a0)	| save return address
1102  0bcc  7000                 	moveq	#0,d0		| return value is 0 in saver
1103  0bce  4ed1                 	jmp	(a1)		| return
1104                             
1105                             _longjmp:
1106  0bd0  206f 0004            	movl	4(sp),a0	| ptr to label_t (place where regs were saved)
1107  0bd4  4cd8 fcfc            	moveml	(a0)+,#/fcfc	| restore d2-d7 & a2-a7
1108  0bd8  2250                 	movl	(a0),a1		| return address
1109  0bda  7001                 	moveq	#1,d0		| return 1
1110  0bdc  4ed1                 	jmp	(a1)		| return
1111                             
1112                             |***
1113                             |***	SPL	- spl7,6,5,4,1,0 set the interupt mask in the status reg
1114                             |***		also return the previous level so that a call to splx
1115                             |***		can be used to set a previous level
1116                             |***
1117                             
1118                             	.globl	_spl7,_spl6,_spl5,_spl4,_spl1,_spl0,_splx,_tasktime
1119                             
1120                             _spl7:
1121                             _spl6:				| spl6 and spl7 use the same interrupt mask
1122  0bde  72ff                 	moveq	#MASK6,d1
1123  0be0  6014                 	jra	splcom
1124                             
1125                             _spl5:
1126  0be2  72fe                 	moveq	#MASK5,d1
1127  0be4  6010                 	jra	splcom
1128                             
1129                             _spl4:
1130  0be6  72fc                 	moveq	#MASK4,d1
1131  0be8  600c                 	jra	splcom
1132                             
1133                             _spl1:
1134  0bea  7238                 	moveq	#MASK1,d1
1135  0bec  6008                 	jra	splcom
1136                             
1137                             _tasktime:
1138                             _spl0:
1139  0bee  7218                 	moveq	#MASK0,d1
1140  0bf0  6004                 	jra	splcom
1141                             
1142                             _splx:
1143  0bf2  122f 0007            	movb	7(sp),d1
1144                             
1145                             
1146                             splcom:				| Common spl code: d1 has new mask
1147  0bf6  43f9 0078 00d1       	lea	INTCOMMAND,a1	| points after data register
1148  0bfc  40c0                 	movw	sr,d0		| save processor pri
1149  0bfe  3040                 	movw	d0,a0
1150  0c00  46fc 2700            	movw	#NOINTR,sr	| no interrupts while playing with mask
1151  0c04  12bc 00b0            	movb	#MASKWRITE,(a1)	| prepare to write new mask value
1152  0c08  1301                 	movb	d1,-(a1)	| new mask into hardware
1153  0c0a  1039 0000 0f7b       	movb	intmask,d0	| old mask register
1154  0c10  13c1 0000 0f7b       	movb	d1,intmask	| new mask into software copy
1155  0c16  3208                 	movw	a0,d1		
1156  0c18  46c1                 	movw	d1,sr		| restore processor pri
1157  0c1a  4e75                 	rts			| return
1158                             
1159                             
1160                             |***
1161                             |***	IDLE	- spl0 and wait for interrupt
1162                             |***
1163                             	.globl	_idle,_waitloc,_Idlef
1164                             	.data
1165                             _Idlef:
1166  0f94  0000                 	.word	0
1167                             	.text
1168                             
1169                             _idle:
1170  0c1c  33fc 0001 0000 0f94  	movw	#1,_Idlef
1171  0c24  61c8                 	jbsr	_spl0
1172                             _waitloc:
1173  0c26  4a79 0000 0f94       	tstw	_Idlef
1174  0c2c  66f8                 	jne	_waitloc
1175                             
1176  0c2e  1200                 	movb	d0,d1		| Fast call to splx()
1177  0c30  61c4                 	jbsr	splcom		| Don't have to mess with the stack this way
1178                             
1179  0c32  4e75                 	rts
1180                             
1181                             |***
1182                             |***	COPYBUF	- copy in kernel memory
1183                             |***
1184                             |***		Because this routine is used by copyin/out on TRS-16,
1185                             |***		copybuf must return 0 in d0.
1186                             |***
1187                             |***		Copyin/out make use of the fact that their arguments
1188                             |***		are logically equivalent to those of copybuf.
1189                             |***
1190                             |***		As presently coded, this routine is slightly inefficient
1191                             |***		for small transfers; however, it is highly efficient
1192                             |***		for large transfers, for which it is called often and
1193                             |***		for which efficiency is crucial.
1194                             |***
1195                             |***		NOTE:
1196                             |***		The bytecount argument must be in the range
1197                             |***		0 <= bytecount < 2^31.  (Because the 68000
1198                             |***		cannot address this much memory, this should
1199                             |***		not cause any problems.)
1200                             |***
1201                             |***		With the single exception noted above,
1202                             |***		copybuf will handled any combination of even, odd,
1203                             |***		zero, or nonzero arguments, as well as any overlap
1204                             |***		in the regions to be copied.
1205                             |***
1206                             |***		This routine is probably the most heavily used
1207                             |***		assembly language routine.  It is used by
1208                             |***			copyin
1209                             |***			copyout
1210                             |***			copyiin
1211                             |***			copyiout
1212                             |***			save
1213                             |***			resume
1214                             |***		A single call to copybuf is used in places where there
1215                             |***		would be multiple calls to
1216                             |***			copyseg
1217                             |***
1218                             	.globl	_copybuf
1219                             	.globl	_bcopy
1220                             
1221                             _bcopy:
1222                             _copybuf:			| copybuf(from,to,count)
1223  0c34  202f 000c            	movl	12(sp),d0	| d0 = count
1224  0c38  6700 00e8            	jeq	copyend		| if zero, no work to do
1225  0c3c  206f 0004            	movl	4(sp),a0	| a0 = from
1226  0c40  226f 0008            	movl	8(sp),a1	| a1 = to
1227  0c44  b3c8                 	cmpl	a0,a1		| compare from addr and to addr
1228  0c46  6700 00da            	jeq	copyend		| if equal, don't do anything
1229  0c4a  48e7 3f3e            	moveml	#/3f3e,-(sp)	| save reg d2-d7 and a2-a6
1230                             				| moveml does not affect condition codes!
1231  0c4e  6e64                 	jgt	copyup		| if fromaddr < toaddr, must ripple correctly
1232                             
1233                             | From address > To address: copy from low byte first
1234                             
1235                             | If both from and to are odd, move one byte and proceed to even code
1236                             | But if one is even and the other odd proceed to the bytewise move
1237                             
1238  0c50  2408                 	movl	a0,d2		| get addr in data reg so btst can work
1239  0c52  2609                 	movl	a1,d3		|
1240  0c54  7800                 	moveq	#0,d4		| clear d4 for use in btst instructions
1241  0c56  0902                 	btst	d4,d2		| test from bit 0
1242  0c58  670a                 	jeq	1$		| from even
1243  0c5a  0903                 	btst	d4,d3		| test to bit 0
1244  0c5c  673a                 	jeq	70$		| to even but from odd
1245                             
1246                             				| both odd
1247  0c5e  12d8                 	movb	(a0)+,(a1)+	| move one byte
1248  0c60  5380                 	subql	#1,d0		| cnt--
1249  0c62  6004                 	jra	2$
1250                             
1251                             1$:				| from even
1252  0c64  0903                 	btst	d4,d3		| test to bit 0
1253  0c66  6630                 	jne	70$		| from even but to odd
1254                             
1255                             2$:				| both even
1256  0c68  722c                 	moveq	#44.,d1		| use d1 to hold the constant
1257                             3$:
1258  0c6a  9081                 	subl	d1,d0		| subtract number of bytes to sub
1259  0c6c  6f0c                 	jle	4$		| if too few bytes, go to word-at-a-time
1260                             |*** Note that the moveml instruction generates an extra memory
1261                             |*** access; to avoid unexpected memory faults, if a move is exactly
1262                             |*** 44 bytes, we do it a word at a time.
1263                             
1264  0c6e  4cd8 7cfc            	moveml	(a0)+,#/7cfc	| load 44 bytes
1265  0c72  48d1 7cfc            	moveml	#/7cfc,(a1)	| store 44 bytes
1266  0c76  d3c1                 	addl	d1,a1		| can't autoinc the destination on moveml
1267  0c78  60f0                 	jra	3$		| loop
1268                             
1269                             4$:				| 44 or few bytes to go
1270  0c7a  d081                 	addl	d1,d0
1271  0c7c  e280                 	asrl	#1,d0		| convert to word count
1272  0c7e  650e                 	jcs	61$		| if byte-count was odd, C-bit set
1273  0c80  6002                 	jra	51$		| for proper iteration, enter end of loop
1274                             
1275  0c82  32d8                 50$:	movw	(a0)+,(a1)+	| move word
1276  0c84  51c8 fffc            51$:	dbra	d0,50$		| while words left
1277  0c88  6000 0094            	jra	copypop		| pop regs and return
1278                             
1279  0c8c  32d8                 60$:	movw	(a0)+,(a1)+	| move words, then 1 byte at end
1280  0c8e  51c8 fffc            61$:	dbra	d0,60$
1281  0c92  12d8                 	movb	(a0)+,(a1)+
1282  0c94  6000 0088            	jra	copypop		| pop regs and return
1283                             			
1284                             				| one even the other odd
1285                             
1286                             | For the case where one number is even, the other odd,
1287                             | we cannot just use one big dbra loop.  This is because
1288                             | the dbra instruction operates only on the low order
1289                             | word of a register, not on the long register.  This
1290                             | makes certain gyrations necessary:
1291                             70$:
1292  0c98  4840                 	swap	d0		| get high word of register into low word
1293  0c9a  72ff                 	moveq	#-1,d1		| initialize d1 with FFFF
1294  0c9c  6006                 	bras	72$		| transfer 64K bytes some no. of times
1295                             
1296                             
1297                             71$:				| d1 holds FFFF, will transfer FFFF+1 bytes
1298  0c9e  12d8                 	movb	(a0)+,(a1)+	| transfer byte
1299  0ca0  51c9 fffc            	dbra	d1,71$		| loop each of the 64K bytes
1300                             				| fall out of inner loop with FFFF in d1
1301                             
1302  0ca4  51c8 fff8            72$:	dbra	d0,71$		| outer loop, 64K per iteration
1303                             
1304  0ca8  4840                 	swap	d0		| get back low order half of d0
1305  0caa  6002                 	bras	74$		| enter loop at bottom for proper iteration
1306                             
1307  0cac  12d8                 73$:	movb	(a0)+,(a1)+	| transfer byte
1308  0cae  51c8 fffc            74$:	dbra	d0,73$		| loop for each byte
1309  0cb2  606a                 	jra	copypop		| pop regs and return
1310                             	
1311                             
1312                             | From address < To address: copy from hi byte first
1313                             
1314                             copyup:
1315  0cb4  d1c0                 	addl	d0,a0		| pointer past end of from region
1316  0cb6  d3c0                 	addl	d0,a1		| pointer past end of to region
1317                             
1318                             | If both from and to are odd, move one byte and proceed to even code
1319                             | But if one is even and the other odd proceed to the bytewise move
1320                             
1321  0cb8  2408                 	movl	a0,d2		| get addr in data reg so btst can work
1322  0cba  2609                 	movl	a1,d3		|
1323  0cbc  7800                 	moveq	#0,d4		| clear d4 for use in btst instructions
1324  0cbe  0902                 	btst	d4,d2		| test from bit 0
1325  0cc0  670a                 	jeq	1$		| from even
1326  0cc2  0903                 	btst	d4,d3		| test to bit 0
1327  0cc4  673e                 	jeq	80$		| to even but from odd
1328                             
1329                             				| both odd
1330  0cc6  1320                 	movb	-(a0),-(a1)	| move one byte
1331  0cc8  5380                 	subql	#1,d0		| cnt--
1332  0cca  6004                 	jra	2$
1333                             
1334                             1$:				| from even
1335  0ccc  0903                 	btst	d4,d3		| test to bit 0
1336  0cce  6634                 	jne	80$		| from even but to odd
1337                             
1338                             2$:				| both even
1339  0cd0  722c                 	moveq	#44.,d1		| use d1 to hold the constant
1340  0cd2  b081                 	cmpl	d1,d0		| might we be doing a moveml?
1341  0cd4  6f16                 	jle	5$		| no: jump around moveml loop (see note below)
1342  0cd6  3320                 	movw	-(a0),-(a1)	| yes: move 1 word because of moveml funniness
1343  0cd8  5580                 	subql	#2,d0		| indicate word moved in bytecount register
1344                             3$:
1345  0cda  9081                 	subl	d1,d0		| subtract number of bytes to sub
1346  0cdc  6d0c                 	jlt	4$		| if too few bytes, go to word-at-a-time
1347                             |*** Note that the moveml instruction generates an extra memory
1348                             |*** access; to avoid unexpected memory faults, we must have assured
1349                             |*** that the first transfer instruction is not a moveml.
1350                             
1351  0cde  91c1                 	subl	d1,a0		| move back from pointer
1352  0ce0  4cd0 7cfc            	moveml	(a0),#/7cfc	| load 44 bytes
1353  0ce4  48e1 3f3e            	moveml	#/3f3e,-(a1)	| store 44 bytes
1354  0ce8  60f0                 	jra	3$		| loop
1355                             
1356                             4$:				| -44 <= d0 < 0
1357  0cea  d081                 	addl	d1,d0		| get back real byte count
1358                             
1359                             5$:				| fewer than 44 bytes to go
1360  0cec  e280                 	asrl	#1,d0		| convert to word count
1361  0cee  650c                 	jcs	71$		| if byte-count was odd, C-bit set
1362  0cf0  6002                 	jra	61$		| for proper iteration, enter end of loop
1363                             
1364  0cf2  3320                 60$:	movw	-(a0),-(a1)	| move word
1365  0cf4  51c8 fffc            61$:	dbra	d0,60$		| while words left
1366  0cf8  6024                 	jra	copypop		| pop regs and return
1367                             
1368  0cfa  3320                 70$:	movw	-(a0),-(a1)	| move words, then 1 byte at end
1369  0cfc  51c8 fffc            71$:	dbra	d0,70$
1370  0d00  1320                 	movb	-(a0),-(a1)
1371  0d02  601a                 	jra	copypop
1372                             
1373                             				| one even the other odd
1374                             
1375                             | For the case where one number is even, the other odd,
1376                             | we cannot just use one big dbra loop.  This is because
1377                             | the dbra instruction operates only on the low order
1378                             | word of a register, not on the long register.  This
1379                             | makes certain gyrations necessary:
1380                             80$:
1381  0d04  4840                 	swap	d0		| get high word of register into low word
1382  0d06  72ff                 	moveq	#-1,d1		| initialize d1 with FFFF
1383  0d08  6006                 	bras	82$		| transfer 64K bytes some no. of times
1384                             
1385                             
1386                             81$:				| d1 holds FFFF, will transfer FFFF+1 bytes
1387  0d0a  1320                 	movb	-(a0),-(a1)	| transfer byte
1388  0d0c  51c9 fffc            	dbra	d1,81$		| loop each of the 64K bytes
1389                             				| fall out of inner loop with FFFF in d1
1390                             
1391  0d10  51c8 fff8            82$:	dbra	d0,81$		| outer loop, 64K per iteration
1392                             
1393  0d14  4840                 	swap	d0		| get back low order half of d0
1394  0d16  6002                 	bras	84$		| enter loop at bottom for proper iteration
1395                             
1396  0d18  1320                 83$:	movb	-(a0),-(a1)	| transfer byte
1397  0d1a  51c8 fffc            84$:	dbra	d0,83$		| loop for each byte
1398                             
1399                             copypop:
1400  0d1e  4cdf 7cfc            	moveml	(sp)+,#/7cfc	| restor reg d2-d7 and a2-a6
1401                             copyend:
1402  0d22  7000                 	moveq	#0,d0
1403  0d24  4e75                 	rts
1404                             
1405                             |***
1406                             |***	CLEARBUF	- zero a region of physical memory
1407                             |***
1408                             |***		This code will work for any combination of (even, odd)
1409                             |***		address and bytecount.  The code is rather inefficient
1410                             |***		for small buffers, though.
1411                             |***
1412                             |***		NOTE: because of the way the dbra instruction is used,
1413                             |***		this code will only work for bytecount < 256 * 64K;
1414                             |***		bytecount must be less than 16 Megabytes.
1415                             |***
1416                             	.globl	_clear
1417                             	.globl	_clearbu
1418                             	.globl	_clearbuf
1419                             _clearbuf:			| clearbuf(addr, nbytes)
1420                             _clearbu:
1421                             _clear:
1422  0d26  202f 0008            	movl	8(sp),d0	| nbytes
1423  0d2a  6700 0086            	jeq	9$		| no bytes to clear -- done
1424  0d2e  206f 0004            	movl	4(sp),a0	| addr
1425  0d32  48e7 3f3e            	moveml	#/3f3e,-(sp)	| save regs d2-d7,a2-a6
1426                             
1427  0d36  7400                 	moveq	#0,d2		| code *depends* on d2 being 0
1428                             
1429  0d38  d1c0                 	addl	d0,a0		| point after clear region
1430  0d3a  2208                 	movl	a0,d1		| get into data register for btst
1431  0d3c  0501                 	btst	d2,d1		| is address odd?
1432  0d3e  6700 0006            	beq	1$		| no: branch to code for even address
1433                             				| yes: odd address
1434  0d42  1102                 	movb	d2,-(a0)	| clear one byte
1435  0d44  5380                 	subql	#1,d0		| decrement byte count
1436                             
1437                             1$:				| even address
1438  0d46  7630                 	moveq	#48,d3		|<1>
1439  0d48  b083                 	cmpl	d3,d0		|<1>quick check for small transfers
1440                             |<1>	cmpl	#48,d0		| quick check for small transfer
1441  0d4a  6d4c                 	jlt	35$		| don't bother clearing registers!
1442                             
1443  0d4c  2202                 	movl	d2,d1		| clear registers to be used for mem clearing
1444  0d4e  2601                 	movl	d1,d3
1445  0d50  2801                 	movl	d1,d4
1446  0d52  2a01                 	movl	d1,d5
1447  0d54  2c01                 	movl	d1,d6
1448  0d56  2e01                 	movl	d1,d7
1449  0d58  2241                 	movl	d1,a1
1450  0d5a  2441                 	movl	d1,a2
1451  0d5c  2641                 	movl	d1,a3
1452  0d5e  2841                 	movl	d1,a4
1453  0d60  2a41                 	movl	d1,a5
1454  0d62  2c41                 	movl	d1,a6
1455                             
1456  0d64  2f00                 	movl	d0,-(sp)	| save byte count
1457  0d66  e088                 	lsrl	#8,d0		| divide by 256
1458  0d68  6014                 	jra	16$
1459                             
1460  0d6a  48e0 7f7e            15$:	moveml	#/7f7e,-(a0)	| clear 52 bytes
1461  0d6e  48e0 7f7e            	moveml	#/7f7e,-(a0)	| 	+ 52 = 104
1462  0d72  48e0 7f7e            	moveml	#/7f7e,-(a0)	| 	+ 52 = 156
1463  0d76  48e0 7f7e            	moveml	#/7f7e,-(a0)	| 	+ 52 = 208
1464  0d7a  48e0 3f7e            	moveml	#/3f7e,-(a0)	|	+ 48 = 256
1465  0d7e  51c8 ffea            16$:	dbra	d0,15$		| loop to clear 256 bytes
1466                             
1467  0d82  201f                 	movl	(sp)+,d0	| pop back byte count
1468                             |<1>	andl	#/FF,d0		|(16) adjust for large transfer just completed
1469  0d84  0240 00ff            	andw	#/ff,d0		|<1>(8) adjust for large xfer just completed
1470  0d88  48c0                 	extl	d0		|<1>(4) make long
1471                             	
1472  0d8a  7230                 	moveq	#48,d1		| number of bytes transferred in next loop
1473                             
1474  0d8c  9081                 2$:	subl	d1,d0		| subtract number of bytes cleared/iteration
1475  0d8e  6d06                 	jlt	3$		| if result < 0, then proceed to slow loop
1476  0d90  48e0 3f7e            	moveml	#/3f7e,-(a0)	| clear memory
1477  0d94  60f6                 	jra	2$		| loop
1478                             
1479  0d96  d081                 3$:	addl	d1,d0		| get back number of bytes left to clear
1480                             
1481  0d98  e280                 35$:	asrl	#1,d0		| convert to word count
1482  0d9a  650c                 	jcs	7$		| carry set indicates odd byte
1483  0d9c  6002                 	jra	5$		| enter loop at bottom for proper indexing
1484                             
1485  0d9e  3102                 4$:	movw	d2,-(a0)	| clear word
1486  0da0  51c8 fffc            5$:	dbra	d0,4$		| loop for all words
1487  0da4  6008                 	jra	8$		| done -- there is no odd byte
1488                             
1489  0da6  3102                 6$:	movw	d2,-(a0)	| clear word
1490  0da8  51c8 fffc            7$:	dbra	d0,6$		| loop for all words
1491  0dac  1102                 	movb	d2,-(a0)	| clear odd byte at beginning
1492                             
1493  0dae  4cdf 7cfc            8$:	moveml	(sp)+,#/7cfc	| restore regs d2-d7,a2-a6
1494  0db2  4e75                 9$:	rts
1495                             
1496                             
1497                             |***
1498                             |***	HALTCPU	- stop cpu
1499                             |***				M002  And stop the z80 & hard drives
1500                             |***
1501                             	.globl	_haltcpu
1502                             _haltcpu:
1503  0db4  46fc 2700            	movw	#NOINTR,sr	| lock out all interrupts
1504  0db8  4eb9 0000 0000       	jbsr	_zhalt		| M002  Ask z80 to shutdown
1505  0dbe  46fc 2700            1$:	movw	#NOINTR,sr	| M002  Added extra DI just-in-case...
1506  0dc2  60fa                 	bras	1$		| M002  Stop. Now.
1507                             
1508                             
1509                             |***	BEGIN M000...
1510                             |***
1511                             |***	Z80INTR	- interrupt the z80
1512                             |***
1513                             	.globl	_z80intr
1514                             _z80intr:
1515  0dc4  33c0 0078 00d6       	movw	d0,Z80IADDR	| I/O latch interrupts z80 on access
1516  0dca  4e75                 	rts
1517                             
1518                             |***	...END M000
1519                             
1520                             
1521                             |***
1522                             |***	FUBYTE,FUIBYTE,FUSHORT,FUISHORT,FUWORD,FUIWORD	- From User
1523                             |***	WORK IN PROGRESS
1524                             	.globl	_fubyte,_fuibyte,_fushort,_fuishor,_fuishort,_fuword,_fuiword
1525                             
1526                             _fubyte:			| fu(i)byte(user_addr)
1527                             _fuibyte:
1528  0dcc  206f 0004            	movl	4(sp),a0
1529  0dd0  7001                 	moveq	#1,d0
1530  0dd2  6100 00c6            	jbsr	umap
1531  0dd6  6504                 	jcs	1$
1532                             
1533  0dd8  7000                 	moveq	#0,d0
1534  0dda  1010                 	movb	(a0),d0
1535  0ddc  4e75                 1$:	rts
1536                             	
1537                             _fushort:
1538                             _fuishor:			| fu(i)short(user_addr)
1539                             _fuishort:
1540  0dde  206f 0004            	movl	4(sp),a0
1541  0de2  7002                 	moveq	#2,d0
1542  0de4  6100 00b4            	jbsr	umap
1543  0de8  650e                 	jcs	2$
1544  0dea  2208                 	movl	a0,d1
1545                             
1546  0dec  7000                 	moveq	#0,d0			| cleared d0 used twice:
1547  0dee  0101                 	btst	d0,d1			| test low order bit
1548  0df0  6704                 	jeq	1$
1549  0df2  70ff                 	moveq	#-1,d0
1550  0df4  6002                 	jra	2$
1551  0df6  3010                 1$:	movw	(a0),d0			| result zero-extended by earlier clr
1552  0df8  4e75                 2$:	rts
1553                             	
1554                             _fuword:			| fu(i)word(user_addr)
1555                             _fuiword:
1556  0dfa  206f 0004            	movl	4(sp),a0
1557  0dfe  7004                 	moveq	#4,d0
1558  0e00  6100 0098            	jbsr	umap
1559  0e04  650e                 	jcs	2$
1560  0e06  2208                 	movl	a0,d1
1561  0e08  0801 0000            	btst	#0,d1
1562  0e0c  6704                 	jeq	1$
1563  0e0e  70ff                 	moveq	#-1,d0
1564  0e10  6002                 	jra	2$
1565  0e12  2010                 1$:	movl	(a0),d0
1566  0e14  4e75                 2$:	rts
1567                             
1568                             |***
1569                             |***	SUBYTE,SUIBYTE,SUSHORT,SUISHORT,SUWORD,SUIWORD	- Set User
1570                             |***
1571                             	.globl	_subyte,_suibyte,_sushort,_suishor,_suishort,_suword,_suiword
1572                             
1573                             _subyte:			| su(i)byte(user_addr,byte)
1574  0e16  206f 0004            	movl	4(sp),a0
1575  0e1a  7001                 	moveq	#1,d0
1576  0e1c  616e                 	jbsr	udmap
1577  0e1e  6008                 	jra	subytecom
1578                             _suibyte:
1579  0e20  206f 0004            	movl	4(sp),a0
1580  0e24  7001                 	moveq	#1,d0
1581  0e26  6172                 	jbsr	umap
1582                             subytecom:
1583  0e28  654a                 	jcs	suret
1584  0e2a  10af 000b            	movb	11(sp),(a0)
1585  0e2e  6042                 	jra	suok
1586                             
1587                             _sushort:			| su(i)short(user_addr,word)
1588  0e30  206f 0004            	movl	4(sp),a0	| user_address
1589  0e34  7002                 	moveq	#2,d0
1590  0e36  6154                 	jbsr	udmap
1591  0e38  6008                 	jra	sushortcom
1592                             
1593                             _suishor:
1594                             _suishort:
1595  0e3a  206f 0004            	movl	4(sp),a0	| user_address
1596  0e3e  7002                 	moveq	#2,d0
1597  0e40  6158                 	jbsr	umap
1598                             sushortcom:
1599  0e42  6530                 	jcs	suret
1600  0e44  2208                 	movl	a0,d1
1601  0e46  0801 0000            	btst	#0,d1
1602  0e4a  662a                 	jne	suerr
1603  0e4c  30af 000a            	movw	10(sp),(a0)
1604  0e50  6020                 	jra	suok
1605                             
1606                             _suword:			| su(i)word(user_addr,long)
1607  0e52  206f 0004            	movl	4(sp),a0	| user_address
1608  0e56  7004                 	moveq	#4,d0
1609  0e58  6132                 	jbsr	udmap
1610  0e5a  6008                 	jra	suwordcom
1611                             _suiword:
1612  0e5c  206f 0004            	movl	4(sp),a0	| user_address
1613  0e60  7004                 	moveq	#4,d0
1614  0e62  6136                 	jbsr	umap
1615                             suwordcom:
1616  0e64  650e                 	jcs	suret
1617  0e66  2208                 	movl	a0,d1
1618  0e68  0801 0000            	btst	#0,d1
1619  0e6c  6608                 	jne	suerr
1620                             
1621  0e6e  20af 0008            	movl	8(sp),(a0)
1622                             suok:
1623  0e72  7000                 	moveq	#0,d0
1624                             suret:
1625  0e74  4e75                 	rts
1626                             suerr:
1627  0e76  70ff                 	moveq	#-1,d0
1628  0e78  4e75                 	rts
1629                             
1630                             
1631                             |***
1632                             |***	UMAP -- check if address and nbytes given actually resides
1633                             |***		in current user's address space.  If so, return with user
1634                             |***		logical address replaced by physical address, and carry
1635                             |***		bit clear.
1636                             |***		If not, return with d0 = -1, and carry bit set.
1637                             |***	
1638                             |***	UDMAP -- like UMAP, but considers any access to text segment to
1639                             |***		an error.  Used by subyte, sushort, suword, copyout.
1640                             |***
1641                             |***	Arguments:	d0:	nbytes
1642                             |***			a0:	logical address
1643                             |***	Results:	Success:
1644                             |***				a0: physical address
1645                             |***				d0: nbytes (unchanged)
1646                             |***				carry bit clear
1647                             |***			Error:
1648                             |***				a0: undefined
1649                             |***				d0: -1
1650                             |***				carry bit set
1651                             |***
1652                             |***	Uses:		d1,a1
1653                             |***
1654                             |***	Note:		This routine returns with  -1 in d0 so that its
1655                             |***			callers need take no special action to indicate
1656                             |***			an error to their callers.
1657                             |***
1658                             
1659                             
1660                             |***	BEGIN M001...
1661                             
1662                             |***	caddr_t  umap(addr, count)
1663                             |***	  caddr_t	addr;
1664                             |***	  int		count;
1665                             |***
1666                             	.globl	_umap
1667                             _umap:
1668  0e7a  206f 0004            	movl	4(sp),a0
1669  0e7e  202f 0008            	movl	8(sp),d0
1670  0e82  6116                 	jbsr	umap
1671  0e84  6500 0004            	bcs	1$			| Skip the move if carry flag
1672  0e88  2008                 	movl	a0,d0			|   is set (error), -1 already in d0
1673  0e8a  4e75                 1$:	rts
1674                             
1675                             |***	...END M001
1676                             
1677                             
1678  0e8c  2208                 udmap:	movl	a0,d1			| address into d register for btst
1679  0e8e  0801 0017            	btst	#23,d1			| is this a text reference?
1680  0e92  671c                 	jeq	umaplow			| no: use low segment
1681                             					| yes: fall thru to error return
1682                             
1683                             umaperr:
1684  0e94  70ff                 	moveq	#-1,d0			| error return, set up d0
1685  0e96  44c0                 	movw	d0,cc			| indicate error
1686  0e98  4e75                 	rts
1687                             
1688                             umap:
1689  0e9a  2208                 	movl	a0,d1			| address into d register for btst
1690  0e9c  0801 0017            	btst	#23,d1			| is this a text reference?
1691  0ea0  670e                 	jeq	umaplow			| no: use low segment
1692                             
1693  0ea2  227c 0000 0f66       	movl	#mmuhi,a1		| yes: ptr to hi seg registers in a1
1694  0ea8  0881 0017            	bclr	#23,d1			|	clear hi seg bit
1695  0eac  2041                 	movl	d1,a0			|	replace given address
1696  0eae  6006                 	jra	umapcom			|	and continue with work
1697                             umaplow:
1698  0eb0  227c 0000 0f6a       	movl	#mmulo,a1		| ptr to lo seg registers in a1
1699                             
1700                             umapcom:
1701  0eb6  4a80                 	tstl	d0			| test bytecount
1702  0eb8  673c                 	jeq	umapok			| bytecount of 0, indicate OK
1703  0eba  6dd8                 	jlt	umaperr			| negative bytecount--error
1704                             |<1>	asrl	#SHIFT1,d1		| convert to page
1705                             |<1>	asrl	#SHIFT2,d1		|	number
1706                             |<1>	The following should do the same thing
1707  0ebc  e999                 	roll	#4,d1			|<1>(16)
1708  0ebe  0241 000f            	andw	#/000f,d1		|<1>(8)
1709  0ec2  4841                 	swap	d1			|<1>(4)
1710                             
1711  0ec4  d269 0002            	addw	2(a1),d1		| add offset register
1712  0ec8  0801 000b            	btst	#11,d1			| Did add overflow 11 bit MMU range?
1713  0ecc  66c6                 	jne	umaperr			| if carry produced, then error
1714                             
1715  0ece  b251                 	cmpw	(a1),d1			| compare with limit register
1716  0ed0  62c2                 	jhi	umaperr			| if (pageno > limit reg) then error
1717                             
1718  0ed2  0c80 0000 1000       	cmpl	#PAGESIZE,d0		| if bytecount is <= 1 page
1719  0ed8  6f1c                 	jle	umapok			|	then done with verification
1720                             
1721  0eda  2208                 	movl	a0,d1			| starting address
1722  0edc  d280                 	addl	d0,d1			| + bytecount
1723  0ede  5381                 	subql	#1,d1			| - 1
1724                             |<1>	asrl	#SHIFT1,d1		| convert to page
1725                             |<1>	asrl	#SHIFT2,d1		|	number
1726                             |<1>	The following should do the same thing
1727  0ee0  e999                 	roll	#4,d1			|<1>(16)
1728  0ee2  0241 000f            	andw	#/000f,d1		|<1>(8)
1729  0ee6  4841                 	swap	d1			|<1>(4)
1730                             
1731  0ee8  d269 0002            	addw	2(a1),d1		| add offset register
1732  0eec  0801 000b            	btst	#11,d1			| Did add overflow 11 bit MMU range?
1733  0ef0  66a2                 	jne	umaperr			| if carry produced, then error
1734                             
1735  0ef2  b251                 	cmpw	(a1),d1			| compare with limit register
1736  0ef4  629e                 	jhi	umaperr			| if (pageno > limit reg) then error
1737                             
1738                             umapok:
1739  0ef6  3229 0002            	movw	2(a1),d1		| no error: take page offset
1740                             |<1>	asll	#SHIFT1,d1		| convert to
1741                             |<1>	asll	#SHIFT2,d1		|	bytecount
1742                             |<1>	Believe it or not, the following is equivalent.  Here is what happens:
1743                             |<1>	31 30 29 28 ... 18 17 16 | 15 14 13 ... 5  4  3  2  1  0
1744                             |<1>	3  2  1  0  31 30 29 ...  21 20 | 19 18 17 16  ... 6  5  4
1745                             |<1>	19 18 17 16 ... 6  5  4 | 3  2  1  0 31 30 29 ... 22 21 20
1746                             |<1>    19 18 17 16 ... 6  5  4 | 3  2  1  0 - - - - - - - - - - - - 
1747                             |<1>	Cute, eh?  saves 12 clocks - fdiv
1748                             
1749  0efa  e899                 	rorl	#4,d1		|<1>(16)Rotate right four bits
1750  0efc  4841                 	swap	d1		|<1>(4)
1751  0efe  0241 f000            	andw	#/f000,d1	|<1>(8)Zero lower 12 bits
1752                             
1753                             
1754  0f02  d1c1                 	addl	d1,a0			| and add to get physical addr
1755  0f04  44fc 0000            	movw	#0,cc			| clear condition codes for return
1756  0f08  4e75                 	rts
1757                             
1758                             
1759                             |***
1760                             |***	COPYIN/OUT	in and out of system space (from/to user space)
1761                             |***
1762                             |***		The current implementations is somewhat of a hack
1763                             |***		and depends on the arguments to copybuf corresponding
1764                             |***		to those to these routines.  We verify that the requested
1765                             |***		transfer involves entirely valid user address, replace
1766                             |***		the user address argument with a physical address, and
1767                             |***		use copybuf to do the actual copying.
1768                             |***
1769                             |***		The current implementation works for any combination
1770                             |***		of odd and even args.
1771                             |***
1772                             |***		The code here depends upon copybuf returning 0.
1773                             |***
1774                             	.globl	_copyin,_copyiin,_copyout,_copyiout,_copyiou
1775                             |***	copyin(user_address, kernel_address, nbytes)
1776                             |***	copyiin(user_address, kernel_address, nbytes)
1777                             |***	copyout(kernel_address, user_address, nbytes)
1778                             |***	copyiout(kernel_address, user_address, nbytes)
1779                             _copyin:
1780                             _copyiin:
1781  0f0a  206f 0004            	movl	4(sp),a0		| user-address
1782  0f0e  202f 000c            	movl	12(sp),d0		| byte-count
1783  0f12  6186                 	jbsr	umap			| map and verify user address
1784  0f14  6508                 	jcs	cperr			| error: return
1785  0f16  2f48 0004            	movl	a0,4(sp)		| replace logical addr w/physical
1786  0f1a  6000 fd18            	jra	_copybuf		| use copybuf to do the copy!
1787                             
1788  0f1e  4e75                 cperr:	rts
1789                             
1790                             _copyout:
1791  0f20  206f 0008            	movl	8(sp),a0		| user-address
1792  0f24  202f 000c            	movl	12(sp),d0		| byte-count
1793  0f28  6100 ff62            	jbsr	udmap			| map and verify user address
1794  0f2c  600c                 	jra	cpyoutcom		| common copy(i)out code
1795                             
1796                             _copyiout:
1797                             _copyiou:
1798  0f2e  206f 0008            	movl	8(sp),a0		| user-address
1799  0f32  202f 000c            	movl	12(sp),d0		| byte-count
1800  0f36  6100 ff62            	jbsr	umap			| map and verify user address
1801                             cpyoutcom:
1802  0f3a  65e2                 	jcs	cperr			| error: return
1803  0f3c  2f48 0008            	movl	a0,8(sp)		| replace logical addr w/physical
1804  0f40  6000 fcf2            	jra	_copybuf		| use copybuf to do the copy!
1805                             
1806                             
