/*
 *	%Z% %M% %I% %D% %Q%
 */




/*
 * THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
 * M68000 CPU. IT MAY REQUIRE CHANGING WHEN MOVING
 * XENIX TO A MACHINE CONTAINING A DIFFERENT CPU.
 */



/*
 * Location of the users' stored
 * registers relative to R0.
 * Usage is u.u_ar0[XX].
 * EVERYTHING HERE IS DEPENDENT ON trap: in mch.s and trap.c
 * AND THE HARDWARE
 */

#define	D0	0
#define	D1	1
#define	D2	2
#define	D3	3
#define	D4	4
#define	D5	5
#define	D6	6
#define	D7	7

#define	A0	8
#define	A1	9
#define	A2	10
#define	A3	11
#define	A4	12
#define	A5	13
#define	A6	14
#define	A7	15			/* only holds user's a7 */
#define	USP	15

#define	MMU	16
#define SR	17
#define UPC	18

/* Status reg values (used in trap.c) */

#define SR_TRACE	0x8000		/* Trace Mode Bit */
#define	SR_SUPER	0x2000		/* SUpervisor State Bit */
#define SR_IMASK	0x0700		/* Interrupt Mask */

#define SR_USER		0x00ff		/* User byte of SR */
#define SR_EXTEND	0x0010		/* Extend Condition Bit */
#define SR_NEGATIVE	0x0008		/* Negative Condition Bit */
#define SR_ZERO		0x0004		/* Zero Condition Bit */
#define SR_OVERFLOW	0x0002		/* Overflow Condition Bit */
#define SR_CARRY	0x0001		/* Carry Condition Bit */
