/*****************************************

z80intr.h -- Interface to z80 interrupt ID register

Copyright (C) Tandy Corporation, 1983.

This file must be kept consistent with z80/ctl/68kdefs.h

******************************************

The interrupt ID register is a serial array in shared RAM with bytes
defined to tell the 68k which device is interrupting on the CONT5 or
CONT6 interrupt.  When TRS-XENIX is configured [see config(1)], each 
device that gets interrupts is assigned to the CONT5 (higher priority) 
or the CONT6 (lower priority) interrupt in the /usr/sys/conf/master file,
and config sets up c.c to poll EACH device's interrupt routine when it
gets a cont5 or cont6 interrupt.  It is up to each interrupt routine to
determine if a given interrupt was for it.

This module's existance is keyed on the define symbol Z80INTR

****/

/* Defines for bits in z80int_ID (for CONT5) */
#define	SERINT	0x00
#define	GRINT	0x01
/*#define	LPINT	0x02*/

/* Defines for bits in z80int_ID (for CONT6) */
#define	FDINT	0x02
#define	HDINT	0x03
#define	MTINT	0x04

/* The interrupt ID register itself */
unsigned char	z80int_ID[4];
