#include "../h/param.h"
#include "../h/tty.h"

/*
 * Return count of characters in cblock
 * pointed to by q->c_cf.
 * Stop counting if (flag&char) != 0
 */
ndqb(q, flag)
  register struct clist *q;
  register flag;
{
	register char	fp, bp, cp, *dp, nbytes;

	fp = q->c_cf->c_first;
	bp = q->c_cf->c_last;
	nbytes = bp - fp;

	if (flag == 0)
		return (nbytes);
	
	cp = fp;
	dp = &q->c_cf->c_data[fp];
	while (cp < bp  &&  !(*dp++ & flag))
		++cp;
	return (cp - fp);
}

/*
 * Flush cc bytes from q.
 */
ndflush(q, cc)
  register struct clist *q;
  register cc;
{
	register struct cblock	*cbp;
	register 	char	nbytes;
	register int	s;

	if (q->c_cc == 0)
		return;

	s = spl6();
	while (cc > 0  &&  q->c_cc > 0) {
		nbytes = q->c_cf->c_last - q->c_cf->c_first;
		if (cc >= nbytes) {
			cbp = getcb(q);	   /* getcb() updates q->c_cc for us */
			if (cbp == (struct cblock *)NULL)
				panic("ndflush");
			putcf(cbp);
			cc -= nbytes;
		}
		else {
			q->c_cf->c_first += cc;
			q->c_cc -= cc;
			cc = 0;
		}
	}
	splx(s);
}
