/*
 *  "z80attn.c"     68000/XENIX interface to the z80 attention queue
 *
 *   Copyright 1986 Tandy Corporation
 *
 *	06/24/1983	jeIV 
 */


#include  "../h/z80attn.h"


z80attn(maj, min, cmd)
  register unsigned char  maj;
  register unsigned char  min;
  register unsigned char  cmd;
{
	register struct atn_q_entry	*qp;
	register struct req_fifo	*rqp;
	register unsigned char  rear;
	register unsigned char  rearevt;
	int	s;

	s = spl7();

	rqp = &z80req_fifo;
	rearevt = rqp->rear + 1;
	rear = rearevt & REQFIFOSIZE-1;
	if (rear == rqp->front)
		goto out;

	qp = &rqp->q[rear];
	qp->dev = maj | min;
	qp->cmd = cmd;
/*
 *  ATTENTION!  Note that the event was not updated until the actual
 *		item was placed into the queue.  THIS IS IMPORTANT.
 *		Otherwise, it is possible (however unlikely) that the
 *		z80 could attempt to load the supposedly queued item
 *		before we have placed it there.
 */
	rqp->rear = rearevt;
	z80intr();

   out:
	splx(s);
}

#ifdef fooNEVER
z80intr()
{
	/* Doesn't matter what we write to 0x7800D6, just
	 *   accessing the address interrupts the Z80 */
	asm("	movw	d0,/7800D6");
}
#endif /*fooNEVER*/
