/*
 *  "z80init.c"     C interface for mch.s to initialize z80 structures
 *
 *   Copyright 1986 Tandy Corporation
 *
 *	21 May 1986	jeIV 
 */

#include  "../h/param.h"
#include  "../h/systm.h"
#include  "../h/z80attn.h"
#include  "../h/z80boot.h"
#include  "../h/z80halt.h"
#include  "../h/z80msgbuf.h"


unsigned char	hdpark = 0,	/* Global flag to be set by drive command */
		reboot = 0xFF;	/* Global flag to be set by the user */


z80init()
{
	/* Initialize the z80 attention queue */
	z80req_fifo.rear = 0;
	z80req_fifo.front = 0;

	/* Initialize the z80 message queue */
	z80msgbuf.zm_front = 0;
	z80msgbuf.zm_back = 0;
	z80msgbuf.zm_6front = 0;

	/* Initialize the z80 HALT arming byte to a safe value */
	z80halt = 0;
}

z80reboot()
{
	int	action = ZB_HALT;

	/*  reboot == 0xFF means ignore reboot feature; always manually boot.
	 *  This way, our installation stuff won't try to auto-boot and fail
	 *  miserably */

	if (reboot != 0xFF) {
		/* Check the boot/reboot byte; if we're auto-booting, we
		 *   need to change the arg that icode is going to hand
		 *   to /etc/init (default is a manual boot). */
		if (z80boot.zb_reboot)
			ricodech();	/* Reboot-icode-change */
		
		/* Finally, set zb_reboot to ZB_REBOOT if 
		 *   the user wishes to reboot on a crash. */
		if (reboot)
			action = ZB_REBOOT;
	} else
		reboot = 0;

	z80boot.zb_reboot = action;
}
