/*
 *	@(#) sys/sysent.c 1.1 83/10/23 Copyright Microsoft Corporation, 1983
 *
 *  $Header: sysent.c,v 6.0 87/10/12 17:10:20 iv Exp $
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS DESIGNED TO BE
 * PORTABLE BETWEEN DIFFERENT MACHINE ARCHITECHTURES
 * AND CONFIGURATIONS. IT SHOULD NOT REQUIRE ANY
 * MODIFICATIONS WHEN ADAPTING XENIX TO NEW HARDWARE.
 *
 * $Log:	sysent.c,v $
 * Revision 6.0  87/10/12  17:10:20  iv
 * 	- Checkin to lock down 3.2
 * 
 * Revision 5.0  85/08/23  10:37:25  iv
 * 	- Checkin to lock down XENIX 3.1 release
 * 
 * Revision 4.0  85/03/13  14:50:19  iv
 * 	- Checkin to lock down XENIX 3.0(28) release
 * 
 * Revision 3.0  85/01/17  15:44:57  iv
 * 	- Checkin to save XENIX v3.0(23)
 * 
 * Revision 2.0  85/01/10  13:24:00  iv
 * Checkin to save XENIX 3.0(22)
 * 
 * Revision 0.1  84/05/17  15:50:39  iv
 * 	- The NULLP "#define NULLP ((int (*)())0)" macro was changed
 *	  to cast a value "x" to pointer-to-function-returning-int:
 * 	  #define p(x)  ((int (*)())x)
 * 	  No one here knows why they did this.  *sigh*   Oh, well.
 * 	  Hope they didn't break anything on our port.  They didn't 
 * 	  document this one at all.  Just changed it...
 */


#include "../h/param.h"
#include "../h/systm.h"

#define p(x) ((int (*)())x)

/*
 * This table is the switch used to transfer
 * to the appropriate routine for processing a system call.
 * Each row contains the number of arguments expected
 * and a pointer to the routine.
 */

int	alarm();
int	chdir();
int	chmod();
int	chown();
int	chroot();
int	close();
int     clocal();
int     cxenix();
int	creat();
int	dup();
int	exec();
int	exece();
int	fcntl();
int	fork();
int	fstat();
int     ftime();
int	getgid();
int	getpid();
int	getuid();
int	gtime();
int	gtty();
int	ioctl();
int	kill();
int	link();
int     lock();
int	mknod();
int	nice();
int	nosys();
int	nullsys();
int	open();
int	pause();
int	pipe();
int	profil();
int	ptrace();
int	read();
int	rexit();
int	saccess();
int	sbreak();
int	seek();
int	setgid();
int	setpgrp();
int	setuid();
int	smount();
int	ssig();
int	stat();
int	stime();
int	stty();
int	sumount();
int	sync();
int	sysacct();
int	times();
int	ulimit();
int	umask();
int	unlink();
int	utime();
int	utssys();
int	wait();
int	write();

struct sysent sysent[] =
{
	0, 0, nosys,			/*  0 = indir */
	1, 1, rexit,			/*  1 = exit */
	0, 0, fork,			/*  2 = fork */
	3, 1, read,			/*  3 = read */
	3, 1, write,			/*  4 = write */
	3, 0, open,			/*  5 = open */
	1, 1, close,			/*  6 = close */
	0, 0, wait,			/*  7 = wait */
	2, 0, creat,			/*  8 = creat */
	2, 0, link,			/*  9 = link */
	1, 0, unlink,			/* 10 = unlink */
	2, 0, exec,			/* 11 = exec */
	1, 0, chdir,			/* 12 = chdir */
	0, 0, gtime,			/* 13 = time */
	3, 0, mknod,			/* 14 = mknod */
	2, 0, chmod,			/* 15 = chmod */
	3, 0, chown,			/* 16 = chown; now 3 args */
	1, 0, sbreak,			/* 17 = break */
	2, 0, stat,			/* 18 = stat */
	4, 1, seek,			/* 19 = seek; now 3 args */
	0, 0, getpid,			/* 20 = getpid */
	3, 0, smount,			/* 21 = mount */
	1, 0, sumount,			/* 22 = umount */
	1, 1, setuid,			/* 23 = setuid */
	0, 0, getuid,			/* 24 = getuid */
	2, 2, stime,			/* 25 = stime */
	4, 1, ptrace,			/* 26 = ptrace */
	1, 1, alarm,			/* 27 = alarm */
	2, 1, fstat,			/* 28 = fstat */
	0, 0, pause,			/* 29 = pause */
	2, 0, utime,			/* 30 = utime */
	2, 1, stty,			/* 31 = stty */
	2, 1, gtty,			/* 32 = gtty */
	2, 0, saccess,			/* 33 = access */
	1, 1, nice,			/* 34 = nice */
	0, 0, p(0),                     /* 35 v7/s3 diff */
	0, 0, sync,			/* 36 = sync */
	2, 1, kill,			/* 37 = kill */
	1, 0, p(0),                     /* 38 v7/s3 diff */
	2, 0, p(0),                     /* 39 v7/s3 diff */
	3, 0, p(0),                     /* 40 v7/s3 diff */
	2, 2, dup,                      /* 41 = dup */
	0, 0, pipe,			/* 42 = pipe */
	1, 0, times,			/* 43 = times */
	4, 0, profil,			/* 44 = prof */
	1, 1, lock,                     /* 45 = lock */
	1, 1, setgid,			/* 46 = setgid */
	0, 0, getgid,			/* 47 = getgid */
	2, 0, ssig,			/* 48 = sig */
	0, 0, nosys,			/* 49 = reserved for USG */
	0, 0, nosys,			/* 50 = reserved for USG */
	1, 0, sysacct,			/* 51 = turn acct off/on */
	0, 0, nosys,			/* 52 */
	0, 0, nosys,			/* 53 */
	3, 1, ioctl,			/* 54 = ioctl */
	0, 0, nosys,			/* 55 = x */
	0, 0, nosys,			/* 56 = x */
	4, 0, p(0),                     /* 57 v7/s3 diff */
	0, 0, nosys,			/* 58 = reserved for USG */
	3, 0, exece,			/* 59 = exece */
	1, 0, umask,			/* 60 = umask */
	1, 0, chroot,			/* 61 = chroot */
	5, 0, p(0),                     /* 62 v7/s3 diff */
	6, 0, p(0),                     /* 63 v7/s3 diff */
};


struct sysent v7sysent[] =
{
	1, 1, ftime,                    /* 35 */
	0, 0, nosys,                    /* 38 */
	0, 0, nullsys,                  /* 39 */
	0, 0, nosys,                    /* 40 */
	0, 0, nosys,                    /* 57 */
	5, 2, clocal,                   /* 62 = custom local calls */
	5, 2, cxenix                    /* 63 = custome xenix calls */
};

struct sysent s3sysent[] =
{
	0, 0, nullsys,                  /* 35 */
	5, 2, clocal,                   /* 38 = custom local calls */
	1, 1, setpgrp,			/* 39 = setpgrp */
	5, 2, cxenix,                   /* 40 = custom xenix calls */
	5, 2, utssys,                   /* 57 = utssys */
	3, 1, fcntl,                    /* 62 = fcntl */
	3, 0, ulimit,                   /* 63 = ulimit */
};
