/*
 *  "fvtest3.c"  -  YAFVTP (Yet Another Fast Video Test Program)
 *
 *	John Elliott IV		15 Aug 1984
 */

#include  <sgtty.h>
#include  <signal.h>
#define	RAND()	(rand() >> 4)
#define DSTEP	5

long	time();
char	*ctime();

char	screen[] = "/dev/screen";
char	cantopen[] = "Can't open ";
char	cantread[] = "Can't read ";
char	movestr[] = "\033Y  ";
char	ceol[] = "\033K";
char	exiting[] = "[break...]\n";
char	status[] = "Insane Fortune System, v1.0     Pos: %-5.5s   Speed: %-3.3s Delay: %-3.3s      %.8s";
char	line[] = "================================================================================\n";
char	spaces[] = "                                                                                ";
char	*mesgs[] = {
	"Hi, Mom!",
	"Now is the time for all good computers to come to the Kool Aid.",
	"Try to divide your time evenly to keep others happy.",
	"You are in a maze of twisty little passages, all alike.",
	"Beware of a dark-haired man with a loud tie.",
	"Disk crisis, please clean up!",
	"Some men are discovered; others are found out.",
	"You dialed 5483",
	"Laugh, and the world ignores you. Crying doesn't help either.",
	"Many pages make a thick book.",
	"The wise shepherd never trusts his flock to a smiling wolf.",
	"You now have Asian Flu.",
	"Your computer account is overdrawn. Please reauthorize.",
	"Words are the voice of the heart.",
	"Many are cold, but few are frozen.",
	"*  UNIX is a Trademark of Bell Laboratories.",
	"Go to Jail. Go directly to jail. Do not pass Go, do not collect $200.",
	"Let not the sands of time get in your lunch.",
	"It's not reality that's important, but how you perceive things.",
	"Those who can do, those who can't, write.",
	"You cannot kill time without injuring eternity.",
	"Let a fool hold his tongue and he will pass for a sage.",
	"A journey of a thousand miles begins with a cash advance from Sam.",
	"Flee at once, all is discovered.",
	"Put not your trust in money, but put your money in trust.",
	"I will never lie to you.",
	"When in doubt, lead trump.",
	"Many are cold, but few are frozen.",
	"People who take cat naps don't usually sleep in a cat's cradle.",
	"It is a poor judge who cannot award a prize.",
	"Just remember this, no matter where you go, there you are.",
	"It is the wise bird who builds his nest in a tree.",
	"fvtest3:  segmentation violation - Core dumped",
	"Deprive a mirror of its silver, and even the Czar won't see his face.",
	"For a good time, call 8367-3100.",
	"Mistakes are oft the stepping stones to failure.",
	"Try to divide your time evenly to keep others happy.",
	"If you suspect a man, don't employ him.",
	"A king's castle is his home.",
	"Old MacDonald had an agricultural real estate tax abatement.",
	"Even a hawk is an eagle among crows.",
	"Do not underestimate the power of the Force.",
};

char	sbuff[80 * 24];

struct  sgttyb	new, old;
int		fv_fd;
int		speed = 5;
int		delay = 0;

main()
{
	int	shutdown();
	register int	fd, pos, x, y;
	register char	*msg, *msgptr, *endptr;
	unsigned char	c;

	fd = open(screen, 2);
	if (fd < 0) {
		write(2, cantopen, sizeof(cantopen));
		perror(screen);
		exit(1);
	}
	fv_fd = fd;

	signal(SIGINT, shutdown);

	if (read(fd, sbuff, sizeof (sbuff)) != sizeof (sbuff)) {
		write(2, cantread, sizeof (cantread));
		perror(screen);
		exit(1);
	}

	gtty(0, &old);
	new = old;
	new.sg_flags |= CBREAK;
	new.sg_flags &= ~ECHO;
	stty(0, &new);

	/* ^L clears the screen on the console */
	c = 'L' & 0x1f;  fvwrite(2, &c, 1);
	show(0, 21, line);
	srand((int)time(0));

	for ( ; ; ) 
	{
		msg = mesgs[RAND() % (sizeof(mesgs) / sizeof(char *))];
		x = RAND() % (80 - strlen(msg));
		y = RAND() % 21;
		pos = (y * 80) + x;

		/* Update status line... */
		upd_status(x, y);

		/* clear the line we want to display on */
		lseek(fd, (long)(y * 80), 0);
		fvwrite(fd, spaces, strlen(spaces));

		/* Write the message on the console using /dev/screen */
		for (msgptr = msg, endptr = &msg[strlen(msg)];
		     msgptr < endptr; ) 
		{
			int	i;

			lseek(fd, (long)pos, 0);
			if (endptr - msgptr < speed)
				i = endptr - msgptr;
			else
				i = speed;
			fvwrite(fd, msgptr, i);
			msgptr += i;
			pos += i;
			if ((x += i) > 80) 
				x = 80 - x, ++y;

			move(x, y);
			upd_status(x, y);

			for (i = 0; i <= delay; ++i) {
			    if (rdchk(0)) {
				read(0, &c, 1);
				if (rdchk(0) && c == '\033') {
					read(0, &c, 1);
					if (c == 'A') {
					    if (delay > 0)
						delay -= ((delay-DSTEP) >= 0)?
								DSTEP : delay;
					    else
						++speed;
					}
					else if (c == 'B') {
					    if (speed <= 1)
						delay += DSTEP;
					    else
						speed -= ((speed-1) >= 0)?
								1 : speed;
					}
					upd_status(x, y);
				}
			    }
			}
		}
		/* write(fd, msg, strlen(msg)); */

		/* Position the cursor to the end of the message */
		/* move(x + strlen(msg), y); */
	}
	/*NOTREACHED*/
}

move(x, y)
  register int  x, y;
{
	register char	*pos = movestr;

	pos[2] = (char)y + ' ';
	pos[3] = (char)x + ' ';
	write(2, pos, strlen(pos));
}

show(x, y, msg)
  register int   x, y;
  register char  *msg;
{
	move(x, y);
	write(2, msg, strlen(msg));
}

upd_status(x, y)
  register int	x, y;
{
	char	buff[80], xy_buff[8], speed_buff[6], delay_buff[6], *timeptr;
	long	nowtime;

	/* First, calculate the current time... */
	nowtime = time(0);
	timeptr = ctime(&nowtime);

	/* Next, we format the line/column information... */
	sprintf(xy_buff, "%d/%d", y, x);

	/* the speed... */
	sprintf(speed_buff, "%d", speed);

	/* and the delay... */
	sprintf(delay_buff, "%d", delay / DSTEP);

	/* ...and then we bring it all together on the line */
	sprintf(buff,  status,  xy_buff, speed_buff, delay_buff, &timeptr[11]);
	lseek(fv_fd, (long)(22 * 80), 0);
	write(fv_fd, buff, strlen(buff));
}

shutdown()
{
	lseek(fv_fd, 0L, 0);
	fvwrite(fv_fd, sbuff, sizeof (sbuff));
	_shutdown();
}

_shutdown()
{
	stty(0, &old);
	show(0, 23, exiting);
	exit(0);
}

fvwrite(fd, buff, bytes)
  char	*buff;
{
	if (write(fd, buff, bytes) != bytes) {
		perror("write failed");
		_shutdown();
	}
}
