/*
 *  "box.c"  -  draw a box around whatever's on screen
 *
 *	George Moore 	08/28/1986
 *	Tandy System Software
 */

#include  <stdio.h>
#include  <signal.h>
#include  <sys/ioctl.h>
#include  <sys/graphics.h>

extern int	errno;

char	screen[] = "/dev/graphics";
char	cantopen[] = "Can't open ";

struct screen {
	unsigned char	b[240][80];
};
struct screen	buff;


int	screen_fd;
char	*myname;

main(argc, argv)
  int	argc;
  char	**argv;
{
	register int	rval;
	int		arg;

	myname = *argv;

	screen_fd = open(screen, 2);
	if (screen_fd < 0) {
		write(2, cantopen, sizeof(cantopen));
		perror(screen);
		exit(1);
	}

	errno = 0;

	/* Set some crunchy options */
	arg = GR_ENABLE;
	if (ioctl(screen_fd, GIOCCBIS, &arg) < 0) {
		fprintf(stderr, "%s: Can't GIOCCBIS; ", myname);
		perror("");
		exit(1);
	}

	read(screen_fd, &buff.b[0][0], 80 * 240);

	/* draw the box around the screen */
	line(0, 0, 639, 0, 1);	   /* top */
	line(0, 239, 0, 0, 1);	   /* left side */
	line(639, 0, 639, 239, 1); /* right side */
	line(639, 239, 0, 239, 1); /* bottom */
	refresh();
}

line(x0, y0, x1, y1, c)
int	x0, y0, x1, y1, c;
{
	int	dx, dy, xinc, yinc, threshold;

	xinc = yinc = 1;
	dx = x1 - x0;
	dy = y1 - y0;
	if (dx < 0) {
		dx = -dx;
		xinc = -xinc;
	}
	if (dy < 0) {
		dy = -dy;
		yinc = -yinc;
	}
	threshold = 0;
	write_pixel(x0, y0, c);
	if (dx >= dy) {
		while (x0 != x1) {
			x0 += xinc;
			threshold += dy;
			if (threshold > dx) {
				threshold -= dx;
				y0 += yinc;
			}
			write_pixel(x0, y0, c);
		}
	}
	else {
		while (y0 != y1) {
			y0 += yinc;
			threshold += dx;
			if (threshold > dy) {
				threshold -= dy;
				x0 += xinc;
			}
			write_pixel(x0, y0, c);
		}
	}
}

struct screen	*cbp = &buff;
short	cbuff = 0;
long	lo = 80 * 240, hi = 0L;
write_pixel(x, y, c)
int	x, y, c;
{
	char	mask;
	long	seek;

	mask = 1 << (7 - (x&7));
	if (c == 1)
		cbp->b[y][x/8] |= mask;
	else if (c == 0)
		cbp->b[y][x/8] &= ~mask;

	seek = (y * 80) + (x / 8);
	if (seek < lo)
		lo = seek;
	if (seek > hi)
		hi = seek;

	/*lseek(screen_fd, seek, 0);*/
	/*write(screen_fd, &cbp->b[y][x], 1);*/
}

refresh()
{
	if (hi - lo > 0) {
		lseek(screen_fd, lo, 0);
		write(screen_fd, &cbp->b[lo/80][lo%80], (int)(hi - lo + 1));
		lo = 80 * 240;
		hi = 0L;
	}
}
