/*
 *  "ginvert.c"  -  Invert image on screen
 *
 *	John Elliott IV		09/15/1986
 */

#include  <stdio.h>
#include  <sys/ioctl.h>
#include  <sys/graphics.h>

extern int	errno;
extern long	lseek();


char	screen[] = "/dev/graphics";
char	cantopen[] = "Can't open ";


char	buff[80 * 240];
char	*myname;


main(argc, argv)
  int	argc;
  char	**argv;
{
	register int	fd, rval;
	register char	*cp;
	int		mask;

	myname = *argv++; --argc;

	fd = open(screen, 2);
	if (fd < 0) {
		write(2, cantopen, sizeof(cantopen));
		perror(screen);
		exit(1);
	}

	mask = (GR_ENABLE|GR_WAITS);
	if (ioctl(fd, GIOCCBIC, &mask) < 0) {
		perror("Can't alter control word");
		exit(1);
	}

	errno = 0;

	rval = read(fd, buff, sizeof (buff));
	if (rval != sizeof (buff)) {
		fprintf(stderr, "%s read error: wanted %d, got %d; ", 
					myname,
					sizeof (buff),
					rval);
		perror("");
	}

	for (cp = buff; cp < &buff[sizeof (buff)]; ++cp)
		*cp = ~*cp;

	if (lseek(fd, 0L, 0) != 0L) {
		fprintf(stderr, "%s seek error: ", myname);
		perror("");
	}

	rval = write(fd, buff, sizeof (buff));
	if (rval != sizeof (buff)) {
		fprintf(stderr, "%s write error: wanted %d, got %d; ", 
					myname,
					sizeof (buff),
					rval);
		perror("");
	}

	if (ioctl(fd, GIOCCBIS, &mask) < 0) {
		perror("Can't alter control word");
		exit(1);
	}

	close(fd);
}
