   1                             |***	Startup for XENIX
   2                             |***	
   3                             |***	Create the environment for a call to main and upon return start
   4                             |***	the initial user process.
   5                             |***
   6                             |***	Originally written by Jerry J. Dunietz, Microsoft Corp.; January 1983
   7                             |***	Maintained locally by John A. Elliott IV
   8                             |***	Copyright (c) Tandy Corporation, 1986, 1987
   9                             |***
  10                             |***	Assembly Language Assist Routines
  11                             |***   
  12                             |***	===========================================================
  13                             |***   
  14                             |***	Tandy Radio Shack Model 16
  15                             |***   
  16                             |***	The hardware provides no relocation in supervisor mode (!!).
  17                             |***	For initial development, we reserve an area in which the currently
  18                             |***	active U and stack manipulated.  Whenever a save is done, we copy
  19                             |***	the currently active U and stack back to where they belong; whenever
  20                             |***	a resume is done, the newly selected U and stack are copied into 
  21                             |***	the active area.
  22                             |***
  23                             |***	The memory management in user mode supports two segments;
  24                             |***	one starts at location 0, the other at hex 800000.
  25                             |***	Segments can be any multiple of 4Kbytes in size.  They are
  26                             |***	defined by set of offset registers and a set of limit registers.
  27                             |***
  28                             |***	All I/O is done thru the auxiliary Z80 processor.  The 68000
  29                             |***	informs the Z80 of the start of their communications buffers
  30                             |***	by loading this address into location 4.  The Z80 initializes 
  31                             |***	them and resets the contents of location 4 back to its original 
  32                             |***	value.  This informs the 68000 to proceed.
  33                             |***
  34                             |*** ========================================================================
  35                             |***  Modification record:
  36                             |***
  37                             |***   $Log:	mch.S,v $
  38                             |***   Revision 6.2  88/08/17  15:25:18  root
  39                             |***   	- Changed all DEBUG putchar() calls to _putcha()
  40                             |***   	  [so it won't get put in the output buffer]
  41                             |***   
  42                             |***   Revision 6.1  88/04/05  11:16:38  iv
  43                             |***   	- Added MC68010 conditional support
  44                             |***   	- Added DEBUG code for startup under conditional DEBUGS
  45                             |***   	- Changed kernel-debugger conditional to KDEBUG
  46                             |***   
  47                             |***   Revision 6.0  87/10/12  17:00:10  iv
  48                             |***   	- Checkin to lock down 3.2
  49                             |***   
  50                             |***   Revision 5.6  86/10/16  15:17:28  iv
  51                             |***   	- Replaced `movb's with `moveq's in _spl? calls
  52                             |***   	- Renamed bufinit() to cfginit()  [now handles more than buffers]
  53                             |***   
  54                             |***   Revision 5.5  86/10/01  16:59:37  iv
  55                             |***   	- Re-arranged startup code to support auto-configurable buffers
  56                             |***   	  (and maybe other things later!)
  57                             |***   
  58                             |***   Revision 5.4  86/08/28  17:22:14  iv
  59                             |***   	- Changed mmu-related code to support extra 3 bits of resolution
  60                             |***   	  (see mmu.h and mmu.c comments and change log)
  61                             |***   
  62                             |***   Revision 5.3  86/07/10  15:24:07  iv
  63                             |***   	- Cleaned up some of the RCS revsion comments
  64                             |***   	- Prettied up some of the code comments
  65                             |***   	- Changed copyright message to Tandy, 1986 [we've changed AT LEAST 10%]
  66                             |***   	- Added new 1 conditional, compiles in fast-system-call handling
  67                             |***   	  code.  Trimmed ~2 seconds off of our system call benchmark!
  68                             |***   	- Moved z80 mailboxes into mch.S, especially for Mr. Bob Snapp
  69                             |***   	  who likes patching our code to death
  70                             |***   	- Rewrote spl code & saved 4 clocks there & shortened local calls to it
  71                             |***   
  72                             |***   Revision 5.2  86/06/12  11:39:30  iv
  73                             |***   	- Added support code for auto-boot
  74                             |***   
  75                             |***   Revision 5.1  86/05/21  21:12:55  iv
  76                             |***   	- Converted the awful, awful, ea syntax that mch.s was written in
  77                             |***   	  to the one everyone else in the world uses.  Much more readable.
  78                             |***   
  79                             |***   Revision 5.0  85/08/23  10:00:48  iv
  80                             |***   	- Checkin to lock down XENIX 3.1 release
  81                             |***   
  82                             |***   Revision 5.0  85/08/23  09:56:21  iv
  83                             |***   	- Checkin to lock down XENIX 3.1 release
  84                             |***   
  85                             |***   Revision 4.2  85/08/22  16:06:14  iv
  86                             |***   	- Changed memory size code to lie and say 1 Meg if the actual
  87                             |***   	  main memory is really > 1 Meg, because the MMU can't handle
  88                             |***   	  addresses that are > 1 Meg.  *sigh*
  89                             |***   
  90                             |***   Revision 4.1  85/03/29  09:57:47  iv
  91                             |***    - Removed the Z80 interrupt ID array; it is not used
  92                             |***   
  93                             |***   Revision 4.0  85/03/13  14:38:03  iv
  94                             |***   	- Checkin to lock down XENIX 3.0(28) release
  95                             |***   
  96                             |***   Revision 3.0  85/01/17  15:37:59  iv
  97                             |***   	- Checkin to save XENIX v3.0(23)
  98                             |***   
  99                             |***   Revision 2.0  85/01/10  14:05:14  iv
 100                             |***   	- Checkin to save XENIX 3.0(22)
 101                             |***   
 102                             |***   Revision 1.5  84/12/21  15:58:10  iv
 103                             |***   	- Changed call to "clock()" to call to "rclock()", which gives
 104                             |***   	  clock() the arguments it expects
 105                             |***   	- Corrected misc typos (in comments and such)
 106                             |***   	- Added "_tasktime" as an alias for "_spl0"
 107                             |***   	- Added "_bcopy" entry for "copybuf"
 108                             |***   
 109                             |***   Revision 1.4  84/04/18  10:20:11  iv
 110                             |***   	- Fixed up some RCS comment leader errors, I forgot to set
 111                             |***   	  the comment header with 'rcs -c' before I checked in.
 112                             |***   
 113                             |***   Revision 1.3  84/04/18  10:12:52  iv
 114                             |***	- Changed "idleflg" to "Idlef", per sys/clock.c
 115                             |***
 116                             |*** ------------------------------------------------------------------------
 117                             |***	M000	07 Jul 1983	jeIV  (Tandy)
 118                             |***		- Added z80 interrupt routine and request fifo initialization
 119                             |***
 120                             |***	M001	19 Sep 1983	jeIV  (Tandy)
 121                             |***		- Added C interface to "umap" routine so drivers can hand
 122                             |***		  PHYSICAL user addresses to z80 for "DMA" z80 style
 123                             |***		- Added initialization of z80 interrupt ID mask
 124                             |***
 125                             |***	M002	01 Feb 1984	jeIV  (Tandy)
 126                             |***		- Added support for z80 notification of system shutdown
 127                             |***		  [done at haltcpu].  Added code to initalize shutdown enable
 128                             |***		  byte "z80halt" to a safe value.
 129                             |***
 130                             |*** ========================================================================
 131                             
 132                             	.data
 133  0e54  436f 7079 7269 6768  	.asciz	"Copyright 1987 Tandy Corporation\n"
            7420 3139 3837 2054 616e 6479 2043 6f72 706f 7261 7469 6f6e 0a00
 134  0e76                       	.even
 135                             	.text
 136                             
 137                             USRSTART= /000000	| User Virtual Addr of First Execable Code
 138                             
 139                             USIZE		=	/1000	| size of U structure
 140                             UMASK		=	/fff
 141                             PAGESIZE	=	/1000	| size of 1 page
 142                             PAGESHIFT	=	12	| shift required
 143                             SHIFT1		=	8	| fragments of PAGESHIFT
 144                             SHIFT2		=	4	|	for use in shift instructions
 145                             
 146                             INTDATA		= 0x7800d0	| interrupt controller data register
 147                             INTCOMMAND	= 0x7800d1	| interrupt controller command register
 148                             
 149                             CLRINT		= /60		| clear interrupt command
 150                             MASKWRITE	= /b0		| next data write is new mask register
 151                             MASKREAD	= /a4		| condition for reading mask register
 152                             INTPROGRAM	= /ffffffe0	| command to program first int with 1 byte
 153                             INTARM		= /a5		| arm the chip (and set for reading of mask)
 154                             INTRESET	= /00		| reset the interrupt controller
 155                             ISRREAD		= /a0		| condition reading interrupt service register
 156                             
 157                             MMU_BASE	= 0x7800d2	| base of MMU registers
 158                             MMU_HILIM	= 0x7800d2	| 	limit register, hi segment
 159                             MMU_HIOFF	= 0x7800d3	|	offset register, hi segment
 160                             MMU_LOLIM	= 0x7800d4	|	limit register, lo segment
 161                             MMU_LOOFF	= 0x7800d5	|	offset register, lo segment
 162                             
 163                             Z80IADDR	= /7800d6	| M000  z80 interrupt latch
 164                             
 165                             
 166                             |***
 167                             |***	We must set up software copies of the MMU registers...
 168                             |***
 169                             |***	     WARNING:	mmu.c *depends* on and uses the fact that
 170                             |***			_mmuHiOff follows _mmuHiLim and that
 171                             |***			_mmuLoOff follows _mmuLoLim.
 172                             |***
 173                             |***		[See the code and comments for mmusub() in mmu.c]
 174                             |***
 175                             	.data
 176                             	.globl	_mmuHiLim, _mmuHiOff, _mmuLoLim, _mmuLoOff
 177                             mmuhi:
 178                             _mmuHiLim:
 179  0e76  0000                 	.word	0
 180                             _mmuHiOff:
 181  0e78  0000                 	.word	0
 182                             
 183                             mmulo:
 184                             _mmuLoLim:
 185  0e7a  0000                 	.word	0
 186                             _mmuLoOff:
 187  0e7c  0000                 	.word	0
 188                             
 189                             	.text
 190                             
 191                             |***
 192                             |***	Because a TIMERRI (bus timeout while 68000 is bus master) or ADERR
 193                             |***	ADERR (user MMU fault) interrupt would also generate a bus error,
 194                             |***	these are always masked off.
 195                             |***	Under no circumstances should the kernel ever get a TIMERRE (bus
 196                             |***	timeout while 68000 is *not* bus master) interrupt; therefore this
 197                             |***	mask bit is used to differentiate between MASK1 and MASK0.
 198                             |***
 199                             |***	MASK7-4 use negative numbers so that we can use a `moveq' in _spl
 200                             |***
 201                             MASK7	= -1	|/ff		| no ints enabled
 202                             MASK6	= -1	|/ff		| level six must disable clock; same as MASK7
 203                             MASK5	= -2	|/fe		| allow highest pri int only (clock)
 204                             MASK4   = -4	|/fc		| allow clock and disk
 205                             MASK1	= 	/38		| lowest pri which does not enable all ints
 206                             MASK0	= 	/18		| all ints enabled
 207                             
 208                             |SPL7	= /2700		| status reg value disable all interupts, super mode
 209                             |SPL6	= /2600		| level 6
 210                             |SPL5	= /2500		| level 5
 211                             |SPL4	= /2400		| level 4
 212                             |SPL3	= /2300		| level 3
 213                             |SPL2	= /2200		| level 2
 214                             |SPL1	= /2100		| level 1
 215                             |SPL0	= /2000		| level 0
 216                             
 217                             SSTATE	= /2000		| supervisor state bit
 218                             SBIT	= 13		| supervisor state bit of status register
 219                             TBIT	= 15		| trace bit of status register
 220                             NOINTR	= /2700		| no interrupts
 221                             TRACE	= /8000		| trace mode bit
 222                             
 223                             |***
 224                             |***	Location 0	Interrupt and Trap Vectors
 225                             |***
 226                             zero:
 227  0000  0000 0100            	.long	_end+0x100	| Initial SSP (FIX ME BUG)
 228  0004  0000 0734            	.long	start		| Initial PC
 229                             
 230  0008  0000 09ca            	.long	_aberr		| vector   2	BUS ERROR
 231  000c  0000 09ca            	.long	_aberr		| vector   3	ADDRESS ERROR
 232  0010  0000 06d0            	.long	jvector		| vector   4
 233  0014  0000 06d0            	.long	jvector		| vector   5
 234  0018  0000 06d0            	.long	jvector		| vector   6
 235  001c  0000 06d0            	.long	jvector		| vector   7
 236  0020  0000 06d0            	.long	jvector		| vector   8
 237  0024  0000 06d0            	.long	jvector		| vector   9
 238  0028  0000 06d0            	.long	jvector		| vector  10
 239  002c  0000 06d0            	.long	jvector		| vector  11
 240  0030  0000 06d0            	.long	jvector		| vector  12
 241  0034  0000 06d0            	.long	jvector		| vector  13
 242  0038  0000 06d0            	.long	jvector		| vector  14
 243  003c  0000 06d0            	.long	jvector		| vector  15
 244  0040  0000 06d0            	.long	jvector		| vector  16
 245  0044  0000 06d0            	.long	jvector		| vector  17
 246  0048  0000 06d0            	.long	jvector		| vector  18
 247  004c  0000 06d0            	.long	jvector		| vector  19
 248  0050  0000 06d0            	.long	jvector		| vector  20
 249  0054  0000 06d0            	.long	jvector		| vector  21
 250  0058  0000 06d0            	.long	jvector		| vector  22
 251  005c  0000 06d0            	.long	jvector		| vector  23
 252  0060  0000 06d0            	.long	jvector		| vector  24
 253  0064  0000 06d0            	.long	jvector		| vector  25
 254  0068  0000 06d0            	.long	jvector		| vector  26
 255  006c  0000 06d0            	.long	jvector		| vector  27
 256  0070  0000 06d0            	.long	jvector		| vector  28
 257  0074  0000 06d0            	.long	jvector		| vector  29
 258  0078  0000 06d0            	.long	jvector		| vector  30
 259                             
 260  007c  0000 09bc            	.long	nmi		| vector  31
 261                             
 262  0080  0000 08e0            	.long	do_scall	| vector  32	trap #0 -- System call
 263                             
 264                             
 265  0084  0000 06d0            	.long	jvector		| vector  33
 266  0088  0000 06d0            	.long	jvector		| vector  34
 267  008c  0000 06d0            	.long	jvector		| vector  35
 268  0090  0000 06d0            	.long	jvector		| vector  36
 269  0094  0000 06d0            	.long	jvector		| vector  37
 270  0098  0000 06d0            	.long	jvector		| vector  38
 271  009c  0000 06d0            	.long	jvector		| vector  39
 272  00a0  0000 06d0            	.long	jvector		| vector  40
 273  00a4  0000 06d0            	.long	jvector		| vector  41
 274  00a8  0000 06d0            	.long	jvector		| vector  42
 275  00ac  0000 06d0            	.long	jvector		| vector  43
 276  00b0  0000 06d0            	.long	jvector		| vector  44
 277  00b4  0000 06d0            	.long	jvector		| vector  45
 278  00b8  0000 06d0            	.long	jvector		| vector  46
 279  00bc  0000 06d0            	.long	jvector		| vector  47
 280  00c0  0000 06d0            	.long	jvector		| vector  48
 281  00c4  0000 06d0            	.long	jvector		| vector  49
 282  00c8  0000 06d0            	.long	jvector		| vector  50
 283  00cc  0000 06d0            	.long	jvector		| vector  51
 284  00d0  0000 06d0            	.long	jvector		| vector  52
 285  00d4  0000 06d0            	.long	jvector		| vector  53
 286  00d8  0000 06d0            	.long	jvector		| vector  54
 287  00dc  0000 06d0            	.long	jvector		| vector  55
 288  00e0  0000 06d0            	.long	jvector		| vector  56
 289  00e4  0000 06d0            	.long	jvector		| vector  57
 290  00e8  0000 06d0            	.long	jvector		| vector  58
 291  00ec  0000 06d0            	.long	jvector		| vector  59
 292  00f0  0000 06d0            	.long	jvector		| vector  60
 293  00f4  0000 06d0            	.long	jvector		| vector  61
 294  00f8  0000 06d0            	.long	jvector		| vector  62
 295  00fc  0000 06d0            	.long	jvector		| vector  63
 296                             
 297                             
 298                             |***	We use the first user vectors for the interrupt
 299                             |***	contoller chip.  It must be programmed to generate
 300                             |**	vectors 64-71.
 301                             
 302                             INTVEC	=	64
 303                             
 304  0100  0000 06d4            cont4:	.long	cont4encode	| initiated by z80
 305  0104  0000 06e0            cont5:	.long	cont5encode	| initiated by z80
 306  0108  0000 06ec            cont6:	.long	cont6encode	| initiated by z80
 307                             |***
 308                             |***	The following three interrupts cannot be generated without also
 309                             |***	generating a bus error.  We keep the first two masked off permanently.
 310                             |***	The third should absolutely never be generated while running XENIX;
 311                             |***	the mask bit for this interrupt is used for special purposes by
 312                             |***	XENIX.
 313                             |***
 314  010c  0000 06f8            aderr:	.long	spu1encode	| MMU address error
 315                             timerri:
 316  0110  0000 0704            	.long	spu2encode	| timeout error, 68000 is bus master
 317                             timerre:
 318  0114  0000 0710            	.long	spu3encode	| timeout error, 68000 is not bus master
 319  0118  0000 071c            iper:	.long	ipencode	| parity error, 68000 is bus master
 320  011c  0000 0728            eper:	.long	epencode	| parity error, 68000 is not bus master
 321                             
 322                             
 323                             |***
 324                             |***	Just for fun, and to be totally evil to Mr. Snapp, we decided
 325                             |***	to put the mailboxes here instead of letting `ld' place them.
 326                             |***	[You hear maniacal laughter in the distance...]
 327                             |***
 328                             
 329                             |	c68  - enhanced compiler  - Version 3(24)  29-Mar-88
 330                             	.text
 331                             	.globl	z80base
 332  0120                       	.even
 333                             z80base:
 334                             
 335                             	.globl	_z80clk
 336  0120  0000                 _z80clk:	.blkb	2
 337  0122                       	.even
 338                             
 339                             	.globl	_z80halt
 340  0122  00                   _z80halt:	.blkb	1
 341  0123  00                   	.even
 342                             
 343                             	.globl	_z80disk
 344  0124  0000 0000 0000 0000  _z80disk:	.blkb	84
            0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000
 345  0178                       	.even
 346                             
 347                             	.globl	_z80msgb
 348  0178  0000 0000 0000 0000  _z80msgb:	.blkb	636
            0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 00
 349  03f4                       	.even
 350                             
 351                             	.globl	_z80grap
 352  03f4  0000 0000 0000 0000  _z80grap:	.blkb	18
            0000 0000 0000 0000 0000
 353  0406                       	.even
 354                             
 355                             	.globl	_z80ser
 356  0406  0000 0000 0000 0000  _z80ser:	.blkb	130
            0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 00
 357  0488                       	.even
 358                             
 359                             	.globl	_z80rcv
 360  0488  0000 0000            _z80rcv:	.blkb	4
 361  048c                       	.even
 362                             
 363                             	.globl	_z80fifo
 364  048c  0000 0000 0000 0000  _z80fifo:	.blkb	512
            0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 00
 365  068c                       	.even
 366                             
 367                             	.globl	_z80req_
 368  068c  0000 0000 0000 0000  _z80req_:	.blkb	66
            0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000
 369  06ce                       	.even
 370                             
 371                             	.globl	_z80boot
 372  06ce  0000                 _z80boot:	.blkb	2
 373  06d0                       	.even
 374                             
 375                             
 376                             
 377                             |***  >SIGH<  trap() uses these symbols to determine if the user attempted
 378                             |***  to single-step a system call.  Since we go into supervisor mode at that
 379                             |***  point, we won't get the trace trap until after we're in supervisor mode.
 380                             |***  So, we need _firstvec and _endvec to be the range of addresses the PC
 381                             |***  will be in when we take the trace trap.  trap() will then discard it.
 382                             
 383                             	.globl	_firstvec,_firstve,_endvec
 384                             jvector:
 385                             _firstvec:
 386                             _firstve:
 387  06d0  6000 0268            	bra	_vector
 388                             
 389                             
 390                             cont4encode:
 391                             	.globl	_rclock
 392  06d4  6100 0176            	jbsr	intr		| cont4
 393  06d8  0000 0000            	.long	0
 394  06dc  0000 0000            	.long	_rclock
 395                             cont5encode:
 396                             	.globl	_cont5
 397  06e0  6100 016a            	jbsr	intr		| cont5
 398  06e4  0000 0001            	.long	1
 399  06e8  0000 0000            	.long	_cont5
 400                             cont6encode:
 401                             	.globl	_cont6
 402  06ec  6100 015e            	jbsr	intr		| cont6
 403  06f0  0000 0002            	.long	2
 404  06f4  0000 0000            	.long	_cont6
 405                             spu1encode:
 406                             	.globl	_novec
 407  06f8  6100 0152            	jbsr	intr		| unexpected interrupt
 408  06fc  0000 0003            	.long	3
 409  0700  0000 0000            	.long	_novec
 410                             spu2encode:
 411                             	.globl	_novec
 412  0704  6100 0146            	jbsr	intr		| unexpected interrupt
 413  0708  0000 0004            	.long	4
 414  070c  0000 0000            	.long	_novec
 415                             spu3encode:
 416                             	.globl	_novec
 417  0710  6100 013a            	jbsr	intr		| unexpected interrupt
 418  0714  0000 0005            	.long	5
 419  0718  0000 0000            	.long	_novec
 420                             ipencode:
 421                             	.globl	_parity
 422  071c  6100 012e            	jbsr	intr
 423  0720  0000 0006            	.long	6
 424  0724  0000 0000            	.long	_parity
 425                             epencode:
 426                             	.globl	_parity
 427  0728  6100 0122            	jbsr	intr
 428  072c  0000 0007            	.long	7
 429  0730  0000 0000            	.long	_parity
 430                             
 431                             	.globl	_endvec		| end of vectors
 432                             _endvec:
 433                             
 434                             |***   
 435                             |***	START	- The very first XENIX code
 436                             |***
 437                             |***	Create a C environment and call main, when main returns start the
 438                             |***	first user task.
 439                             |***
 440                             
 441                             |***
 442                             |***	Clear BSS, and initialize global variables as to size of system,
 443                             |***	base of working upage, address of first user memory, etc.
 444                             |***
 445                             	.text
 446                             	.globl	start,_end,_edata,_main,_cfginit
 447                             |***
 448                             |***	Size memory by trying to write a value and testing by reading it.
 449                             |***	Also check for memory wrap by looking at loc 0
 450                             |***
 451                             start:
 452                             
 453  0734  203c 0000 0000       	movl	#_end,d0	| point to start of user memory (more-or-less)
 454  073a  0680 0000 0fff       	addl	#USIZE-1,d0	| Round up one page
 455  0740  0280 ffff f000       	andl	#~UMASK,d0	| to page boundry
 456  0746  2040                 	movl	d0,a0
 457  0748  93c9                 	subl	a1,a1		| point to loc zero
 458                             
 459  074a  23fc 0000 0770 0000  	movl	#3$,nofault	| make memory faults go here
            0ea8
 460                             2$:
 461  0754  30bc 1234            	movw	#/1234,(a0)	| try to store 1234
 462  0758  317c 0000 0002       	movw	#0,2(a0)	| put another value on the bus
 463  075e  0c50 1234            	cmpw	#/1234,(a0)	| did it store ?
 464  0762  660c                 	jne	3$		| no, so this is top of memory
 465  0764  0c51 1234            	cmpw	#/1234,(a1)	| did it set loc 0 ?
 466  0768  6706                 	jeq	3$		| yes, we have finished with all of memory
 467  076a  d0fc 1000            	addw	#PAGESIZE,a0	| next page boundary
 468  076e  60e4                 	jra	2$		| loop for more memory
 469                             
 470  0770  23c8 0000 0e86       3$:	movl	a0,_maxaddr	| This is top of memory for XENIX
 471                             
 472  0776  42b9 0000 0ea8       	clrl	nofault
 473                             
 474                             
 475                             
 476  077c  4eb9 0000 0000       	jsr	_cfginit	| Allocate configurable stuff as apropriate
 477                             				|  [cfginit() returns new _end in d0]
 478                             
 479                             
 480  0782  0680 0000 0fff       	addl	#USIZE-1,d0	| Round up one page
 481  0788  0280 ffff f000       	andl	#~UMASK,d0	|   to page boundry
 482  078e  23c0 0000 0e7e       	movl	d0,_exenix	| addr of end of xenix
 483  0794  23c0 0000 0eac       	movl	d0,uaddr	| initialize address of current process U
 484  079a  0680 0000 1000       	addl	#USIZE,d0	| next page
 485  07a0  23c0 0000 0e82       	movl	d0,_umem	| first free page
 486  07a6  207c 0000 0000       	movl	#_edata,a0	| start clearing from here
 487                             
 488                             |*** Clear BSS, first upage.  Because we may have parity equipped
 489                             |*** memory, we don't use a clr intruction on memory, which generates
 490                             |*** a read access before write access.
 491  07ac  7200                 	moveq	#0,d1
 492  07ae  20c1                 1$:	movl	d1,(a0)+	| clear a long word and increment a0
 493  07b0  b088                 	cmpl	a0,d0		| are we done
 494  07b2  6efa                 	jgt	1$		| loop while less than or equal
 495                             
 496                             
 497                             
 498                             
 499                             
 500                             
 501                             
 502                             
 503                             
 504                             
 505                             
 506                             
 507                             
 508                             |***	Initialize all of physical memory, in case it is parity equipped.
 509  07b4  2079 0000 0e86       	movl	_maxaddr,a0
 510  07ba  2008                 	movl	a0,d0		| top of physical memory
 511  07bc  90b9 0000 0e82       	subl	_umem,d0	| number of bytes of user memory
 512  07c2  223c 4afc 4afc       	movl	#/4afc4afc,d1	| initialize memory with illegal instructions
 513                             
 514  07c8  2101                 4$:	movl	d1,-(a0)	| Initialize a word
 515  07ca  5980                 	subql	#4,d0		| We did 4 bytes
 516  07cc  66fa                 	bnes	4$		| Loop for all words (we can't use dbra
 517                             				|   here because it might be > 16 bits)
 518                             
 519                             
 520                             |***	The initial system stack will grow from the end of the system U
 521                             |***	page down
 522                             
 523  07ce  207c 0000 0000       	movl	#_u,a0		| physical address of system U
 524  07d4  23f9 0000 0e7e 0000  	movl	_exenix,uaddr	| where we keep the proc 0 upage when running
            0eac
 525                             				|   other processes
 526  07de  d0fc 0ffe            	addw	#USIZE-2,a0
 527  07e2  2e48                 	movl	a0,sp
 528                             
 529                             |***
 530                             |***	Initialize the Z80 interface and interrupt controller.
 531                             |***
 532  07e4  46fc 2700            	movw	#NOINTR,sr	| hi processor priority
 533                             
 534                             	.globl	_z80init
 535  07e8  4eb9 0000 0000       	jsr	_z80init	| Initialize z80 structures
 536                             
 537  07ee  21fc 0000 0120 0004  	movl	#z80base,4:w	| inform z80 of base address
 538  07f6  0cb8 0000 0120 0004  8$:	cmpl	#z80base,4:w	| wait for z80 to intialize buffer space
 539  07fe  67f6                 	jeq	8$
 540                             
 541                             
 542                             	| We need to wait until this point to check the reboot-byte
 543                             	|   because the Z80 didn't know where the iopb's were until
 544                             	|   just now (we just told it).
 545                             	.globl	_z80rebo	| [In real life: z80reboot()]
 546  0800  4eb9 0000 0000       	jsr	_z80rebo	| Check for reboot or normal boot
 547                             
 548                             
 549                             
 550                             
 551                             	|*** Check to make sure we're running on a 68010.  68010/XENIX will
 552                             	|***   appear to run on a 68000, until you get a bus or address error.
 553                             	|*** If we ARE running on a 68000, we should get an illegal
 554                             	|***   instruction trap here.
 555                             ill_loc:
 556  0806  4e7a                 	.word	/4e7a		| movec	vbr,a0
 557  0808  8801                 	.word	/8801
 558                             
 559                             
 560  080a  41f9 0078 00d1       	lea	INTCOMMAND,a0	| pointer to interrupt command reg
 561  0810  2248                 	movl	a0,a1		| pointer to
 562  0812  5389                 	subql	#1,a1		|	interrupt data reg
 563  0814  10bc 0000            	movb	#INTRESET,(a0)	| reset controller
 564                             
 565  0818  70e0                 	moveq	#INTPROGRAM,d0	| command to program first int level
 566  081a  7240                 	moveq	#INTVEC,d1	| interrupt vector to be programmed
 567  081c  7407                 	moveq	#7,d2		| number of vectors minus one
 568                             
 569  081e  1080                 9$:	movb	d0,(a0)		| specify which register to program
 570  0820  1281                 	movb	d1,(a1)		| provide vector number
 571  0822  5280                 	addql	#1,d0		| next register
 572  0824  5281                 	addql	#1,d1		| next vector number
 573  0826  51ca fff6            	dbra	d2,9$		| loop
 574                             
 575                             
 576                             
 577  082a  10bc 00a5            	movb	#INTARM,(a0)	| arm the chip
 578                             
 579                             
 580                             
 581                             	| make a stack so first proc can have a u.u_ar0
 582  082e  48e7 ffff            	moveml	#/ffff,-(sp)	| save all regs
 583  0832  48e7 f800            	moveml	#/f800,-(sp)	| save 5 more
 584  0836  46fc 2000            	movw	#SSTATE,sr	| lo processor priority
 585                             
 586                             
 587                             
 588  083a  4eb9 0000 0000       	jsr	_main		| call main
 589                             
 590                             |***	return from main is "in" init process
 591                             
 592                             
 593  0840  4267                 	clrw	-(sp)		| Push format word
 594                             
 595  0842  2f3c 0000 0000       	movl	#USRSTART,-(sp)	| starting addr for user process
 596  0848  4267                 	clrw	-(sp)		| return to user mode
 597  084a  4e73                 	rte
 598                             
 599                             	.data
 600                             	.globl	_exenix,_umem,_maxaddr
 601                             
 602  0e7e  0000 0000            _exenix: .long	0	| The first page after xenix (also the first U page)
 603  0e82  0000 0000            _umem:	 .long	0	| The first free page
 604  0e86  0000 0000            _maxaddr:.long	0	| The last page of memory
 605                             
 606  0e8a  00                   nmiflag:.byte	0
 607                             
 608                             |***	Because we seem to be unable to read the mask register
 609                             |***	of the interrupt controller, we maintain copy in software.
 610                             
 611                             	.globl	intmask		| so it will come out in the symbol table
 612  0e8b  ff                   intmask:.byte	/ff		| software copy of interrupt mask register
 613  0e8c                       	.even
 614                             
 615                             
 616                             |***   
 617                             |***	Trap and Interrupt Handlers
 618                             |***
 619                             |***	Your basic stack is:
 620                             |***				pchi,pclo	long
 621                             |***				sr		word
 622                             |***				pchi,pclo	long from bsr
 623                             |***
 624                             |***	For traps, the "long from bsr" points to the trap number.
 625                             |***	For interrupts, the "long from bsr" points to the interrupt
 626                             |***		number, followed by a jmp instruction to the handler.
 627                             |***
 628                             |***	Your stack handed to _trap becomes:
 629                             |***				pchi,pclo	long
 630                             |***				sr		long
 631                             |***				intmask		long	(formerly unused "mmu")
 632                             |***				regs		16 longs
 633                             |***				trap no		long
 634                             |***
 635                             |***	Your stack handed to interrupt handlers is:
 636                             |***				pchi,pclo	long
 637                             |***				sr		long
 638                             |***				intmask		long
 639                             |***				saved a1	long
 640                             |***				saved a0	long
 641                             |***				saved d1	long
 642                             |***				saved d0	long
 643                             |***				intno		long
 644                             |***
 645                             |*** trap(no,d0,d1,d2,d3,d4,d5,d6,d7,a0,a1,a2,a3,a4,a5,a6,usp,mmu,sr,tpc)
 646                             |*** long no,d0,d1,d2,d3,d4,d5,d6,d7,a0,a1,a2,a3,a4,a5,a6,usp,mmu,sr,tpc;
 647                             |***
 648                             |*** devintr(no,d0,d1,a0,a1,intmask,sr,tpc)
 649                             |*** long no,d0,d1,a0,a1,sr,tpc;
 650                             |***
 651                             
 652                             |***
 653                             |***	INTR -- handle vectored interrupts from interrupt controller
 654                             |***
 655                             	.text
 656                             intr:				| vectored interrupt handler
 657  084c  4267                 	clrw	-(sp)		| get to long alignment
 658  084e  48e7 c0c0            	moveml	<a0,a1,d0,d1>,-(sp)
 659                             
 660  0852  206f 0012            	movl	18(sp),a0	| where bsr put address of itself plus 4
 661  0856  42af 0012            	clrl	18(sp)		| make args nice
 662                             
 663  085a  2018                 	movl	(a0)+,d0	| fetch vector number
 664  085c  2f00                 	movl	d0,-(sp)	| push vector number as arg
 665                             
 666                             	| Compute the appropriate bits to set in the mask register
 667  085e  72ff                 	moveq	#-1,d1
 668  0860  e1a1                 	asll	d0,d1
 669                             
 670                             	| d1 now holds bits to set in mask register
 671  0862  1039 0000 0e8b       	movb	intmask,d0	| get old mask value
 672  0868  1f40 0017            	movb	d0,23(sp)	| save as stack arg
 673  086c  8001                 	orb	d1,d0		| compute new mask
 674                             
 675                             	| d0 now holds the new mask
 676  086e  43f9 0078 00d1       	lea	INTCOMMAND,a1	| points after data register
 677  0874  12bc 00b0            	movb	#MASKWRITE,(a1)	| prepare to write new mask value
 678  0878  1300                 	movb	d0,-(a1)	| new mask into hardware
 679  087a  13c0 0000 0e8b       	movb	d0,intmask	| new mask into software copy
 680  0880  5289                 	addql	#1,a1		| points to command register again
 681  0882  12bc 0060            	movb	#CLRINT,(a1)	| clear the interrupt -- trust the mask
 682                             
 683                             	| we use d1 to figure what the new SR will be
 684  0886  322f 001a            	movw	26(sp),d1	| old sr
 685  088a  08c1 000d            	bset	#SBIT,d1	| set supervisor bit
 686  088e  0881 000f            	bclr	#TBIT,d1	| clear trace bit
 687  0892  46c1                 	movw	d1,sr		| new processor pri -- enable higher pri ints
 688                             
 689  0894  2050                 	movl	(a0),a0		| Grab handler's address
 690  0896  4e90                 	jsr	(a0)		| call handler(no,d0,d1,a0,a1,intmask,sr,tpc)
 691                             
 692  0898  588f                 	addql	#4,sp		| pop int number
 693  089a  082f 000d 0016       	btst	#SBIT,22(sp)	| came from supervisor mode?
 694  08a0  6608                 	jne	1$		| yes: do not reschedule
 695  08a2  4a39 0000 0000       	tstb	_runrun		| need to reschedule?
 696  08a8  6628                 	jne	reschedule	| yes: branch
 697                             1$:
 698  08aa  4279 0000 0eb0       	clrw	_Idlef		| don't loop in idle
 699  08b0  102f 0013            	movb	19(sp),d0	| saved mask register
 700  08b4  41f9 0078 00d1       	lea	INTCOMMAND,a0	| pointer to hardware register
 701  08ba  46fc 2700            	movw	#NOINTR,sr	| hi priority for mask fiddling
 702  08be  13c0 0000 0e8b       	movb	d0,intmask	| software copy
 703  08c4  10bc 00b0            	movb	#MASKWRITE,(a0)	|
 704  08c8  1100                 	movb	d0,-(a0)	| hardware copy
 705  08ca  4cdf 0303            	moveml	(sp)+,<a0,a1,d0,d1>	| restore registers
 706  08ce  5c8f                 	addql	#6,sp		| pop old intmask, hi sr
 707  08d0  4e73                 	rte
 708                             
 709                             	.data
 710                             	.comm	_runrun,1
 711                             	.text
 712                             
 713                             
 714                             |***
 715                             |***	RESCHEDULE -- branched to from INTR to fake a rescheduling trap
 716                             |***	RESCHED1 -- branched to from DO_SCALL to fake a rescheduling trap
 717                             |***
 718                             	.text
 719                             reschedule:
 720  08d2  4cdf 0303            	moveml	(sp)+,<a0,a1,d0,d1>	| restore registers, leaving intmask
 721                             resched1:
 722  08d6  48e7 ffff            	moveml	#/ffff,-(sp)	| save ALL registers
 723  08da  7001                 	moveq	#1,d0		| fake trap 1
 724  08dc  6000 009e            	jra	calltrap
 725                             
 726                             
 727                             
 728                             |***
 729                             |***	DO_SCALL -- handle system call traps quickly
 730                             |***
 731                             
 732                             do_scall:
 733  08e0  4267                 	clrw	-(sp)		| Make sr a long
 734  08e2  42a7                 	clrl	-(sp)		| put old `mmu' arg on stack
 735  08e4  48e7 ffff            	moveml	#/ffff,-(sp)	| save all regs
 736  08e8  1f79 0000 0e8b 0043  	movb	intmask,67(sp)	| save interrupt info on stack in old "mmu" slot
 737                             
 738  08f0  082f 000d 0046       	btst	#SBIT,70(sp)	| Did we come from supervisor mode?
 739  08f6  6706                 	jeq	1$		|   No:  proceed with system call
 740                             
 741  08f8  7020                 	moveq	#32,d0		| Yes:  Oh, oh; we executed a "trap #0" from
 742  08fa  6000 0080            	bra	calltrap	|   SUPERVISOR mode...  (prepare to panic:)
 743                             
 744  08fe  4e68                 1$:	movl	usp,a0
 745  0900  2f48 003c            	movl	a0,60(sp)	| Replace saved a7 with user stack pointer
 746                             
 747  0904  4eb9 0000 0000       	jbsr	_systrap	| Run the system call
 748                             
 749  090a  206f 003c            	movl	60(sp),a0	| Possibly altered user stack pointer
 750  090e  4e60                 	movl	a0,usp		| Restore user stack pointer
 751                             
 752                             |***  Program interrupt controller chip
 753  0910  102f 0043            	movb	67(sp),d0	| saved mask register
 754  0914  41f9 0078 00d1       	lea	INTCOMMAND,a0	| pointer to hardware register
 755  091a  46fc 2700            	movw	#NOINTR,sr	| hi priority for mask fiddling
 756  091e  13c0 0000 0e8b       	movb	d0,intmask	| Save software a copy
 757  0924  10bc 00b0            	movb	#MASKWRITE,(a0)	|
 758  0928  1100                 	movb	d0,-(a0)	| Give hardware its copy
 759                             
 760  092a  4cdf 7fff            	moveml	(sp)+,#/7fff	| restore all registers except sp
 761  092e  defc 000a            	addw	#10,sp		| Pop saved usp, intmask, and high word of sr
 762  0932  4239 0000 0e8a       	clrb	nmiflag		| allow processing of NMI
 763  0938  4e73                 	rte			| Back to the User
 764                             
 765                             
 766                             
 767                             |***
 768                             |***	VECTOR -- handle processor traps
 769                             |***
 770                             	.globl	_vector,_trap
 771                             
 772                             _vector:
 773                             
 774                             
 775  093a  4267                 	clrw	-(sp)		| Make sr a long
 776  093c  42a7                 	clrl	-(sp)		| Make room for int-#
 777  093e  48e7 ffff            	moveml	#/ffff,-(sp)	| Save ALL regs
 778  0942  7000                 	moveq	#0,d0		| Clear upper-half of d0 for later
 779  0944  302f 004c            	movw	76(sp),d0	| Get format/vec-offset word (ffff00vvVvvvVvvv)
 780  0948  426f 004c            	clrw	76(sp)		| Make format 0000 for later legal rte
 781  094c  e958                 	rolw	#4,d0		| Put format nybble in lower bits
 782  094e  ec48                 	lsrw	#6,d0		| Eat format code and div vec-offset by 4
 783                             				|   to get the vector-number (int-#)
 784                             
 785  0950  082f 000d 0046       	btst	#SBIT,70(sp)	| Did we come from supervisor mode?
 786  0956  671c                 	jeq	illtrap		|   no: proceed with trap
 787  0958  0caf 0000 0806 0048  	cmpl	#ill_loc,72(sp)	| Did we generate the trap to check for a '010?
 788  0960  6612                 	jne	illtrap		|   nope: proceed with trap
 789                             
 790                             	.data
 791  0e8c  6e6f 7420 6120 3638  pmsg:	.asciz	"not a 68010"
            3031 3000
 792  0e98                       	.even
 793                             	.text
 794                             
 795                             	.globl	_panic
 796  0962  2f3c 0000 0e8c       	movl	#pmsg,-(sp)	| "panic: not a 68010"
 797  0968  4eb9 0000 0000       	jsr	_panic
 798  096e  4ef9 0000 0cd0       	jmp	_haltcpu	| Just in case...
 799                             
 800                             
 801                             illtrap:
 802  0974  1f79 0000 0e8b 0043  	movb	intmask,67(sp)	| save interrupt info on stack in "mmu" arg
 803                             
 804                             calltrap:
 805  097c  2f00                 	movl	d0,-(sp)	| push trap number on stack
 806  097e  4e68                 	movl	usp,a0		| get user stack pointer
 807  0980  2f48 0040            	movl	a0,64(sp)	| replace saved a7 with user stack pointer
 808                             
 809  0984  4eb9 0000 0000       	jbsr	_trap		| call trap(number, regs)
 810                             
 811  098a  588f                 	addql	#4,sp		| pop off vector number
 812  098c  206f 003c            	movl	60(sp),a0	| saved user stack pointer
 813  0990  4e60                 	movl	a0,usp		| restore user stack pointer
 814                             
 815  0992  102f 0043            	movb	67(sp),d0	| saved mask register
 816  0996  41f9 0078 00d1       	lea	INTCOMMAND,a0	| pointer to hardware register
 817  099c  46fc 2700            	movw	#NOINTR,sr	| hi priority for mask fiddling
 818  09a0  13c0 0000 0e8b       	movb	d0,intmask	| software copy
 819  09a6  10bc 00b0            	movb	#MASKWRITE,(a0)	|
 820  09aa  1100                 	movb	d0,-(a0)	| hardware copy
 821                             
 822  09ac  4cdf 7fff            	moveml	(sp)+,#/7fff	| restore all registers (not sp)
 823  09b0  defc 000a            	addw	#10,sp		| saved usp, intmask, and hi of sr
 824  09b4  4239 0000 0e8a       	clrb	nmiflag		| allow processing of NMI
 825  09ba  4e73                 	rte			| back to somewhere
 826                             
 827                             |*** Debounce NMI
 828                             nmi:
 829  09bc  08f9 0000 0000 0e8a  	bset	#0,nmiflag    | Figure out if we're already handling NMI
 830                             			      | uses kludge because some MMU's can't handle TAS
 831                             
 832  09c4  6700 ff74            	jeq	_vector		| no -- call vector
 833                             
 834  09c8  4e73                 	rte			| yes -- ignore this one
 835                             
 836                             |***
 837                             |***	Bus error and Address error traps push 4 extra words on the stack.
 838                             |***	On a 68010, they push 22 extra words on the stack.
 839                             |***
 840                             |***	These routines take the words off the stack so that all traps look
 841                             |***	the same.
 842                             |***
 843                             	.data
 844                             	.globl	berrinfo,aerrinfo,_fltinfo,nofault
 845                             _fltinfo:
 846  0e98  0000 0000 0000 0000  berrinfo:.word	0,0,0,0		| save error info in global
 847  0ea0  0000 0000 0000 0000  aerrinfo:.word	0,0,0,0		| save error info in global
 848  0ea8  0000 0000            nofault:.long	0		| address to go to on memory faults
 849                             
 850                             
 851                             	.text
 852                             
 853                             	.globl	_aberr
 854                             _aberr:
 855  09ca  2f0c                 	movl	a4,-(sp)	| Save scratch register
 856                             
 857  09cc  386f 000c            	movw	12(sp),a4	| Grab special status word to save it
 858  09d0  33cc 0000 0e98       	movw	a4,berrinfo	| Silliness because we don't know if we're
 859  09d6  33cc 0000 0ea0       	movw	a4,aerrinfo	|   an address error or a bus error
 860                             
 861  09dc  286f 000e            	movl	14(sp),a4	| Grab fault address to save it
 862  09e0  23cc 0000 0e9a       	movl	a4,berrinfo+2	| Silliness because we don't know if we're
 863  09e6  23cc 0000 0ea2       	movl	a4,aerrinfo+2	|   an address error or a bus error
 864                             
 865  09ec  386f 001c            	movw	28(sp),a4	| Grab fault instruction to save it
 866  09f0  33cc 0000 0e9e       	movw	a4,berrinfo+6	| Silliness because we don't know if we're
 867  09f6  33cc 0000 0ea6       	movw	a4,aerrinfo+6	|   an address error or a bus error
 868                             
 869                             
 870                             
 871                             
 872                             
 873  09fc  285f                 	movl	(sp)+,a4	| Restore scratch reg
 874                             
 875  09fe  2f57 0032            	movl	(sp),50(sp)	| Copy sr and pc-hi to bottom of frame
 876  0a02  2f6f 0004 0036       	movl	4(sp),54(sp)	| Copy pc-lo and format to bottom
 877  0a08  defc 0032            	addw	#50,sp		| Pop 68010 Group 0 execption frame,
 878                             				|   except for last 4 words we copied
 879                                 |*** Voila!  Stack now looks like a "normal" exception frame
 880                             
 881                                 |*** WARNING:  The format word still says there's a "long" exception
 882                                 |***	   frame on the stack.  Do NOT rte to this frame without 
 883                                 |***	   clearing the format word, or you will have one very
 884                                 |***	   confused and slightly angry 68010...
 885                                 |***	   We leave the old format/vector word on the stack so
 886                                 |***	   that _vector can use it to get the vector number.
 887                             
 888  0a0c  4ab9 0000 0ea8       	tstl	nofault		| nofault set ?
 889  0a12  670e                 	jeq	1$
 890                             
 891  0a14  2f79 0000 0ea8 0002  	movl	nofault,2(sp)	| Yes, so return there
 892  0a1c  426f 0006            	clrw	6(sp)		| Make format word legal
 893  0a20  4e73                 	rte			| Back to where nofault said to go...
 894                             
 895                                 |*** Do an rte to _vector (which handles the fault) to avoid processor halt
 896  0a22  4267                 1$:	clrw	-(sp)		| Push format word
 897  0a24  2f3c 0000 093a       	movl	#_vector,-(sp)	| push pc
 898  0a2a  40e7                 	movw	sr,-(sp)	| push status word
 899  0a2c  4e73                 	rte
 900                             
 901                             
 902                             
 903                             |***
 904                             |***	SAVE(regs)
 905                             |***	struct label_t *regs;
 906                             |***
 907                             |***		Save register contents in U area pointed to by
 908                             |***		addr, in prepartion for context switch.
 909                             |***
 910                             |***		On TRS-16, must copy struct U and stack contents
 911                             |***		from working Upage to process's Upage.
 912                             |***
 913                             |***		  Note:	The M68010SR code does NOT work.  
 914                             |***			Do not define M68010SR.  23 Oct 87  jeIV
 915                             |***
 916                             	.data
 917                             
 918                             	.globl	_dustack	| number of bytes from &u to &u.stack
 919                             				| initialized in C code
 920                             	.globl	_u
 921                             	.comm	_u,USIZE
 922                             
 923                             	.globl	uaddr
 924  0eac  0000 0000            uaddr:	.long	0		| address of U area for current process
 925                             				| set by last resume, initialized with
 926                             				| same value as _exenix
 927                             	.text
 928                             	.globl	_save
 929                             
 930                             _save:				| save(regs)
 931  0a2e  225f                 	movl	(sp)+,a1	| return address off of stack
 932  0a30  2057                 	movl	(sp),a0		| ptr to a label_t (place to save regs)
 933  0a32  48d0 fcfc            	moveml	#/fcfc,(a0)	| save d2-d7 and a2-a7
 934  0a36  2149 0030            	movl	a1,48(a0)	| save return address
 935  0a3a  2f09                 	movl	a1,-(sp)	| and back onto stack for safe keeping
 936                             |***
 937                             |***	Copy the stack and U-struct from the working area to the
 938                             |***	process's allocated U and stack
 939                             |***
 940                             
 941                             
 942                                 |*** First, copy the stack [from sp to (_u + USIZE - 1)]
 943  0a3c  200f                 	movl	sp,d0		| copy current stack pointer
 944  0a3e  207c 0000 1000       	movl	#_u+USIZE,a0	| end of U
 945  0a44  91cf                 	subl	sp,a0		| number of bytes of stack
 946  0a46  2f08                 	movl	a0,-(sp)	| nbytes arg to copybuf
 947                             
 948  0a48  2200                 	movl	d0,d1		| stack pointer copy
 949  0a4a  0481 0000 0000       	subl	#_u,d1		| calculate offset within U+stack page
 950  0a50  d2b9 0000 0eac       	addl	uaddr,d1	| address within process's real U
 951  0a56  2f01                 	movl	d1,-(sp)	| toaddr arg to copybuf
 952  0a58  2f00                 	movl	d0,-(sp)	| copy of sp -- fromaddr arg to copybuf
 953  0a5a  6100 00f2            	jbsr	_copybuf	| copy bytes
 954  0a5e  defc 000c            	addw	#12,sp		| pop args to copybuf
 955                             
 956                                 |*** Then, copy the U struct proper  [from &u to &u.u_stack (end of the U)]
 957  0a62  2f39 0000 0000       	movl	_dustack,-(sp)	| nbytes = (char *) u.u_stack - (char *) &u
 958  0a68  2f39 0000 0eac       	movl	uaddr,-(sp)	| toaddr
 959  0a6e  2f3c 0000 0000       	movl	#_u,-(sp)	| fromaddr
 960  0a74  6100 00d8            	jbsr	_copybuf	| copy bytes
 961  0a78  defc 000c            	addw	#12,sp		| pop args to copybuf
 962                             
 963                             
 964  0a7c  7000                 	moveq	#0,d0		| return value is 0 in saver
 965  0a7e  4e75                 	rts			| return
 966                             
 967                             |***
 968                             |***	RESUME(upage,regs)
 969                             |***	struct label_t *regs;
 970                             |***
 971                             |***		Switch contexts to kernel process whose U and stack
 972                             |***		are in physical page upage, and whose registers are
 973                             |***		saved in its U at the location corresponding to
 974                             |***		address regs.
 975                             |***
 976                             |***		On TRS-16, must copy new process's U-struct and stack
 977                             |***		into the working area, and must set variable (uaddr)
 978                             |***		to hold address of current process's allocated U-page.
 979                             |***
 980                             |***		  Note:	The M68010SR code does NOT work.  
 981                             |***			Do not define M68010SR.  23 Oct 87  jeIV
 982                             |***
 983                             	.globl	_resume
 984                             _resume:			| resume(upage,regs)
 985  0a80  242f 0004            	movl	4(sp),d2	| address of user structure
 986  0a84  246f 0008            	movl	8(sp),a2	| ptr to label_t (place where regs were saved)
 987                             
 988  0a88  e182                 	asll	#SHIFT1,d2	| convert upage number
 989  0a8a  e982                 	asll	#SHIFT2,d2	|	to physical address
 990  0a8c  23c2 0000 0eac       	movl	d2,uaddr	| stow address of new U in global
 991                             
 992                             
 993  0a92  2f39 0000 0000       	movl	_dustack,-(sp)	| nbytes
 994  0a98  2f3c 0000 0000       	movl	#_u,-(sp)	| toaddr
 995  0a9e  2f02                 	movl	d2,-(sp)	| from addr
 996  0aa0  6100 00ac            	jbsr	_copybuf	| copy bytes
 997  0aa4  defc 000c            	addw	#12,sp		| pop args
 998                             
 999                             
1000  0aa8  2e6a 002c            	movl	44(a2),sp	| stack pointer to be restored
1001                             				| note that current stack contents are now
1002                             				| 	invalid
1003                             
1004  0aac  260f                 	movl	sp,d3		| copy of new stack pointer
1005  0aae  267c 0000 1000       	movl	#_u+USIZE,a3	| end of working Upage
1006  0ab4  97cf                 	subl	sp,a3		| calculate size of saved stack
1007  0ab6  2f0b                 	movl	a3,-(sp)	| nbytes
1008                             
1009  0ab8  2f03                 	movl	d3,-(sp)	| toaddress
1010  0aba  0483 0000 0000       	subl	#_u,d3		| convert sp copy to offset in page
1011  0ac0  d682                 	addl	d2,d3		| compute address within process's copy
1012  0ac2  2f03                 	movl	d3,-(sp)	| fromaddress
1013  0ac4  6100 0088            	jbsr	_copybuf	| copy bytes
1014  0ac8  defc 000c            	addw	#12,sp		| pop args
1015                             
1016                             
1017  0acc  613a                 	jbsr	_spl0		| we return in an interruptible condition
1018  0ace  204a                 	movl	a2,a0		| reg pointer into a volatile register
1019  0ad0  4cd8 fcfc            	moveml	(a0)+,#/fcfc	| restore d2-d7 & a2-a7
1020  0ad4  2050                 	movl	(a0),a0		| return address
1021  0ad6  7001                 	moveq	#1,d0		| return 1
1022  0ad8  4ed0                 	jmp	(a0)		| return in new context
1023                             
1024                             |***
1025                             |***	SETJMP(regs)
1026                             |***	LONGJMP(regs)
1027                             |***
1028                             |***		Similar to save and resume, but do not involve
1029                             |***		context switches, and therefore, don't require
1030                             |***		copying of any U information.
1031                             |***
1032                             	.globl	_setjmp,_longjmp
1033                             _setjmp:
1034  0ada  225f                 	movl	(sp)+,a1	| return address
1035  0adc  2057                 	movl	(sp),a0		| ptr to a label_t (place to save regs)
1036  0ade  48d0 fcfc            	moveml	#/fcfc,(a0)	| save d2-d7 and a2-a7
1037  0ae2  2149 0030            	movl	a1,48(a0)	| save return address
1038  0ae6  7000                 	moveq	#0,d0		| return value is 0 in saver
1039  0ae8  4ed1                 	jmp	(a1)		| return
1040                             
1041                             _longjmp:
1042  0aea  206f 0004            	movl	4(sp),a0	| ptr to label_t (place where regs were saved)
1043  0aee  4cd8 fcfc            	moveml	(a0)+,#/fcfc	| restore d2-d7 & a2-a7
1044  0af2  2250                 	movl	(a0),a1		| return address
1045  0af4  7001                 	moveq	#1,d0		| return 1
1046  0af6  4ed1                 	jmp	(a1)		| return
1047                             
1048                             |***
1049                             |***	SPL	- spl7,6,5,4,1,0 set the interupt mask in the status reg
1050                             |***		also return the previous level so that a call to splx
1051                             |***		can be used to set a previous level
1052                             |***
1053                             
1054                             	.globl	_spl7,_spl6,_spl5,_spl4,_spl1,_spl0,_splx,_tasktime
1055                             
1056                             _spl7:
1057                             _spl6:				| spl6 and spl7 use the same interrupt mask
1058  0af8  72ff                 	moveq	#MASK6,d1
1059  0afa  6014                 	jra	splcom
1060                             
1061                             _spl5:
1062  0afc  72fe                 	moveq	#MASK5,d1
1063  0afe  6010                 	jra	splcom
1064                             
1065                             _spl4:
1066  0b00  72fc                 	moveq	#MASK4,d1
1067  0b02  600c                 	jra	splcom
1068                             
1069                             _spl1:
1070  0b04  7238                 	moveq	#MASK1,d1
1071  0b06  6008                 	jra	splcom
1072                             
1073                             _tasktime:
1074                             _spl0:
1075  0b08  7218                 	moveq	#MASK0,d1
1076  0b0a  6004                 	jra	splcom
1077                             
1078                             _splx:
1079  0b0c  122f 0007            	movb	7(sp),d1
1080                             
1081                             
1082                             splcom:				| Common spl code: d1 has new mask
1083  0b10  43f9 0078 00d1       	lea	INTCOMMAND,a1	| points after data register
1084  0b16  40c0                 	movw	sr,d0		| save processor pri
1085  0b18  3040                 	movw	d0,a0
1086  0b1a  46fc 2700            	movw	#NOINTR,sr	| no interrupts while playing with mask
1087  0b1e  12bc 00b0            	movb	#MASKWRITE,(a1)	| prepare to write new mask value
1088  0b22  1301                 	movb	d1,-(a1)	| new mask into hardware
1089  0b24  1039 0000 0e8b       	movb	intmask,d0	| old mask register
1090  0b2a  13c1 0000 0e8b       	movb	d1,intmask	| new mask into software copy
1091  0b30  3208                 	movw	a0,d1		
1092  0b32  46c1                 	movw	d1,sr		| restore processor pri
1093  0b34  4e75                 	rts			| return
1094                             
1095                             
1096                             |***
1097                             |***	IDLE	- spl0 and wait for interrupt
1098                             |***
1099                             	.globl	_idle,_waitloc,_Idlef
1100                             	.data
1101                             _Idlef:
1102  0eb0  0000                 	.word	0
1103                             	.text
1104                             
1105                             _idle:
1106  0b36  33fc 0001 0000 0eb0  	movw	#1,_Idlef
1107  0b3e  61c8                 	jbsr	_spl0
1108                             _waitloc:
1109  0b40  4a79 0000 0eb0       	tstw	_Idlef
1110  0b46  66f8                 	jne	_waitloc
1111                             
1112  0b48  1200                 	movb	d0,d1		| Fast call to splx()
1113  0b4a  61c4                 	jbsr	splcom		| Don't have to mess with the stack this way
1114                             
1115  0b4c  4e75                 	rts
1116                             
1117                             |***
1118                             |***	COPYBUF	- copy in kernel memory
1119                             |***
1120                             |***		Because this routine is used by copyin/out on TRS-16,
1121                             |***		copybuf must return 0 in d0.
1122                             |***
1123                             |***		Copyin/out make use of the fact that their arguments
1124                             |***		are logically equivalent to those of copybuf.
1125                             |***
1126                             |***		As presently coded, this routine is slightly inefficient
1127                             |***		for small transfers; however, it is highly efficient
1128                             |***		for large transfers, for which it is called often and
1129                             |***		for which efficiency is crucial.
1130                             |***
1131                             |***		NOTE:
1132                             |***		The bytecount argument must be in the range
1133                             |***		0 <= bytecount < 2^31.  (Because the 68000
1134                             |***		cannot address this much memory, this should
1135                             |***		not cause any problems.)
1136                             |***
1137                             |***		With the single exception noted above,
1138                             |***		copybuf will handled any combination of even, odd,
1139                             |***		zero, or nonzero arguments, as well as any overlap
1140                             |***		in the regions to be copied.
1141                             |***
1142                             |***		This routine is probably the most heavily used
1143                             |***		assembly language routine.  It is used by
1144                             |***			copyin
1145                             |***			copyout
1146                             |***			copyiin
1147                             |***			copyiout
1148                             |***			save
1149                             |***			resume
1150                             |***		A single call to copybuf is used in places where there
1151                             |***		would be multiple calls to
1152                             |***			copyseg
1153                             |***
1154                             	.globl	_copybuf
1155                             	.globl	_bcopy
1156                             
1157                             _bcopy:
1158                             _copybuf:			| copybuf(from,to,count)
1159  0b4e  202f 000c            	movl	12(sp),d0	| d0 = count
1160  0b52  6700 00e8            	jeq	copyend		| if zero, no work to do
1161  0b56  206f 0004            	movl	4(sp),a0	| a0 = from
1162  0b5a  226f 0008            	movl	8(sp),a1	| a1 = to
1163  0b5e  b3c8                 	cmpl	a0,a1		| compare from addr and to addr
1164  0b60  6700 00da            	jeq	copyend		| if equal, don't do anything
1165  0b64  48e7 3f3e            	moveml	#/3f3e,-(sp)	| save reg d2-d7 and a2-a6
1166                             				| moveml does not affect condition codes!
1167  0b68  6e64                 	jgt	copyup		| if fromaddr < toaddr, must ripple correctly
1168                             
1169                             | From address > To address: copy from low byte first
1170                             
1171                             | If both from and to are odd, move one byte and proceed to even code
1172                             | But if one is even and the other odd proceed to the bytewise move
1173                             
1174  0b6a  2408                 	movl	a0,d2		| get addr in data reg so btst can work
1175  0b6c  2609                 	movl	a1,d3		|
1176  0b6e  7800                 	moveq	#0,d4		| clear d4 for use in btst instructions
1177  0b70  0902                 	btst	d4,d2		| test from bit 0
1178  0b72  670a                 	jeq	1$		| from even
1179  0b74  0903                 	btst	d4,d3		| test to bit 0
1180  0b76  673a                 	jeq	70$		| to even but from odd
1181                             
1182                             				| both odd
1183  0b78  12d8                 	movb	(a0)+,(a1)+	| move one byte
1184  0b7a  5380                 	subql	#1,d0		| cnt--
1185  0b7c  6004                 	jra	2$
1186                             
1187                             1$:				| from even
1188  0b7e  0903                 	btst	d4,d3		| test to bit 0
1189  0b80  6630                 	jne	70$		| from even but to odd
1190                             
1191                             2$:				| both even
1192  0b82  722c                 	moveq	#44.,d1		| use d1 to hold the constant
1193                             3$:
1194  0b84  9081                 	subl	d1,d0		| subtract number of bytes to sub
1195  0b86  6f0c                 	jle	4$		| if too few bytes, go to word-at-a-time
1196                             |*** Note that the moveml instruction generates an extra memory
1197                             |*** access; to avoid unexpected memory faults, if a move is exactly
1198                             |*** 44 bytes, we do it a word at a time.
1199                             
1200  0b88  4cd8 7cfc            	moveml	(a0)+,#/7cfc	| load 44 bytes
1201  0b8c  48d1 7cfc            	moveml	#/7cfc,(a1)	| store 44 bytes
1202  0b90  d3c1                 	addl	d1,a1		| can't autoinc the destination on moveml
1203  0b92  60f0                 	jra	3$		| loop
1204                             
1205                             4$:				| 44 or few bytes to go
1206  0b94  d081                 	addl	d1,d0
1207  0b96  e280                 	asrl	#1,d0		| convert to word count
1208  0b98  650e                 	jcs	61$		| if byte-count was odd, C-bit set
1209  0b9a  6002                 	jra	51$		| for proper iteration, enter end of loop
1210                             
1211  0b9c  32d8                 50$:	movw	(a0)+,(a1)+	| move word
1212  0b9e  51c8 fffc            51$:	dbra	d0,50$		| while words left
1213  0ba2  6000 0094            	jra	copypop		| pop regs and return
1214                             
1215  0ba6  32d8                 60$:	movw	(a0)+,(a1)+	| move words, then 1 byte at end
1216  0ba8  51c8 fffc            61$:	dbra	d0,60$
1217  0bac  12d8                 	movb	(a0)+,(a1)+
1218  0bae  6000 0088            	jra	copypop		| pop regs and return
1219                             			
1220                             				| one even the other odd
1221                             
1222                             | For the case where one number is even, the other odd,
1223                             | we cannot just use one big dbra loop.  This is because
1224                             | the dbra instruction operates only on the low order
1225                             | word of a register, not on the long register.  This
1226                             | makes certain gyrations necessary:
1227                             70$:
1228  0bb2  4840                 	swap	d0		| get high word of register into low word
1229  0bb4  72ff                 	moveq	#-1,d1		| initialize d1 with FFFF
1230  0bb6  6006                 	bras	72$		| transfer 64K bytes some no. of times
1231                             
1232                             
1233                             71$:				| d1 holds FFFF, will transfer FFFF+1 bytes
1234  0bb8  12d8                 	movb	(a0)+,(a1)+	| transfer byte
1235  0bba  51c9 fffc            	dbra	d1,71$		| loop each of the 64K bytes
1236                             				| fall out of inner loop with FFFF in d1
1237                             
1238  0bbe  51c8 fff8            72$:	dbra	d0,71$		| outer loop, 64K per iteration
1239                             
1240  0bc2  4840                 	swap	d0		| get back low order half of d0
1241  0bc4  6002                 	bras	74$		| enter loop at bottom for proper iteration
1242                             
1243  0bc6  12d8                 73$:	movb	(a0)+,(a1)+	| transfer byte
1244  0bc8  51c8 fffc            74$:	dbra	d0,73$		| loop for each byte
1245  0bcc  606a                 	jra	copypop		| pop regs and return
1246                             	
1247                             
1248                             | From address < To address: copy from hi byte first
1249                             
1250                             copyup:
1251  0bce  d1c0                 	addl	d0,a0		| pointer past end of from region
1252  0bd0  d3c0                 	addl	d0,a1		| pointer past end of to region
1253                             
1254                             | If both from and to are odd, move one byte and proceed to even code
1255                             | But if one is even and the other odd proceed to the bytewise move
1256                             
1257  0bd2  2408                 	movl	a0,d2		| get addr in data reg so btst can work
1258  0bd4  2609                 	movl	a1,d3		|
1259  0bd6  7800                 	moveq	#0,d4		| clear d4 for use in btst instructions
1260  0bd8  0902                 	btst	d4,d2		| test from bit 0
1261  0bda  670a                 	jeq	1$		| from even
1262  0bdc  0903                 	btst	d4,d3		| test to bit 0
1263  0bde  673e                 	jeq	80$		| to even but from odd
1264                             
1265                             				| both odd
1266  0be0  1320                 	movb	-(a0),-(a1)	| move one byte
1267  0be2  5380                 	subql	#1,d0		| cnt--
1268  0be4  6004                 	jra	2$
1269                             
1270                             1$:				| from even
1271  0be6  0903                 	btst	d4,d3		| test to bit 0
1272  0be8  6634                 	jne	80$		| from even but to odd
1273                             
1274                             2$:				| both even
1275  0bea  722c                 	moveq	#44.,d1		| use d1 to hold the constant
1276  0bec  b081                 	cmpl	d1,d0		| might we be doing a moveml?
1277  0bee  6f16                 	jle	5$		| no: jump around moveml loop (see note below)
1278  0bf0  3320                 	movw	-(a0),-(a1)	| yes: move 1 word because of moveml funniness
1279  0bf2  5580                 	subql	#2,d0		| indicate word moved in bytecount register
1280                             3$:
1281  0bf4  9081                 	subl	d1,d0		| subtract number of bytes to sub
1282  0bf6  6d0c                 	jlt	4$		| if too few bytes, go to word-at-a-time
1283                             |*** Note that the moveml instruction generates an extra memory
1284                             |*** access; to avoid unexpected memory faults, we must have assured
1285                             |*** that the first transfer instruction is not a moveml.
1286                             
1287  0bf8  91c1                 	subl	d1,a0		| move back from pointer
1288  0bfa  4cd0 7cfc            	moveml	(a0),#/7cfc	| load 44 bytes
1289  0bfe  48e1 3f3e            	moveml	#/3f3e,-(a1)	| store 44 bytes
1290  0c02  60f0                 	jra	3$		| loop
1291                             
1292                             4$:				| -44 <= d0 < 0
1293  0c04  d081                 	addl	d1,d0		| get back real byte count
1294                             
1295                             5$:				| fewer than 44 bytes to go
1296  0c06  e280                 	asrl	#1,d0		| convert to word count
1297  0c08  650c                 	jcs	71$		| if byte-count was odd, C-bit set
1298  0c0a  6002                 	jra	61$		| for proper iteration, enter end of loop
1299                             
1300  0c0c  3320                 60$:	movw	-(a0),-(a1)	| move word
1301  0c0e  51c8 fffc            61$:	dbra	d0,60$		| while words left
1302  0c12  6024                 	jra	copypop		| pop regs and return
1303                             
1304  0c14  3320                 70$:	movw	-(a0),-(a1)	| move words, then 1 byte at end
1305  0c16  51c8 fffc            71$:	dbra	d0,70$
1306  0c1a  1320                 	movb	-(a0),-(a1)
1307  0c1c  601a                 	jra	copypop
1308                             
1309                             				| one even the other odd
1310                             
1311                             | For the case where one number is even, the other odd,
1312                             | we cannot just use one big dbra loop.  This is because
1313                             | the dbra instruction operates only on the low order
1314                             | word of a register, not on the long register.  This
1315                             | makes certain gyrations necessary:
1316                             80$:
1317  0c1e  4840                 	swap	d0		| get high word of register into low word
1318  0c20  72ff                 	moveq	#-1,d1		| initialize d1 with FFFF
1319  0c22  6006                 	bras	82$		| transfer 64K bytes some no. of times
1320                             
1321                             
1322                             81$:				| d1 holds FFFF, will transfer FFFF+1 bytes
1323  0c24  1320                 	movb	-(a0),-(a1)	| transfer byte
1324  0c26  51c9 fffc            	dbra	d1,81$		| loop each of the 64K bytes
1325                             				| fall out of inner loop with FFFF in d1
1326                             
1327  0c2a  51c8 fff8            82$:	dbra	d0,81$		| outer loop, 64K per iteration
1328                             
1329  0c2e  4840                 	swap	d0		| get back low order half of d0
1330  0c30  6002                 	bras	84$		| enter loop at bottom for proper iteration
1331                             
1332  0c32  1320                 83$:	movb	-(a0),-(a1)	| transfer byte
1333  0c34  51c8 fffc            84$:	dbra	d0,83$		| loop for each byte
1334                             
1335                             copypop:
1336  0c38  4cdf 7cfc            	moveml	(sp)+,#/7cfc	| restor reg d2-d7 and a2-a6
1337                             copyend:
1338  0c3c  7000                 	moveq	#0,d0
1339  0c3e  4e75                 	rts
1340                             
1341                             |***
1342                             |***	CLEARBUF	- zero a region of physical memory
1343                             |***
1344                             |***		This code will work for any combination of (even, odd)
1345                             |***		address and bytecount.  The code is rather inefficient
1346                             |***		for small buffers, though.
1347                             |***
1348                             |***		NOTE: because of the way the dbra instruction is used,
1349                             |***		this code will only work for bytecount < 256 * 64K;
1350                             |***		bytecount must be less than 16 Megabytes.
1351                             |***
1352                             	.globl	_clear
1353                             	.globl	_clearbu
1354                             	.globl	_clearbuf
1355                             _clearbuf:			| clearbuf(addr, nbytes)
1356                             _clearbu:
1357                             _clear:
1358  0c40  202f 0008            	movl	8(sp),d0	| nbytes
1359  0c44  6700 0088            	jeq	9$		| no bytes to clear -- done
1360  0c48  206f 0004            	movl	4(sp),a0	| addr
1361  0c4c  48e7 3f3e            	moveml	#/3f3e,-(sp)	| save regs d2-d7,a2-a6
1362                             
1363  0c50  7400                 	moveq	#0,d2		| code *depends* on d2 being 0
1364                             
1365  0c52  d1c0                 	addl	d0,a0		| point after clear region
1366  0c54  2208                 	movl	a0,d1		| get into data register for btst
1367  0c56  0501                 	btst	d2,d1		| is address odd?
1368  0c58  6700 0006            	beq	1$		| no: branch to code for even address
1369                             				| yes: odd address
1370  0c5c  1102                 	movb	d2,-(a0)	| clear one byte
1371  0c5e  5380                 	subql	#1,d0		| decrement byte count
1372                             
1373                             1$:				| even address
1374  0c60  0c80 0000 0030       	cmpl	#48,d0		| quick check for small transfer
1375  0c66  6d4c                 	jlt	35$		| don't bother clearing registers!
1376                             
1377  0c68  2202                 	movl	d2,d1		| clear registers to be used for mem clearing
1378  0c6a  2601                 	movl	d1,d3
1379  0c6c  2801                 	movl	d1,d4
1380  0c6e  2a01                 	movl	d1,d5
1381  0c70  2c01                 	movl	d1,d6
1382  0c72  2e01                 	movl	d1,d7
1383  0c74  2241                 	movl	d1,a1
1384  0c76  2441                 	movl	d1,a2
1385  0c78  2641                 	movl	d1,a3
1386  0c7a  2841                 	movl	d1,a4
1387  0c7c  2a41                 	movl	d1,a5
1388  0c7e  2c41                 	movl	d1,a6
1389                             
1390  0c80  2f00                 	movl	d0,-(sp)	| save byte count
1391  0c82  e088                 	lsrl	#8,d0		| divide by 256
1392  0c84  6014                 	jra	16$
1393                             
1394  0c86  48e0 7f7e            15$:	moveml	#/7f7e,-(a0)	| clear 52 bytes
1395  0c8a  48e0 7f7e            	moveml	#/7f7e,-(a0)	| 	+ 52 = 104
1396  0c8e  48e0 7f7e            	moveml	#/7f7e,-(a0)	| 	+ 52 = 156
1397  0c92  48e0 7f7e            	moveml	#/7f7e,-(a0)	| 	+ 52 = 208
1398  0c96  48e0 3f7e            	moveml	#/3f7e,-(a0)	|	+ 48 = 256
1399  0c9a  51c8 ffea            16$:	dbra	d0,15$		| loop to clear 256 bytes
1400                             
1401  0c9e  201f                 	movl	(sp)+,d0	| pop back byte count
1402  0ca0  0280 0000 00ff       	andl	#/FF,d0		| adjust for large transfer just completed
1403                             	
1404  0ca6  7230                 	moveq	#48,d1		| number of bytes transferred in next loop
1405                             
1406  0ca8  9081                 2$:	subl	d1,d0		| subtract number of bytes cleared/iteration
1407  0caa  6d06                 	jlt	3$		| if result < 0, then proceed to slow loop
1408  0cac  48e0 3f7e            	moveml	#/3f7e,-(a0)	| clear memory
1409  0cb0  60f6                 	jra	2$		| loop
1410                             
1411  0cb2  d081                 3$:	addl	d1,d0		| get back number of bytes left to clear
1412                             
1413  0cb4  e280                 35$:	asrl	#1,d0		| convert to word count
1414  0cb6  650c                 	jcs	7$		| carry set indicates odd byte
1415  0cb8  6002                 	jra	5$		| enter loop at bottom for proper indexing
1416                             
1417  0cba  3102                 4$:	movw	d2,-(a0)	| clear word
1418  0cbc  51c8 fffc            5$:	dbra	d0,4$		| loop for all words
1419  0cc0  6008                 	jra	8$		| done -- there is no odd byte
1420                             
1421  0cc2  3102                 6$:	movw	d2,-(a0)	| clear word
1422  0cc4  51c8 fffc            7$:	dbra	d0,6$		| loop for all words
1423  0cc8  1102                 	movb	d2,-(a0)	| clear odd byte at beginning
1424                             
1425  0cca  4cdf 7cfc            8$:	moveml	(sp)+,#/7cfc	| restore regs d2-d7,a2-a6
1426  0cce  4e75                 9$:	rts
1427                             
1428                             
1429                             |***
1430                             |***	HALTCPU	- stop cpu
1431                             |***				M002  And stop the z80 & hard drives
1432                             |***
1433                             	.globl	_haltcpu
1434                             _haltcpu:
1435  0cd0  46fc 2700            	movw	#NOINTR,sr	| lock out all interrupts
1436  0cd4  4eb9 0000 0000       	jbsr	_zhalt		| M002  Ask z80 to shutdown
1437  0cda  46fc 2700            1$:	movw	#NOINTR,sr	| M002  Added extra DI just-in-case...
1438  0cde  60fa                 	bras	1$		| M002  Stop. Now.
1439                             
1440                             
1441                             |***	BEGIN M000...
1442                             |***
1443                             |***	Z80INTR	- interrupt the z80
1444                             |***
1445                             	.globl	_z80intr
1446                             _z80intr:
1447  0ce0  33c0 0078 00d6       	movw	d0,Z80IADDR	| I/O latch interrupts z80 on access
1448  0ce6  4e75                 	rts
1449                             
1450                             |***	...END M000
1451                             
1452                             
1453                             |***
1454                             |***	FUBYTE,FUIBYTE,FUSHORT,FUISHORT,FUWORD,FUIWORD	- From User
1455                             |***	WORK IN PROGRESS
1456                             	.globl	_fubyte,_fuibyte,_fushort,_fuishor,_fuishort,_fuword,_fuiword
1457                             
1458                             _fubyte:			| fu(i)byte(user_addr)
1459                             _fuibyte:
1460  0ce8  206f 0004            	movl	4(sp),a0
1461  0cec  7001                 	moveq	#1,d0
1462  0cee  6100 00c6            	jbsr	umap
1463  0cf2  6504                 	jcs	1$
1464                             
1465  0cf4  7000                 	moveq	#0,d0
1466  0cf6  1010                 	movb	(a0),d0
1467  0cf8  4e75                 1$:	rts
1468                             	
1469                             _fushort:
1470                             _fuishor:			| fu(i)short(user_addr)
1471                             _fuishort:
1472  0cfa  206f 0004            	movl	4(sp),a0
1473  0cfe  7002                 	moveq	#2,d0
1474  0d00  6100 00b4            	jbsr	umap
1475  0d04  650e                 	jcs	2$
1476  0d06  2208                 	movl	a0,d1
1477                             
1478  0d08  7000                 	moveq	#0,d0			| cleared d0 used twice:
1479  0d0a  0101                 	btst	d0,d1			| test low order bit
1480  0d0c  6704                 	jeq	1$
1481  0d0e  70ff                 	moveq	#-1,d0
1482  0d10  6002                 	jra	2$
1483  0d12  3010                 1$:	movw	(a0),d0			| result zero-extended by earlier clr
1484  0d14  4e75                 2$:	rts
1485                             	
1486                             _fuword:			| fu(i)word(user_addr)
1487                             _fuiword:
1488  0d16  206f 0004            	movl	4(sp),a0
1489  0d1a  7004                 	moveq	#4,d0
1490  0d1c  6100 0098            	jbsr	umap
1491  0d20  650e                 	jcs	2$
1492  0d22  2208                 	movl	a0,d1
1493  0d24  0801 0000            	btst	#0,d1
1494  0d28  6704                 	jeq	1$
1495  0d2a  70ff                 	moveq	#-1,d0
1496  0d2c  6002                 	jra	2$
1497  0d2e  2010                 1$:	movl	(a0),d0
1498  0d30  4e75                 2$:	rts
1499                             
1500                             |***
1501                             |***	SUBYTE,SUIBYTE,SUSHORT,SUISHORT,SUWORD,SUIWORD	- Set User
1502                             |***
1503                             	.globl	_subyte,_suibyte,_sushort,_suishor,_suishort,_suword,_suiword
1504                             
1505                             _subyte:			| su(i)byte(user_addr,byte)
1506  0d32  206f 0004            	movl	4(sp),a0
1507  0d36  7001                 	moveq	#1,d0
1508  0d38  616e                 	jbsr	udmap
1509  0d3a  6008                 	jra	subytecom
1510                             _suibyte:
1511  0d3c  206f 0004            	movl	4(sp),a0
1512  0d40  7001                 	moveq	#1,d0
1513  0d42  6172                 	jbsr	umap
1514                             subytecom:
1515  0d44  654a                 	jcs	suret
1516  0d46  10af 000b            	movb	11(sp),(a0)
1517  0d4a  6042                 	jra	suok
1518                             
1519                             _sushort:			| su(i)short(user_addr,word)
1520  0d4c  206f 0004            	movl	4(sp),a0	| user_address
1521  0d50  7002                 	moveq	#2,d0
1522  0d52  6154                 	jbsr	udmap
1523  0d54  6008                 	jra	sushortcom
1524                             
1525                             _suishor:
1526                             _suishort:
1527  0d56  206f 0004            	movl	4(sp),a0	| user_address
1528  0d5a  7002                 	moveq	#2,d0
1529  0d5c  6158                 	jbsr	umap
1530                             sushortcom:
1531  0d5e  6530                 	jcs	suret
1532  0d60  2208                 	movl	a0,d1
1533  0d62  0801 0000            	btst	#0,d1
1534  0d66  662a                 	jne	suerr
1535  0d68  30af 000a            	movw	10(sp),(a0)
1536  0d6c  6020                 	jra	suok
1537                             
1538                             _suword:			| su(i)word(user_addr,long)
1539  0d6e  206f 0004            	movl	4(sp),a0	| user_address
1540  0d72  7004                 	moveq	#4,d0
1541  0d74  6132                 	jbsr	udmap
1542  0d76  6008                 	jra	suwordcom
1543                             _suiword:
1544  0d78  206f 0004            	movl	4(sp),a0	| user_address
1545  0d7c  7004                 	moveq	#4,d0
1546  0d7e  6136                 	jbsr	umap
1547                             suwordcom:
1548  0d80  650e                 	jcs	suret
1549  0d82  2208                 	movl	a0,d1
1550  0d84  0801 0000            	btst	#0,d1
1551  0d88  6608                 	jne	suerr
1552                             
1553  0d8a  20af 0008            	movl	8(sp),(a0)
1554                             suok:
1555  0d8e  7000                 	moveq	#0,d0
1556                             suret:
1557  0d90  4e75                 	rts
1558                             suerr:
1559  0d92  70ff                 	moveq	#-1,d0
1560  0d94  4e75                 	rts
1561                             
1562                             
1563                             |***
1564                             |***	UMAP -- check if address and nbytes given actually resides
1565                             |***		in current user's address space.  If so, return with user
1566                             |***		logical address replaced by physical address, and carry
1567                             |***		bit clear.
1568                             |***		If not, return with d0 = -1, and carry bit set.
1569                             |***	
1570                             |***	UDMAP -- like UMAP, but considers any access to text segment to
1571                             |***		an error.  Used by subyte, sushort, suword, copyout.
1572                             |***
1573                             |***	Arguments:	d0:	nbytes
1574                             |***			a0:	logical address
1575                             |***	Results:	Success:
1576                             |***				a0: physical address
1577                             |***				d0: nbytes (unchanged)
1578                             |***				carry bit clear
1579                             |***			Error:
1580                             |***				a0: undefined
1581                             |***				d0: -1
1582                             |***				carry bit set
1583                             |***
1584                             |***	Uses:		d1,a1
1585                             |***
1586                             |***	Note:		This routine returns with  -1 in d0 so that its
1587                             |***			callers need take no special action to indicate
1588                             |***			an error to their callers.
1589                             |***
1590                             
1591                             
1592                             |***	BEGIN M001...
1593                             
1594                             |***	caddr_t  umap(addr, count)
1595                             |***	  caddr_t	addr;
1596                             |***	  int		count;
1597                             |***
1598                             	.globl	_umap
1599                             _umap:
1600  0d96  206f 0004            	movl	4(sp),a0
1601  0d9a  202f 0008            	movl	8(sp),d0
1602  0d9e  6116                 	jbsr	umap
1603  0da0  6500 0004            	bcs	1$			| Skip the move if carry flag
1604  0da4  2008                 	movl	a0,d0			|   is set (error), -1 already in d0
1605  0da6  4e75                 1$:	rts
1606                             
1607                             |***	...END M001
1608                             
1609                             
1610  0da8  2208                 udmap:	movl	a0,d1			| address into d register for btst
1611  0daa  0801 0017            	btst	#23,d1			| is this a text reference?
1612  0dae  671c                 	jeq	umaplow			| no: use low segment
1613                             					| yes: fall thru to error return
1614                             
1615                             umaperr:
1616  0db0  70ff                 	moveq	#-1,d0			| error return, set up d0
1617  0db2  44c0                 	movw	d0,cc			| indicate error
1618  0db4  4e75                 	rts
1619                             
1620                             umap:
1621  0db6  2208                 	movl	a0,d1			| address into d register for btst
1622  0db8  0801 0017            	btst	#23,d1			| is this a text reference?
1623  0dbc  670e                 	jeq	umaplow			| no: use low segment
1624                             
1625  0dbe  227c 0000 0e76       	movl	#mmuhi,a1		| yes: ptr to hi seg registers in a1
1626  0dc4  0881 0017            	bclr	#23,d1			|	clear hi seg bit
1627  0dc8  2041                 	movl	d1,a0			|	replace given address
1628  0dca  6006                 	jra	umapcom			|	and continue with work
1629                             umaplow:
1630  0dcc  227c 0000 0e7a       	movl	#mmulo,a1		| ptr to lo seg registers in a1
1631                             
1632                             umapcom:
1633  0dd2  4a80                 	tstl	d0			| test bytecount
1634  0dd4  6734                 	jeq	umapok			| bytecount of 0, indicate OK
1635  0dd6  6dd8                 	jlt	umaperr			| negative bytecount--error
1636  0dd8  e081                 	asrl	#SHIFT1,d1		| convert to page
1637  0dda  e881                 	asrl	#SHIFT2,d1		|	number
1638  0ddc  d269 0002            	addw	2(a1),d1		| add offset register
1639  0de0  0801 000b            	btst	#11,d1			| Did add overflow 11 bit MMU range?
1640  0de4  66ca                 	jne	umaperr			| if carry produced, then error
1641                             
1642  0de6  b251                 	cmpw	(a1),d1			| compare with limit register
1643  0de8  62c6                 	jhi	umaperr			| if (pageno > limit reg) then error
1644                             
1645  0dea  0c80 0000 1000       	cmpl	#PAGESIZE,d0		| if bytecount is <= 1 page
1646  0df0  6f18                 	jle	umapok			|	then done with verification
1647                             
1648  0df2  2208                 	movl	a0,d1			| starting address
1649  0df4  d280                 	addl	d0,d1			| + bytecount
1650  0df6  5381                 	subql	#1,d1			| - 1
1651  0df8  e081                 	asrl	#SHIFT1,d1		| convert to page
1652  0dfa  e881                 	asrl	#SHIFT2,d1		|	number
1653  0dfc  d269 0002            	addw	2(a1),d1		| add offset register
1654  0e00  0801 000b            	btst	#11,d1			| Did add overflow 11 bit MMU range?
1655  0e04  66aa                 	jne	umaperr			| if carry produced, then error
1656                             
1657  0e06  b251                 	cmpw	(a1),d1			| compare with limit register
1658  0e08  62a6                 	jhi	umaperr			| if (pageno > limit reg) then error
1659                             
1660                             umapok:
1661  0e0a  3229 0002            	movw	2(a1),d1		| no error: take page offset
1662  0e0e  e181                 	asll	#SHIFT1,d1		| convert to
1663  0e10  e981                 	asll	#SHIFT2,d1		|	bytecount
1664  0e12  d1c1                 	addl	d1,a0			| and add to get physical addr
1665  0e14  44fc 0000            	movw	#0,cc			| clear condition codes for return
1666  0e18  4e75                 	rts
1667                             
1668                             
1669                             |***
1670                             |***	COPYIN/OUT	in and out of system space (from/to user space)
1671                             |***
1672                             |***		The current implementations is somewhat of a hack
1673                             |***		and depends on the arguments to copybuf corresponding
1674                             |***		to those to these routines.  We verify that the requested
1675                             |***		transfer involves entirely valid user address, replace
1676                             |***		the user address argument with a physical address, and
1677                             |***		use copybuf to do the actual copying.
1678                             |***
1679                             |***		The current implementation works for any combination
1680                             |***		of odd and even args.
1681                             |***
1682                             |***		The code here depends upon copybuf returning 0.
1683                             |***
1684                             	.globl	_copyin,_copyiin,_copyout,_copyiout,_copyiou
1685                             |***	copyin(user_address, kernel_address, nbytes)
1686                             |***	copyiin(user_address, kernel_address, nbytes)
1687                             |***	copyout(kernel_address, user_address, nbytes)
1688                             |***	copyiout(kernel_address, user_address, nbytes)
1689                             _copyin:
1690                             _copyiin:
1691  0e1a  206f 0004            	movl	4(sp),a0		| user-address
1692  0e1e  202f 000c            	movl	12(sp),d0		| byte-count
1693  0e22  6192                 	jbsr	umap			| map and verify user address
1694  0e24  6508                 	jcs	cperr			| error: return
1695  0e26  2f48 0004            	movl	a0,4(sp)		| replace logical addr w/physical
1696  0e2a  6000 fd22            	jra	_copybuf		| use copybuf to do the copy!
1697                             
1698  0e2e  4e75                 cperr:	rts
1699                             
1700                             _copyout:
1701  0e30  206f 0008            	movl	8(sp),a0		| user-address
1702  0e34  202f 000c            	movl	12(sp),d0		| byte-count
1703  0e38  6100 ff6e            	jbsr	udmap			| map and verify user address
1704  0e3c  600c                 	jra	cpyoutcom		| common copy(i)out code
1705                             
1706                             _copyiout:
1707                             _copyiou:
1708  0e3e  206f 0008            	movl	8(sp),a0		| user-address
1709  0e42  202f 000c            	movl	12(sp),d0		| byte-count
1710  0e46  6100 ff6e            	jbsr	umap			| map and verify user address
1711                             cpyoutcom:
1712  0e4a  65e2                 	jcs	cperr			| error: return
1713  0e4c  2f48 0008            	movl	a0,8(sp)		| replace logical addr w/physical
1714  0e50  6000 fcfc            	jra	_copybuf		| use copybuf to do the copy!
1715                             
1716                             
