/*
 *	%Z% %M% %I% %D% %Q%
 */

/*
 * THIS FILE CONTAINS CODE SPECIFIC TO THE Tandy TRS-80 MODEL 16
 * COMPUTER. IT MAY REQUIRE MODIFICATION WHEN MOVING
 * XENIX TO DIFFERENT MACHINE ARCHITECTURES OR CONFIGURATIONS.
 *
 *
 * $Header: copy.c,v 6.0 87/10/12 17:07:10 iv Exp $
 *
 * $Log:	copy.c,v $
 * Revision 6.0  87/10/12  17:07:10  iv
 * 	- Checkin to lock down 3.2
 * 
 * Revision 5.1  87/05/06  13:58:18  iv
 * 	- Rewrote copyio() for better optimization
 * 
 * Revision 5.0  85/12/03  17:08:41  iv
 * 	- Checkin to lock down XENIX 3.1 release
 * 
 * Revision 4.0  85/03/13  14:44:52  iv
 * 	- Checkin to lock down XENIX 3.0(28) release
 * 
 * Revision 3.0  85/01/17  15:46:05  iv
 * 	- Checkin to save XENIX v3.0(23)
 * 
 * Revision 2.0  85/01/10  13:49:51  iv
 * Checkin to save XENIX 3.0(22)
 * 
 * Revision 1.1  84/04/10  17:34:48  iv
 * -	Removed routine  "clear" -  will add a label to "_copybuf" in mch.s
 */


#include "../h/param.h"
#include "../h/dir.h"           /* for user.h */
#include "../h/user.h"          /* mapping description */
#include "../h/buf.h"

/* copy to/from a buffer to another address space. */

int	copyout(), copyin(), copyiout(), copyiin(), bcopy();

int copyio(addr1,addr2,size,mapping)
    caddr_t addr1;
    caddr_t addr2;
    int size;
    int mapping;
{
	register caddr_t  a1, a2;
	register int	  (*copy)();

#ifdef DEBUG
	printf("copyio: a1=%X a2=%x sz=%d map=%d\n",addr1,addr2,size,mapping);
#endif
	switch (mapping) {
	    case U_RUD:
		copy = copyout;
		a1 = addr1;
		a2 = addr2;
		break;

	    case U_WUD:
		copy = copyin;
		a1 = addr2;
		a2 = addr1;
		break;

	    case U_RUI:
		copy = copyiout;
		a1 = addr1;
		a2 = addr2;
		break;

	    case U_WUI:
		copy = copyiin;
		a1 = addr2;
		a2 = addr1;
		break;

	    case U_RKD:
		copy = bcopy;
		a1 = addr1;
		a2 = addr2;
		break;

	    case U_WKD:
		copy = bcopy;
		a1 = addr2;
		a2 = addr1;
		break;

	/*  default:
		return (0); */
	}

	return ((*copy)(a1, a2, size));
}
