/*
 *	@(#) sys/prim.c 1.1 83/10/23 Copyright Microsoft Corporation, 1983
 *
 *  $Header: prim.c,v 6.0 87/10/12 17:09:42 iv Exp $
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS DESIGNED TO BE
 * PORTABLE BETWEEN DIFFERENT MACHINE ARCHITECHTURES
 * AND CONFIGURATIONS. IT SHOULD NOT REQUIRE ANY
 * MODIFICATIONS WHEN ADAPTING XENIX TO NEW HARDWARE.
 *
 *  MODIFICATION HISTORY
 *	27 March 1984	blf	M000
 *		- Added missing splx() to putcb().
 *
 * $Log:	prim.c,v $
 * Revision 6.0  87/10/12  17:09:42  iv
 * 	- Checkin to lock down 3.2
 * 
 * Revision 5.0  85/08/23  10:35:56  iv
 * 	- Checkin to lock down XENIX 3.1 release
 * 
 * Revision 4.0  85/03/13  14:48:41  iv
 * 	- Checkin to lock down XENIX 3.0(28) release
 * 
 * Revision 3.0  85/01/17  15:44:08  iv
 * 	- Checkin to save XENIX v3.0(23)
 * 
 * Revision 2.0  85/01/10  13:23:01  iv
 * Checkin to save XENIX 3.0(22)
 * 
 * Revision 0.1  84/05/17  15:18:04  iv
 * 	- Missing splx() added to putcb()
 * 
 */


#include "../h/param.h"
#include "../h/tty.h"

/* Routines to manipulate clists--translated from sys3 clist.s */

/* get a character from a clist */
int getc(cp)
    register struct clist *cp;
{
    register struct cblock *cbp;
    int c,s;
	s=spl6();
	if(cp->c_cc-- > 0){    /* any characters left? */
	    cbp=cp->c_cf;
	    c=cbp->c_data[cbp->c_first]&0377;
	    if(++cbp->c_first == cbp->c_last){  /* got last char in cblock */
		if((cp->c_cf=cbp->c_next)==NULL)
		    cp->c_cl=NULL;  /* last cblock too */
		cbp->c_next = cfreelist.c_next;
		cfreelist.c_next = cbp;
	    }
	} else {                /* were none */
	    cp->c_cc++;         /* restore count */
	    c = -1;
	}
	splx(s);
	return(c);
}


/* put a character on a clist */
int putc(c,cp)
    int c;
    register struct clist *cp;
{
    register struct cblock *cbp;
    int s;
	s=spl6();
	/* if no cblocks on list or no space in last one, must get new one */
	if((cbp=cp->c_cl)==NULL || cfreelist.c_size <= cbp->c_last){
	    if((cbp=cfreelist.c_next)==NULL){
		splx(s);
		return(-1);
	    }
	    cfreelist.c_next = cbp->c_next;
	    cbp->c_next = NULL;
	    cbp->c_first = cbp->c_last = 0;
	    if(cp->c_cl==NULL) cp->c_cf=cbp;
	    else cp->c_cl->c_next = cbp;
	    cp->c_cl = cbp;
	}
	cp->c_cc++;
	cbp->c_data[cbp->c_last++] = c;
	splx(s);
	return(0);
}


/* get a cblock from cfreelist */
struct cblock *getcf()
{
    register struct cblock *cbp;
    int s;
	s=spl6();
	if((cbp=cfreelist.c_next)!=NULL){
	    cfreelist.c_next = cbp->c_next;
	    cbp->c_next = NULL;
	    cbp->c_last = cfreelist.c_size;
	    cbp->c_first = 0;
	}
	splx(s);
	return(cbp);
}

/* put a cblock onto cfreelist */
putcf(cbp)
    register struct cblock *cbp;
{
    int s;
	s=spl6();
	cbp->c_next = cfreelist.c_next;
	cfreelist.c_next = cbp;
	splx(s);
}


/* get a cblock from a clist */
struct cblock *getcb(cp)
    register struct clist *cp;
{
    register struct cblock *cbp;
    int s;
	s=spl6();
	if((cbp=cp->c_cf)!=NULL){
	    cp->c_cc -= cbp->c_last - cbp->c_first;
	    if((cp->c_cf=cp->c_cf->c_next)==NULL) cp->c_cl=NULL;
	}
	splx(s);
	return(cbp);
}

/* put a cblock onto a clist */
int putcb(cbp,cp)
    register struct cblock *cbp;
    register struct clist *cp;
{
    int s;
	s=spl6();
	if(cp->c_cl==NULL)
	    cp->c_cf = cbp;
	else
	    cp->c_cl->c_next = cbp;
	cp->c_cl = cbp;
	cbp->c_next = NULL;
	cp->c_cc += cbp->c_last - cbp->c_first;
	splx(s);					/* M000 */
	return(0);
}
