/*
 *	@(#) sys/utssys.c 1.1 83/10/23 Copyright Microsoft Corporation, 1983
 *
 *  $Header: utssys.c,v 6.0 87/10/12 17:10:41 iv Exp $
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS DESIGNED TO BE
 * PORTABLE BETWEEN DIFFERENT MACHINE ARCHITECHTURES
 * AND CONFIGURATIONS. IT SHOULD NOT REQUIRE ANY
 * MODIFICATIONS WHEN ADAPTING XENIX TO NEW HARDWARE.
 *
 * $Log:	utssys.c,v $
 * Revision 6.0  87/10/12  17:10:41  iv
 * 	- Checkin to lock down 3.2
 * 
 * Revision 5.0  85/08/23  10:39:20  iv
 * 	- Checkin to lock down XENIX 3.1 release
 * 
 * Revision 4.0  85/03/13  14:51:20  iv
 * 	- Checkin to lock down XENIX 3.0(28) release
 * 
 * Revision 3.0  85/01/17  15:45:35  iv
 * 	- Checkin to save XENIX v3.0(23)
 * 
 * Revision 2.0  85/01/10  13:24:21  iv
 * Checkin to save XENIX 3.0(22)
 * 
 * Revision 0.1  84/05/17  16:00:38  iv
 * 	- No code changes.  Added RCS stuff.
 * 
 */


#include "../h/param.h"
#include "../h/buf.h"
#include "../h/filsys.h"
#include "../h/mount.h"
#include "../h/dir.h"
#include "../h/user.h"
#include "../h/var.h"
#include "../h/utsname.h"

extern struct utsname utsname;


utssys()
{
	register i;
	union a {
		unsigned int arg[5];
		struct {
		    int     mv;
		    char    *cbuf;
		} a_us;
		struct {
		    char    *name;
		} a_un;
	} *uap;

	uap = (union a *)u.u_ap;
	switch((uap->arg[4]>>8) & 0xFF) {

case 0:		/* uname */
	if (copyout(&utsname, uap->a_un.name, sizeof(struct utsname)))
		u.u_error = EFAULT;
	return;

/* case 1 was umask */

case 2:		/* ustat */
	for(i=0; i<v.v_mount; i++) {
		register struct mount *mp;

		mp = &mount[i];
		if(mp->m_flags == MINUSE && mp->m_dev==uap->a_us.mv) {
			register struct filsys *fp;

			fp = (struct filsys *)paddr(mp->m_bufp);
			if (copyout(&fp->s_tfree, uap->a_us.cbuf,
			      sizeof(daddr_t) + sizeof(ino_t)) ||
			    copyout(&fp->s_fname[0],
			      &uap->a_us.cbuf[sizeof(daddr_t)+sizeof(ino_t)],
			      12*sizeof(char))) {
				u.u_error = EFAULT;
			}
			return;
		}
	}
	u.u_error = EINVAL;
	return;

default:
	u.u_error = EFAULT;
	}
}
